Package: destiny
Type: Package
Title: Creates diffusion maps
Version: 3.26.0
Date: 2014-12-19
Authors@R: c(
	person('Philipp', 'Angerer', NULL, 'phil.angerer@gmail.com', c('cre', 'aut'), comment = c(ORCID = '0000-0002-0369-2888')),
	person('Laleh', 'Haghverdi', NULL, 'laleh.haghverdi@helmholtz-muenchen.de', 'ctb'),
	person('Maren', 'Büttner', NULL, 'maren.buettner@helmholtz-muenchen.de', 'ctb', comment = c(ORCID = '0000-0002-6189-3792')),
	person('Fabian', 'Theis', NULL, 'fabian.theis@helmholtz-muenchen.de', 'ctb', comment = c(ORCID = '0000-0002-2419-1943')),
	person('Carsten', 'Marr', NULL, 'carsten.marr@helmholtz-muenchen.de', 'ctb', comment = c(ORCID = '0000-0003-2154-4552')),
	person('Florian', 'Büttner', NULL, 'f.buettner@helmholtz-muenchen.de', 'ctb', comment = c(ORCID = '0000-0001-5587-6761')))
Description: Create and plot diffusion maps.
License: GPL-3
URL: https://github.com/theislab/destiny/,
        https://bioconductor.org/packages/destiny,
        https://doi.org/10.1093/bioinformatics/btv715
BugReports: https://github.com/theislab/destiny/issues
Encoding: UTF-8
Depends: R (>= 3.4.0)
Imports: methods, graphics, grDevices, grid, utils, stats, Matrix, Rcpp
        (>= 0.10.3), RcppEigen, RSpectra (>= 0.14-0), irlba,
        pcaMethods, Biobase, BiocGenerics, SummarizedExperiment,
        SingleCellExperiment, ggplot2, ggplot.multistats, rlang, tidyr,
        tidyselect, ggthemes, VIM, knn.covertree, proxy, RcppHNSW,
        scales, scatterplot3d
LinkingTo: Rcpp, RcppEigen, grDevices
SystemRequirements: C++11
NeedsCompilation: yes
Enhances: rgl, SingleCellExperiment
Suggests: knitr, rmarkdown, igraph, testthat, FNN, tidyverse,
        gridExtra, cowplot, conflicted, viridis, rgl, scRNAseq,
        org.Mm.eg.db, scran, repr
VignetteBuilder: knitr
biocViews: CellBiology, CellBasedAssays, Clustering, Software,
        Visualization
Collate: 'RcppExports.R' 'aaa.r' 'accessor-generics.r' 'censoring.r'
        'colorlegend.r' 'cube_helix.r' 'dataset-helpers.r'
        'destiny-package.r' 's4-unions.r' 'dist-matrix-coerce.r'
        'sigmas.r' 'diffusionmap.r' 'diffusionmap-methods-accession.r'
        'diffusionmap-methods.r' 'plothelpers.r'
        'diffusionmap-plotting.r' 'dpt-branching.r' 'dpt-helpers.r'
        'dpt.r' 'dpt-methods-matrix.r' 'dpt-methods.r' 'utils.r'
        'dpt-plotting.r' 'eig_decomp.r' 'expressionset-helpers.r'
        'find_dm_k.r' 'gene-relevance.r' 'gene-relevance-methods.r'
        'gene-relevance-plotting-differential-map.r'
        'gene-relevance-plotting-gr-map.r'
        'gene-relevance-plotting-rank.r' 'gene-relevance-plotting.r'
        'guo-data.r' 'knn.r' 'l_which.r' 'methods-coercion.r'
        'methods-extraction.r' 'methods-update.r' 'predict.r'
        'projection-dist.r' 'rankcor.r' 'sigmas-plotting.r'
        'smth-gaussian.r'
RoxygenNote: 7.3.3
git_url: https://git.bioconductor.org/packages/destiny
git_branch: RELEASE_3_23
git_last_commit: 60f95ca
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
Packaged: 2026-04-28 21:49:38 UTC; biocbuild
Author: Philipp Angerer [cre, aut] (ORCID:
    <https://orcid.org/0000-0002-0369-2888>),
  Laleh Haghverdi [ctb],
  Maren Büttner [ctb] (ORCID: <https://orcid.org/0000-0002-6189-3792>),
  Fabian Theis [ctb] (ORCID: <https://orcid.org/0000-0002-2419-1943>),
  Carsten Marr [ctb] (ORCID: <https://orcid.org/0000-0003-2154-4552>),
  Florian Büttner [ctb] (ORCID: <https://orcid.org/0000-0001-5587-6761>)
Maintainer: Philipp Angerer <phil.angerer@gmail.com>

#' Logical which
#'
#' Inverse of \link[base]{which}. Converts an array of numeric or character indices to a logical index array.
#' This function is useful if you need to perform logical operation on an index array but are only given numeric indices.
#'
#' Either \code{nms} or \code{len} has to be specified.
#'
#' @param idx       Numeric or character indices.
#' @param nms       Array of names or a sequence. Required if \code{idx} is a character array
#' @param len       Length of output array. Alternative to \code{nms} if \code{idx} is numeric
#' @param useNames  Use the names of nms or idx
#'
#' @return Logical vector of length \code{len} or the same length as \code{nms}
#'
#' @examples
#' all(l_which(2, len = 3L) == c(FALSE, TRUE, FALSE))
#' all(l_which(c('a', 'c'), letters[1:3]) == c(TRUE, FALSE, TRUE))
#'
#' @export
l_which <- function(idx, nms = seq_len(len), len = length(nms), useNames = TRUE) { # nolint: object_name_linter.
	rv <- logical(len)
	if (is.character(nms)) # we need names here so that rv[idx] works
		names(rv) <- nms

	if (useNames && !is.null(names(idx)))
		names(rv)[idx] <- names(idx)

	rv[idx] <- TRUE

	if (!useNames) # if we don't want names, we'll remove them if we added them before
		names(rv) <- NULL
	rv
}

#' Find a suitable k
#'
#' The \code{k} parameter for the k nearest neighbors used in \link{DiffusionMap} should be as big as possible while
#' still being computationally feasible. This function approximates it depending on the size of the dataset \code{n}.
#'
#' @param n      Number of possible neighbors (nrow(dataset) - 1)
#' @param min_k  Minimum number of neighbors. Will be chosen for \eqn{n \ge big}
#' @param small  Number of neighbors considered small. If/where \eqn{n \le small}, n itself will be returned.
#' @param big    Number of neighbors considered big. If/where \eqn{n \ge big}, \code{min_k} will be returned.
#'
#' @return A vector of the same length as \code{n} that contains suitable \code{k} values for the respective \code{n}
#'
#' @examples
#' curve(find_dm_k(n),     0, 13000, xname = 'n')
#' curve(find_dm_k(n) / n, 0, 13000, xname = 'n')
#' @export
find_dm_k <- function(n, min_k = 100L, small = 1000L, big = 10000L) {
	stopifnot(small < big)
	if (is.null(n)) return(NULL)

	k <- rep(NA_integer_, length(n))
	k[small >= n] <- n[small >= n]
	k[n >= big]   <- min_k

	rest <- !is.na(n) & small < n & n < big

	n_shifted <- (n[rest] - small) / (big - small)     # linear transf [small, big] -> [0, 1]
	k_shifted <- (cos(n_shifted * pi) + 1) / 2         # ease function [0, 1] -> [1, 0]
	k_rest    <- min_k + k_shifted * (n[rest] - min_k) # linear transf [0, 1] -> [min_k, n]

	k[rest] <- as.integer(round(k_rest))

	k
}

#' @include utils.r
NULL

#' Update old destiny objects to a newer version.
#'
#' Handles \link{DiffusionMap}, \link{Sigmas}, and \link[=gene_relevance]{GeneRelevance}.
#'
#' @param object  An object created with an older destiny release
#' @param ...     ignored
#' @param verbose tells what is being updated
#'
#' @return A \link{DiffusionMap} or \link{Sigmas} object that is valid when used with the current destiny release
#'
#' @aliases updateObject.DiffusionMap updateObject.Sigmas updateObject.GeneRelevance
#' @name updateObject methods
#' @rdname updateObject-methods
NULL

#' @importFrom methods setMethod validObject .hasSlot slot slot<-
#' @importFrom Matrix Matrix
#' @importFrom BiocGenerics updateObject
#' @rdname updateObject-methods
#' @export
setMethod('updateObject', 'DiffusionMap', function(object, ..., verbose = FALSE) {
	if (verbose)
		message("updateObject(object = 'DiffusionMap')")

	if (!hasattr(object, 'distance'))
		slot(object, 'distance', check = FALSE) <- 'euclidean'

	if (!hasattr(object, 'transitions'))
		slot(object, 'transitions', check = FALSE) <- NULL

	if (!hasattr(object, 'd.norm'))  # upgrade only nonexistence, name later
		slot(object, 'd.norm', check = FALSE) <- rep(NA_real_, length(object@d))

	if (!hasattr(object, 'n_pcs'))
		slot(object, 'n_pcs', check = FALSE) <- NA_integer_

	if (!hasattr(object, 'n_local'))
		slot(object, 'n_local', check = FALSE) <- 5L

	if (!hasattr(object, 'rotate'))
		slot(object, 'rotate', check = FALSE) <- TRUE  # old ones were rotated by default

	if (!hasattr(object, 'knn_params'))
		slot(object, 'knn_params', check = FALSE) <- list()

	object <- update_slot_names(object, c('data.env', 'd.norm', 'density.norm', 'censor.val', 'censor.range', 'missing.range'))

	slot(object, 'sigmas', check = FALSE) <- updateObject(object@sigmas)

	validObject(object)
	object
})


#' @rdname updateObject-methods
#' @export
setMethod('updateObject', 'Sigmas', function(object, ..., verbose = FALSE) {
	if (verbose)
		message("updateObject(object = 'Sigmas')")

	object <- update_slot_names(object, c('log.sigmas', 'dim.norms', 'optimal.sigma', 'optimal.idx', 'avrd.norms'))

	object
})


#' @rdname updateObject-methods
#' @export
setMethod('updateObject', 'GeneRelevance', function(object, ..., verbose = FALSE) {
	if (verbose)
		message("updateObject(object = 'GeneRelevance')")

	if (!hasattr(object, 'distance'))
		slot(object, 'distance', check = FALSE) <- 'euclidean'

	# the dimensions were switched to fit the convention elsewhere in the package.
	if (!hasattr(object, 'smooth_window')) {
		object@partials <- aperm(object@partials, c(2, 1, 3))
		object@partials_norm <- t(object@partials_norm)
		slot(object, 'smooth_window', check = FALSE) <- NA_real_
		slot(object, 'smooth_alpha', check = FALSE) <- NA_real_
	}

	object
})


#' @importFrom stats na.omit
update_slot_names <- function(object, old_slots, new_slots = sub('.', '_', old_slots, fixed = TRUE)) {
	atts <- attributes(object)
	update_idx <- old_slots %in% names(atts)
	if (!length(update_idx)) return(object)

	slot_idx <- na.omit(match(old_slots[update_idx], names(atts)))

	names(atts)[slot_idx] <- new_slots[update_idx]
	attributes(object) <- atts

	object
}

#' @include diffusionmap.r dpt.r
NULL

#' Coercion methods
#'
#' Convert a \code{\link{DiffusionMap}} or \code{\link{DPT}} object to other classes
#'
#' \link[ggplot2]{fortify} is a ggplot2 generic allowing a diffusion map to be used as \code{data} parameter in \link[ggplot2]{ggplot} or \link[ggplot2]{qplot}.
#'
#' @param x,model  A \code{\link{DiffusionMap}} or \code{\link{DPT}} object
#' @param row.names  NULL or a character vector giving the row names for the data frame. Missing values are not allowed.
#' @param optional  logical. If TRUE, setting row names and converting column names (to syntactic names: see make.names) is optional.

#' @param ...  Passed to \code{\link[base]{as.data.frame}}
#' @param data  ignored
#'
#' @return An object of the desired class
#'
#' @seealso \link{DiffusionMap accession methods}, \link{Extraction methods}, \link{DiffusionMap methods} for more
#'
#' @examples
#' library(Biobase)
#' data(guo)
#' dm <- DiffusionMap(guo)
#' classes <- vapply(as.data.frame(dm), class, character(1L))
#' stopifnot(all(classes[paste0('DC', 1:20)] == 'numeric'))
#' stopifnot(all(classes[featureNames(guo) ] == 'numeric'))
#' stopifnot(all(classes[   varLabels(guo) ] == c('factor', 'integer')))
#'
#' @aliases
#' as.data.frame.DiffusionMap fortify.DiffusionMap
#' as.data.frame.DPT          fortify.DPT
#'     as.matrix.DPT
#'
#' @importFrom methods setAs
#' @importFrom BiocGenerics as.data.frame
#' @name Coercion methods
#' @rdname coercions
#' @include diffusionmap.r
NULL


#' @importFrom Biobase pData
#' @rdname coercions
#' @export
setMethod('as.data.frame', 'DiffusionMap', function(x, row.names = NULL, optional = FALSE, ...) { # nolint: object_name_linter.
	df_evec <- as.data.frame(eigenvectors(x), row.names, optional, ...)
	df_data <- dataset_to_df(dataset(x), row.names, optional, ...)

	if (is.null(df_data))
		df_evec
	else
		cbind(df_evec, df_data)
})


#' @usage fortify.DiffusionMap(model, data, ...)
#'
#' @importFrom BiocGenerics as.data.frame
#' @importFrom Biobase as.data.frame.ExpressionSet
#' @importFrom ggplot2 fortify
#' @rdname coercions
#' @exportS3Method fortify DiffusionMap
#' @export fortify.DiffusionMap
fortify.DiffusionMap <- function(model, data, ...) as.data.frame(model, ...)
setAs('DiffusionMap', 'data.frame', function(from) as.data.frame(from))


#' @rdname coercions
#' @export
setMethod('as.data.frame', 'DPT', function(x, row.names = NULL, optional = FALSE, ...) { # nolint: object_name_linter.
	dpt <- as.matrix(x)
	colnames(dpt) <- paste0('DPT', seq_len(ncol(dpt)))
	cbind(
		as.data.frame(cbind(dpt, x@branch, x@tips), row.names = row.names, optional = optional, ...),
		as.data.frame(x@dm,                         row.names = row.names, optional = optional, ...))
})


#' @usage fortify.DPT(model, data, ...)
#'
#' @importFrom BiocGenerics as.data.frame
#' @importFrom Biobase as.data.frame.ExpressionSet
#' @importFrom ggplot2 fortify
#' @rdname coercions
#' @exportS3Method fortify DPT
#' @export fortify.DPT
fortify.DPT <- function(model, data, ...) as.data.frame(model, ...)
setAs('DPT', 'data.frame', function(from) as.data.frame(from))


#' @rdname coercions
#' @export
setMethod('as.matrix', 'DPT', function(x, ...) x[])

#'@importFrom methods setOldClass
setOldClass('dist')

#' @importFrom Matrix sparseMatrix
as.Matrix.dist <- function(from) { # nolint: object_name_linter.
	s <- attr(from, 'Size')
	i <- rep.int(seq_len(s - 1L), rev(seq_len(s - 1L)))
	j <- rev(abs(sequence(seq.int(s - 1L)) - s) + 1L)
	sparseMatrix(i, j, x = unclass(from), dims = c(s, s), symmetric = TRUE)
}

#'@importFrom methods setAs
setAs('dist', 'Matrix',          as.Matrix.dist)
setAs('dist', 'sparseMatrix',    as.Matrix.dist)
setAs('dist', 'CsparseMatrix',   as.Matrix.dist)
setAs('dist', 'dsCMatrix',       as.Matrix.dist)
setAs('dist', 'symmetricMatrix', as.Matrix.dist)

#' destiny generics
#'
#' destiny provides several generic methods and implements them for the \code{\link{DiffusionMap}} and \code{\link{Sigmas}} classes.
#'
#' @param object  Object from which to extract or to which to assign a value
#' @param value   Value to assign within an object
#'
#' @examples
#' data(guo_norm)
#' dm <- DiffusionMap(guo_norm)
#' eigenvalues(dm)
#' eigenvectors(dm)
#' sigmas(dm)
#' optimal_sigma(dm)
#' dataset(dm)
#' distance(dm)
#'
#' @seealso \link{DiffusionMap methods} and \link{Sigmas} class for implementations
#'
#' @importFrom methods setGeneric
#' @name destiny generics
#' @rdname destiny-generics
NULL


#' @return \code{eigenvalues} retrieves the numeric eigenvalues
#' @rdname destiny-generics
#' @export
setGeneric('eigenvalues', function(object) standardGeneric('eigenvalues'), valueClass = 'numeric')

#' @rdname destiny-generics
#' @export
setGeneric('eigenvalues<-', function(object, value) standardGeneric('eigenvalues<-'))


#' @return \code{eigenvectors} retrieves the eigenvectors matrix
#' @rdname destiny-generics
#' @export
setGeneric('eigenvectors', function(object) standardGeneric('eigenvectors'), valueClass = 'matrix')

#' @rdname destiny-generics
#' @export
setGeneric('eigenvectors<-', function(object, value) standardGeneric('eigenvectors<-'))


#' @return \code{sigmas} retrieves the \code{\link{Sigmas}} from an object utilizing it as kernel width
#' @rdname destiny-generics
#' @export
setGeneric('sigmas', function(object) standardGeneric('sigmas'), valueClass = 'Sigmas')

#' @rdname destiny-generics
#' @export
setGeneric('sigmas<-', function(object, value) standardGeneric('sigmas<-'))


#' @return \code{dataset} retrieves the data the object was created from
#' @rdname destiny-generics
#' @export
setGeneric('dataset', function(object) standardGeneric('dataset'))

#' @rdname destiny-generics
#' @export
setGeneric('dataset<-', function(object, value) standardGeneric('dataset<-'))


#' @return \code{distance} retrieves the distance metric used to create the object, e.g. \code{euclidean}
#' @rdname destiny-generics
#' @export
setGeneric('distance', function(object) standardGeneric('distance'), valueClass = 'character')

#' @rdname destiny-generics
#' @export
setGeneric('distance<-', function(object, value) standardGeneric('distance<-'))


#' @return \code{optimal_sigma} retrieves the numeric value of the optimal sigma or local sigmas
#' @rdname destiny-generics
#' @export
setGeneric('optimal_sigma', function(object) standardGeneric('optimal_sigma'))

#' Guo at al. mouse embryonic stem cell qPCR data
#'
#' Gene expression data of 48 genes and an annotation column \code{$num_cells} containing the cell stage at which the embryos were harvested.
#'
#' The data is normalized using the mean of two housekeeping genes.
#' The difference between \code{guo} and \code{guo_norm} is the LoD being set to 10 in the former, making it usable with the \code{censor_val} parameter of \link{DiffusionMap}.
#'
#' @return an \link[Biobase:class.ExpressionSet]{ExpressionSet} with 48 features and 428 observations containing qPCR Ct values and a "num.cells" observation annotation.
#'
#' @aliases data:guo data:guo_norm guo guo_norm
#' @name guo
#' @docType data
#' @author Guoji Guo, Mikael Huss, Guo Qing Tong, Chaoyang Wang, Li Li Sun, Neil D. Clarke, Paul Robson \email{robsonp@@gis.a-star.edu.sg}
#' @references \url{http://www.sciencedirect.com/science/article/pii/S1534580710001103}
#' @keywords data
#' @usage
#' data(guo)
#' data(guo_norm)
#' @format An \link[Biobase:class.ExpressionSet]{ExpressionSet} with 48 features, 428 observations and 2 \link[Biobase]{phenoData} annotations.
NULL

#' Create and plot diffusion maps
#'
#' The main function is \code{\link{DiffusionMap}}, which returns an object you can \code{\link{plot}} (\code{\link{plot.DiffusionMap}} is then called).
#'
#' @examples
#' demo(destiny, ask = FALSE)
#'
#' @name destiny
#'
## Make sure Rcpp and RcppEigen are loaded
#' @importFrom Rcpp evalCpp
#' @importFrom RcppEigen RcppEigen.package.skeleton
'_PACKAGE'

#' Sequential color palette using the cube helix system
#'
#' Creates a perceptually monotonously decreasing (or increasing) lightness color palette with different tones.
#' This was necessary in pre-viridis times, by now you can probably just use \code{\link[grDevices]{hcl.colors}}
#'
#' @param n        Number of colors to return (default: 6)
#' @param start    Hue to start helix at (\eqn{\textrm{start} \in [0,3]}, default: 0)
#' @param r        Number of rotations of the helix. Can be negative. (default: 0.4)
#' @param hue      Saturation. 0 means greyscale, 1 fully saturated colors (default: 0.8)
#' @param gamma    Emphasize darker (gamma < 1) or lighter (gamma > 1) colors (default: 1)
#' @param light    Lightest lightness (default: 0.85)
#' @param dark     Darkest lightness (default: 0.15)
#' @param reverse  logical. If TRUE, reverse lightness (default: FALSE)
#' @param discrete If TRUE, return a discrete scale, if FALSE a continuous one (default: TRUE)
#' @param guide    Type of scale guide to use. See \code{\link[ggplot2]{guides}}
#' @param ...      parameters passed to \code{\link[ggplot2]{discrete_scale}} or \code{\link[ggplot2]{continuous_scale}}
#'
#' @return A \code{character} vector of hex colors with length \code{n}
#'
#' @examples
#' palette(cube_helix())
#' image(matrix(1:6), col = 1:6, pch = 19, axes = FALSE)
#'
#' cr <- scales::colour_ramp(cube_helix(12, r = 3))
#' r <- runif(100)
#' plot(1:100, r, col = cr(r), type = 'b', pch = 20)
#'
#' @importFrom grDevices rgb
#' @export
cube_helix <- function(n = 6, start = 0, r = .4, hue = .8, gamma = 1, light = .85, dark = .15, reverse = FALSE) {
	m <- matrix(c(
		-.14861, -.29227, 1.97294,
		1.78277, -.90649, 0
	), ncol = 2)
	lambda <- seq(light, dark, length.out = n)
	if (reverse) lambda <- rev(lambda)
	l <- rep(lambda ^ gamma, each = 3)
	phi <- 2 * pi * (start / 3 + r * lambda)
	t <- rbind(cos(phi), sin(phi))
	out <- l + hue * l * (1 - l) / 2 * (m %*% t)
	out <- pmin(pmax(out, 0), 1)
	out <- apply(out, 2, function(x) rgb(x[[1]], x[[2]], x[[3]]))
	out
}

scale_cube_helix <- function(aesthetics, start, r, hue, gamma, light, dark, reverse, discrete, guide, ...) {
	if (!requireNamespace('ggplot2', quietly = TRUE))
		stop('scale_', aesthetics, '_cube_helix needs (and is only useful for) the ggplot2 package')

	f <- function(n) cube_helix(n, start, r, hue, gamma, light, dark, reverse)

	if (discrete) {
		ggplot2::discrete_scale(aesthetics, 'cube_helix', f, ..., guide = guide)
	} else {
		ggplot2::continuous_scale(aesthetics, 'cube_helix', scales::gradient_n_pal(f(100)), guide = guide, ...)
	}
}

#' @rdname cube_helix
#' @export
scale_colour_cube_helix <- function(...,
	start = 0, r = .4, hue = .8, gamma = 1, light = .85, dark = .15, reverse = FALSE,
	discrete = TRUE, guide = if (discrete) 'legend' else 'colourbar'
) {
	scale_cube_helix('colour', start, r, hue, gamma, light, dark, reverse, discrete, guide, ...)
}
#' @rdname cube_helix
#' @export
scale_color_cube_helix <- scale_colour_cube_helix

#' @rdname cube_helix
#' @export
scale_fill_cube_helix <- function(...,
	start = 0, r = .4, hue = .8, gamma = 1, light = .85, dark = .15, reverse = FALSE,
	discrete = TRUE, guide = if (discrete) 'legend' else 'colourbar'
) {
	scale_cube_helix('fill', start, r, hue, gamma, light, dark, reverse, discrete, guide, ...)
}

#' Color legend
#'
#' Creates a color legend for a vector used to color a plot. It will use the current \code{\link[grDevices]{palette}()} or the specified \code{pal} as reference.
#'
#' When passed a factor or integer vector, it will create a discrete legend, whereas a double vector will result in a continuous bar.
#'
#' @param col          Vector of factor, integer, or double used to determine the ticks.
#' @param pal          If \code{col} is double, pal is used as a continuous palette, else as categorical one
#' @param log          Use logarithmic scale?
#' @param posx         Left and right borders of the color bar relative to plot area (Vector of length 2; 0-1)
#' @param posy         Bottom and top borders of color bar relative to plot area (Vector of length 2; 0-1)
#' @param main         Legend title
#' @param cex_main     Size of legend title font (default: subtitle font size \code{\link{par}('cex.sub')})
#' @param cex_axis     Size of ticks/category labels (default: axis font size \code{\link{par}('cex.axis')})
#' @param col_main     Color of legend title (default: subtitle color \code{\link{par}('col.sub')})
#' @param col_lab      Color of tick or category labels (default: axis color \code{\link{par}('col.lab')})
#' @param steps        Number of labels in case of a continuous axis. If 0 or FALSE, draw no ticks
#' @param steps_color  Number of gradient samples in case of continuous axis
#' @param digit        Number of digits for continuous axis labels
#' @param left         logical. If TRUE, invert posx
#' @param ...          Additional parameters for the \link[graphics]{text} call used for labels
#' @param cex.main,cex.axis,col.main,col.lab  For compatibility with \code{\link{par}}
#'
#' @return This function is called for the side effect of adding a colorbar to a plot and returns nothing/NULL.
#'
#' @examples
#' color_data <- 1:6
#' par(mar = par('mar') + c(0, 0, 0, 3))
#' plot(sample(6), col = color_data)
#' colorlegend(color_data)
#'
#' @importFrom graphics par rect segments text
#' @importFrom grDevices colorRampPalette palette
#' @export
colorlegend <- function( # nolint: cyclocomp_linter.
	col, pal = palette(), log = FALSE,
	posx = c(.9, .93), posy = c(.05, .9),
	main = NULL, cex_main = par('cex.sub'),
	cex_axis = par('cex.axis'),
	col_main = par('col.sub'), col_lab = par('col.lab'),
	steps = 5, steps_color = 100,
	digit = 2, left = FALSE,
	...,
	cex.main = NULL, # nolint: object_name_linter.
	cex.axis = NULL, # nolint: object_name_linter.
	col.main = NULL, # nolint: object_name_linter.
	col.lab = NULL) { # nolint: object_name_linter.
	draw_ticks <- as.logical(steps)
	if (!draw_ticks) steps <- 2L
	if (!is.null(cex.main)) cex_main <- cex.main
	if (!is.null(cex.axis)) cex_axis <- cex.axis
	if (!is.null(col.main)) col_main <- col.main
	if (!is.null(col.lab))  col_lab  <- col.lab

	zval <-
		if      (is.double(col)) seq(min(col, na.rm = TRUE), max(col, na.rm = TRUE), length.out = steps)
		else if (is.factor(col)) factor(levels(col))
		else                     sort(unique(col))

	zval_num <-
		if      (is.integer(zval)) seq_along(zval)
		else if (is.numeric(zval)) zval
		else if (is.factor(zval) || is.character(zval)) seq_along(zval)
		else                       as.integer(zval)

	zlim <-
		if (is.double(col)) range(zval_num)
		else c(min(zval_num) - .5, max(zval_num) + .5)

	par(new = TRUE)
	omar <- nmar <- par('mar')
	nmar[c(2, 4)] <- 0
	par(mar = nmar)

	emptyplot()

	pars <- par('usr')
	dx <- pars[[2]] - pars[[1]]
	xmin <- pars[[1]] + posx[[1]] * dx
	xmax <- pars[[1]] + posx[[2]] * dx
	dy <- pars[[4]] - pars[[3]]
	ymin <- pars[[3]] + posy[[1]] * dy
	ymax <- pars[[3]] + posy[[2]] * dy

	if (log) {
		zlim <- log10(zlim)
		zval <- log10(zval)
	}
	zmin <- zlim[[1]]
	zmax <- zlim[[2]]

	if (is.double(col)) {
		pal_fun <- if (is.function(pal)) pal else colorRampPalette(pal)
		batches <- pal_fun(steps_color)
		y <- seq(ymin, ymax, length.out = length(batches) + 1)
	} else {
		idx_c <- seq(min(zval_num), max(zval_num))
		idx_c[!(idx_c %in% zval_num)] <- NA

		batches <- pal[idx_c]
		y <- seq(ymin, ymax, length.out = length(idx_c) + 1)
	}

	rect(xmin, y[-length(y)], xmax, y[-1], col = batches, border = NA)
	rect(xmin, ymin, xmax, ymax, border = col_lab)

	dx <- xmax - xmin
	dy <- ymax - ymin
	if (left) {
		dx <- -dx
		pos <- 2
		xpos <- xmin + dx * .5
	} else {
		dx <- +dx
		pos <- 4
		xpos <- xmax + dx * .5
	}

	zval_txt <- if (is.double(col)) formatC(zval, digits = digit, format = 'fg') else zval

	y_pos <- ymin + (zval_num - zmin) / (zmax - zmin) * dy
	if (draw_ticks) {
		if (is.double(col))
			segments(xmax, y_pos, xpos + dx * .25, y_pos, col = col_lab)
		text(xpos, y_pos, zval_txt, pos = pos, col = col_lab, cex = cex_axis, ...)
	}

	if (!is.null(main)) {
		for (i in rev(seq_along(main)))
			text(x = mean(c(xmin, xmax)),
					 y = ymax + .05 * (length(main) - i + 1),
					 labels = main[i],
					 adj = c(.5, .5),
					 cex = cex_main,
					 col = col_main)
	}
	par(new = FALSE)
	par(mar = omar)
	invisible()
}

#' @rdname Gene-Relevance-plotting
#' @export
setGeneric('plot_gene_relevance_rank', function(coords, exprs, ..., genes, dims = 1:2, n_top = 10L, pal = c('#3B99B1', '#F5191C'), bins = 10L, faceter = facet_wrap(~ Gene)) {
	standardGeneric('plot_gene_relevance_rank')
})

#' @rdname Gene-Relevance-plotting
#' @export
setMethod('plot_gene_relevance_rank', c('matrix', 'matrix'), function(coords, exprs, ..., genes, dims, n_top, pal, bins, faceter) {
	plot_gene_relevance_rank_impl(gene_relevance(coords, exprs, dims = seq_len(max(dims))), genes = genes, dims = dims, n_top = n_top, pal = pal, bins = bins, faceter = faceter, ...)
})

#' @rdname Gene-Relevance-plotting
#' @export
setMethod('plot_gene_relevance_rank', c('DiffusionMap', 'missing'), function(coords, exprs, ..., genes, dims, n_top, pal, bins, faceter) {
	plot_gene_relevance_rank_impl(gene_relevance(coords, dims = seq_len(max(dims))), genes = genes, dims = dims, n_top = n_top, pal = pal, bins = bins, faceter = faceter, ...)
})

#' @rdname Gene-Relevance-plotting
#' @export
setMethod('plot_gene_relevance_rank', c('GeneRelevance', 'missing'), function(coords, exprs, ..., genes, dims, n_top, pal, bins, faceter) {
	plot_gene_relevance_rank_impl(coords, genes = genes, dims = dims, n_top = n_top, pal = pal, bins = bins, faceter = faceter, ...)
})

#' @importFrom tidyr gather
#' @importFrom tidyselect one_of
#' @importFrom scales percent
#' @importFrom rlang .data
#' @importFrom ggplot2 ggplot after_stat
#' @importFrom ggplot2 scale_fill_gradientn scale_alpha_continuous
#' @importFrom ggplot.multistats stat_summaries_hex
plot_gene_relevance_rank_impl <- function(relevance_map, ..., genes, dims, n_top, pal, bins, faceter) {
	chkDots(...)
	if (is.function(pal)) pal <- pal(12)
	coords <- get_coords(relevance_map, dims)
	gene_names <- if (is.character(genes)) genes else colnames(relevance_map@exprs)[genes]

	genes_missing <- setdiff(genes, colnames(relevance_map@partials_norm))
	if (length(genes_missing) > 0) {
		genes_close <- lapply(genes_missing, agrep, colnames(relevance_map@partials_norm), value = TRUE)
		stop('Missing genes: ', paste(genes_missing, collapse = ', '), '. ',
				 'Closest available: ', paste(unlist(genes_close), collapse = ', '))
	}

	top10 <- function(x) sum(x <= 10) / length(x)

	partials <- as.data.frame(t(apply(-relevance_map@partials_norm, 1, rank)[genes, , drop = FALSE]))
	d <- gather(cbind(partials, as.data.frame(coords)), 'Gene', 'Rank', one_of(gene_names))
	d$Gene <- factor(d$Gene, gene_names)

	d1 <- colnames(coords)[[1]]
	d2 <- colnames(coords)[[2]]
	gg <- ggplot(d, aes(.data[[d1]], .data[[d2]], z = .data$Rank)) +
		stat_summaries_hex(
			aes(fill = after_stat(.data$top10), alpha = after_stat(.data$size)),
			funs = list(top10 = top10, size = 'length', 'median'),
			bins = bins
		) +
		scale_fill_gradientn(
			name = substitute(Rank <= n_top, list(n_top = n_top)),
			labels = percent,
			colours = pal
		) +
		scale_alpha_continuous(name = '#Cells', trans = 'log10') +
		theme_really_minimal()

	if (length(genes) > 1) gg + faceter else gg + ggtitle(gene_names)
}

#' Fast eigen decomposition using \code{\link[RSpectra]{eigs}}
#'
#' By default uses a random initialization vector that you can make deterministic using
#' \code{\link[base]{set.seed}} or override by specifying \code{opts = list(initvec = ...)}.
#'
#' @param m       A matrix (e.g. from the Matrix package) or
#'                a function (see \code{\link[RSpectra]{eigs}}).
#' @param n_eigs  Number of eigenvectors to return.
#' @param sym     defunct and ignored.
#' @param ...     Passed to \code{\link[RSpectra]{eigs}}.
#' @param opts    Passed to \code{\link[RSpectra]{eigs}}.
#'
#' @return see \code{\link[RSpectra]{eigs}}.
#'
#' @examples
#' eig_decomp(cbind(c(1,0,-1), c(0,1,0), c(-1,0,1)), 2)
#'
#' @importFrom Matrix isSymmetric
#' @importFrom RSpectra eigs eigs_sym
#' @importFrom stats runif
#' @export
eig_decomp <- function(m, n_eigs, sym, ..., opts = list()) {
	if (!('initvec' %in% names(opts)))
		opts$initvec <- runif(nrow(m)) - .5
	# eigs cannot handle symmetricMatrix & sparseMatrix yet
	# TODO: low-effort. We can copy the memory and use the `lower = T/F` arg instead
	if (is(m, 'dsCMatrix')) m <- as(m, 'dgCMatrix')
	if (is(m, 'dsRMatrix')) m <- as(m, 'dgRMatrix')
	eigs(m, n_eigs, ..., opts = opts)
}

#' @importFrom methods setClassUnion
#' @importClassesFrom Matrix dMatrix ddenseMatrix dsparseMatrix ddiMatrix dgeMatrix dtrMatrix dtpMatrix dsyMatrix dspMatrix dpoMatrix dppMatrix corMatrix Cholesky pCholesky BunchKaufman pBunchKaufman
setClassUnion('characterOrnumericOrNULL', members = c('character', 'numeric', 'NULL'))
setClassUnion('ColIndex', members = c('character', 'numeric', 'logical'))
setClassUnion('numericOrNULL', members = c('numeric', 'NULL'))
setClassUnion('integerOrNULL', members = c('integer', 'NULL'))
setClassUnion('dMatrixOrNULL', members = c('dMatrix', 'NULL'))
# Added dsparseMatrix directly because of https://bugs.r-project.org/bugzilla/show_bug.cgi?id=17596
setClassUnion('dMatrixOrMatrix', members = c('dMatrix', 'dsparseMatrix', 'matrix'))

setClassUnion('logicalOrMissing', members = c('logical', 'missing'))
setClassUnion('characterOrFactor', c('character', 'factor'))

#' @include dpt.r s4-unions.r
NULL

#' DPT Matrix methods
#'
#' Treat DPT object as a matrix of cell-by-cell DPT distances.
#'
#' @param x     \code{\link{DPT}} object.
#' @param i,j   \link[=numeric]{Numeric} or \link{logical} index.
#' @param ...   ignored
#' @param drop  If \code{\link{TRUE}}, coerce result to a vector if it would otherwise have \code{1 \%in\% dim(result)}.
#'
#' @examples
#' data(guo_norm)
#' dm <- DiffusionMap(guo_norm)
#' dpt <- DPT(dm)
#' set.seed(1)
#' plot(dpt[random_root(dpt), ], Biobase::exprs(guo_norm)['DppaI', ])
#'
#' @seealso \code{\link{as.matrix.DPT}}
## Not [[.DPT, that is in the extraction methods
#' @aliases [.DPT nrow.DPT ncol.DPT dim.DPT
#' @name DPT matrix methods
#' @rdname DPT-matrix-methods
NULL

#' @return \code{[} returns a dense matrix or (if applicable and \code{isTRUE(drop)}) a vector.
#' @rdname DPT-matrix-methods
#' @export
setMethod('[', c('DPT', 'index', 'index', 'logicalOrMissing'), function(x, i, j, ..., drop = TRUE) {
	stopifnot(length(list(...)) == 0L)
	evas <- eigenvalues(x@dm)
	eves <- eigenvectors(x@dm)

	# get numeric from negative or logical indices
	i <- seq_len(nrow(x))[i]
	j <- seq_len(nrow(x))[j]

	norm <- array(NA, c(length(i), length(j), length(evas)))
	ev_dist <- norm

	for (e in seq_along(evas)) norm[, , e] <- evas[[e]]
	norm <- norm / (1 - norm)

	do.call(mapply, c(list(function(ii, jj) {
		ev_dist[ii, jj, ] <<- eves[i[[ii]], ] - eves[j[[jj]], ]
	}), expand.grid(ii = seq_along(i), jj = seq_along(j))))

	r <- sqrt(apply(norm^2 * ev_dist^2, 1:2, sum))
	if (drop && 1L %in% dim(r)) dim(r) <- NULL
	r
})

#' @rdname DPT-matrix-methods
#' @export
setMethod('[', c('DPT', 'index', 'missing', 'logicalOrMissing'), function(x, i, j, ..., drop = TRUE) {
	x[i, seq_len(nrow(x)), ..., drop = drop]
})

#' @rdname DPT-matrix-methods
#' @export
setMethod('[', c('DPT', 'missing', 'index', 'logicalOrMissing'), function(x, i, j, ..., drop = TRUE) {
	x[seq_len(nrow(x)), j, ..., drop = drop]
})

#' @rdname DPT-matrix-methods
#' @export
setMethod('[', c('DPT', 'missing', 'missing', 'logicalOrMissing'), function(x, i, j, ..., drop = TRUE) {
	x[seq_len(nrow(x)), seq_len(nrow(x)), ..., drop = drop]
})

#' @return \code{[[} returns single distance value
#' @rdname DPT-matrix-methods
#' @export
setMethod('[[', c('DPT', 'index', 'index'), function(x, i, j, ...) {
	if (length(i) != 1L || length(j) == 1L)
		stop('Can only extract one element, but i and j were of lengths ', length(i), ' and ', length(j))
	x[i, j, ...]
})

#' @return \code{nrow} and \code{ncol} return the number of cells
#' @importFrom BiocGenerics nrow
#' @rdname DPT-matrix-methods
#' @export
setMethod('nrow', 'DPT', function(x) length(x@dm@d))

#' @importFrom BiocGenerics ncol
#' @rdname DPT-matrix-methods
#' @export
setMethod('ncol', 'DPT', function(x) length(x@dm@d))

#' @return \code{dim} returns \code{c(n_cells, n_cells)}
#' @rdname DPT-matrix-methods
#' @export
setMethod('dim', 'DPT', function(x) c(nrow(x), ncol(x)))

#' @importFrom grDevices palette hcl.colors
#' @rdname Gene-Relevance-plotting
#' @export
setGeneric('plot_differential_map', function(coords, exprs, ..., genes, dims = 1:2, pal = hcl.colors, faceter = facet_wrap(~ Gene)) {
	standardGeneric('plot_differential_map')
})

#' @rdname Gene-Relevance-plotting
#' @export
setMethod('plot_differential_map', c('matrix', 'matrix'), function(coords, exprs, ..., genes, dims, pal, faceter) {
	plot_differential_map_impl(gene_relevance(coords, exprs, dims = seq_len(max(dims))), genes = genes, dims = dims, pal = pal, faceter = faceter, ...)
})

#' @rdname Gene-Relevance-plotting
#' @export
setMethod('plot_differential_map', c('DiffusionMap', 'missing'), function(coords, exprs, ..., genes, dims, pal, faceter) {
	plot_differential_map_impl(gene_relevance(coords, dims = seq_len(max(dims))), genes = genes, dims = dims, pal = pal, faceter = faceter, ...)
})

#' @rdname Gene-Relevance-plotting
#' @export
setMethod('plot_differential_map', c('GeneRelevance', 'missing'), function(coords, exprs, ..., genes, dims, pal, faceter) {
	plot_differential_map_impl(coords, genes = genes, dims = dims, pal = pal, faceter = faceter, ...)
})

differential_map <- function(relevance_map, genes = NULL, dims = 1:2, all = FALSE) {
	relevance_map <- updateObject(relevance_map)

	all_dims <- get_dim_range(relevance_map@partials, 3L, dims)
	if (!all(dims %in% all_dims)) stop(
		'The relevance map contains only the dimensions ', paste(all_dims, collapse = ', '),
		', not ', paste(setdiff(dims, all_dims), collapse = ', '))

	genes_existing <- colnames(relevance_map@partials_norm)
	if (is.null(genes)) {
		genes <- genes_existing
	} else {
		genes_missing <- is.na(match(genes, genes_existing))
		if (any(genes_missing)) stop(
			'The dataset used for the relevance map does not contain gene(s) ', paste(genes[genes_missing], collapse = ', '),
			'. Did you mean ', paste(agrep(genes[genes_missing], genes_existing, value = TRUE), collapse = ', '), '?')
	}

	exprs <- relevance_map@exprs
	coords <- get_coords(relevance_map, dims)

	partials_norms <- relevance_map@partials_norm[, genes, drop = FALSE]

	do.call(rbind, lapply(genes, function(g) {
		d_var <- .05  # Fraction of overall dimension variability
		partials <- lapply(seq_len(length(dims)), function(d) {
			dc <- coords[, d]
			partials <- relevance_map@partials[, g, d]
			# Scale magnitude of partial derivates
			delta <- diff(rev(range(dc, na.rm = TRUE)))
			partials / max(abs(partials), na.rm = TRUE) * d_var * delta
		})

		cbind(
			as.data.frame(coords),
			Expression = exprs[, g],
			PartialsNorm = partials_norms[, g],
			Cell = if (!is.null(rownames(exprs))) rownames(exprs) else seq_len(nrow(exprs)),
			Gene = factor(g, levels = genes),
			Angle = atan(partials[[2]] / partials[[1]]),
			Magnitude = sqrt(partials[[1]]^2 + partials[[2]]^2))
	}))
}

#' @importFrom rlang .data
#' @importFrom ggplot2 ggplot aes
#' @importFrom ggplot2 geom_point geom_spoke
#' @importFrom ggplot2 scale_colour_gradientn
#' @importFrom ggplot2 ggtitle facet_wrap
#' @importFrom grid arrow unit
plot_differential_map_impl <- function(relevance_map, ..., genes, dims, pal, faceter) {
	chkDots(...)
	if (is.function(pal)) pal <- pal(12)
	dtm <- differential_map(relevance_map, genes, dims)
	coords <- get_coords(relevance_map, dims)
	gene_names <- if (is.character(genes)) genes else colnames(relevance_map@exprs)[genes]

	d1 <- colnames(coords)[[1]]
	d2 <- colnames(coords)[[2]]
	gg <- ggplot(dtm, aes(.data[[d1]], .data[[d2]])) +
		geom_spoke(
			aes(
				angle = .data$Angle, radius = .data$Magnitude,
				alpha = .data$PartialsNorm,
				colour = .data$Expression
			),
			arrow = arrow(length = unit(.01, 'npc'))
		) +
		scale_colour_gradientn(colours = pal) +
		geom_rangeframe(colour = par('col')) +
		theme_really_minimal()

	if (length(genes) > 1) gg + faceter else gg + ggtitle(gene_names)
}

#' @include diffusionmap.r
NULL

#' Predict new data points using an existing DiffusionMap. The resulting matrix can be used in \link[=plot.DiffusionMap]{the plot method for the DiffusionMap}
#'
#' @param dm        A \code{\link{DiffusionMap}} object.
#' @param new_data  New data points to project into the diffusion map.
#'                  Can be a \link[base]{matrix}, \link[base]{data.frame},
#'                  \link[Biobase:class.ExpressionSet]{ExpressionSet},
#'                  or \link[SingleCellExperiment]{SingleCellExperiment}.
#' @param verbose   Show progress messages?
#' @param ...       Passed to \code{\link[proxy:dist]{proxy::dist}(new_data, data, dm@distance, ...)}.
#'
#' @return A \eqn{nrow(new\_data) \times ncol(eigenvectors(dif))} matrix of projected diffusion components for the new data.
#'
#' @examples
#' data(guo)
#' g1 <- guo[, guo$num_cells != 32L]
#' g2 <- guo[, guo$num_cells == 32L]
#' dm <- DiffusionMap(g1)
#' dc2 <- dm_predict(dm, g2)
#' plot(dm, new_dcs = dc2)
#'
#' @importFrom methods is
#' @importFrom Matrix Diagonal colSums rowSums
#' @importFrom proxy dist
#' @export
dm_predict <- function(dm, new_data, ..., verbose = FALSE) {
	if (!is(dm, 'DiffusionMap')) stop('dm needs to be a DiffusionMap')

	data <- dataset_extract_doublematrix(dataset(dm), dm@vars)
	new_data <- dataset_extract_doublematrix(new_data, dm@vars)
	if (!dataset_n_features(data) == dataset_n_features(new_data))
		stop('new data needs to have the same features as the one used to create the diffusion map')

	censor <- !is.null(dm@censor_val) || any(is.na(data)) || any(is.na(new_data))
	#censor imples euclidean distance

	#TODO: local sigma
	sigma <- optimal_sigma(dm)
	if (!censor) {
		if (verbose) cat('Creating distance matrix without censoring\n')
		measure <- switch(dm@distance, euclidean = 'Euclidean', cosine = 'correlation', rankcor = 'rankcor', stop('Unknown distance measure'))
		d <-   # no auto-simil2dist to not use 1-abs(simil)
			if (measure == 'Euclidean') proxy::dist(new_data, data, measure, ...)
			else 1 - proxy::simil(new_data, data, measure, ...)
		d2 <- unclass(d ^ 2) # matrix (dense)
		stopifnot(nrow(d2) == nrow(new_data))
		stopifnot(ncol(d2) == nrow(data))

		#TODO: zeros not on diag
		trans_p <- exp(-d2 / (2 * sigma ^ 2))
		trans_p[d2 == 0] <- 0
	} else {
		if (verbose) cat('Creating distance matrix with censoring\n')
		trans_p <- predict_censoring(data, new_data, dm@censor_val, dm@censor_range, dm@missing_range, sigma)
	}

	#trans_p:  columns: old data, rows: new data
	d_new <- rowSums(trans_p, na.rm = TRUE)
	norm_p <- get_norm_p(trans_p, dm@d, d_new, dm@density_norm)
	rm(trans_p)  # free memory

	d_norm_new <- rowSums(norm_p)

	d_rot     <- Diagonal(x = dm@d_norm  ^ -.5)
	d_rot_new <- Diagonal(x = d_norm_new ^ -.5)
	m_new <- d_rot_new %*% norm_p %*% d_rot

	if (verbose) cat('Transforming data\n')
	t(t(m_new %*% eigenvectors(dm)) / eigenvalues(dm))
}

auto_branch <- function(dpt, cells, stats, w_width, nmin = 10L, gmin = 1.1) {
	n <- length(cells)

	stopifnot(n >= nmin)
	stopifnot(stats$g >= gmin)

	# initialize one level (branch, tips) and three branches (dpt)
	branches <- cut_branches(dpt[cells, stats$tips], cells, w_width)  # list of vectors of numeric indices
	branch <- matrix(idx_list_to_vec(branches, cells, n), n, 1L)
	tips <- matrix(logical(n), n, 1L)
	tips[match(stats$tips, cells), 1L] <- TRUE

	subs <- mapply(function(idx_sub, i) {
		if (length(idx_sub) < nmin || !i %in% idx_sub)  # Tip cells can end up undecided!
			return(NULL)

		sub_stats <- tipstats(dpt, idx_sub, i)
		if (sub_stats$g < gmin)
			return(NULL)

		auto_branch(dpt, idx_sub, sub_stats, w_width, nmin, gmin)
	}, branches, stats$tips, SIMPLIFY = FALSE)

	# add dpt columns to dpt and a level column to branch/tips if any branch was subdivided
	nonnull_subs <- vapply(subs, Negate(is.null), logical(1L))
	if (any(nonnull_subs)) {
		n_sublevels <- do.call(max, lapply(subs[nonnull_subs], function(s) ncol(s$branch)))

		branch <- cbind(branch, matrix(NA_integer_, n, n_sublevels))
		tips   <- cbind(tips,   matrix(NA,          n, n_sublevels))

		for (s in which(nonnull_subs)) {
			sub <- subs[[s]]
			idx_sub <- branches[[s]]

			idx_newcol <- seq.int(ncol(branch) - n_sublevels + 1L, length.out = ncol(sub$branch))
			stopifnot(ncol(sub$branch) == ncol(sub$tips))

			branch_offset <- max(branch, na.rm = TRUE)
			branch[match(idx_sub, cells), idx_newcol] <- sub$branch + branch_offset
			tips[match(idx_sub, cells), idx_newcol] <- sub$tips
		}
	}

	stopifnot(ncol(branch) == ncol(tips))
	list(branch = branch, tips = tips)
}


idx_list_to_vec <- function(idx_list, cells, n) {
	v <- rep(NA_integer_, n)
	for (i in seq_along(idx_list))
		v[match(idx_list[[i]], cells)] <- i
	v
}


cut_branches <- function(dpt_mat, cells, w_width) {
	bid <- apply(dpt_mat, 2, order)
	branches <- lapply(seq_len(3), function(b) branchcut(dpt_mat, bid, b, w_width))
	lapply(organize_branches(branches), function(branch) cells[branch])
}


branchcut <- function(dpt_mat, bid, b, w_width) {
	n <- nrow(bid)
	all_branches <- seq_len(3L)

	# sanity checks
	stopifnot(b %in% all_branches)
	stopifnot(ncol(dpt_mat) == 3L, ncol(bid) == 3L)
	stopifnot(nrow(dpt_mat) == n)
	stopifnot(is.double(dpt_mat), is.integer(bid))

	# find cell indexes per branch
	other <- all_branches[all_branches != b]
	b1 <- other[[1L]]
	b2 <- other[[2L]]

	# DPT for other branches, sorted by b3
	b3_idxs <- bid[, b]
	dpt1 <- dpt_mat[b3_idxs, b1]
	dpt2 <- dpt_mat[b3_idxs, b2]

	kcor <- vapply(seq_len(n - 1L), function(s1) {
		s2 <- s1 + 1L
		l <- seq_len(s1)
		r <- seq(s2, n)

		k_l <- kendall_finite_cor(dpt1[l], dpt2[l], dpt1[[s2]], dpt2[[s2]])
		k_r <- kendall_finite_cor(dpt1[r], dpt2[r], dpt1[[s1]], dpt2[[s1]])

		k_l / s1 - k_r / (n - s1)
	}, double(1L))

	kcor <- smth.gaussian(kcor, w_width)
	cut <- which.max(kcor)

	b3_idxs[seq_len(cut)]
}


# This function organizes the cell arrays branches[[i]]
# to build Branch labels (length <- number of cells) indicating the branch each cell belongs to.
# Cells which are assigned to more than one branch in dpt as well
# as cells which are not assigned to any branch are defined as undeceided (label NA)
#' @importFrom utils combn
organize_branches <- function(branches) {
	intersect_branches <- function(bs) intersect(branches[[bs[[1L]]]], branches[[bs[[2L]]]])
	branch_intersections <- lapply(combn(3L, 2L, simplify = FALSE), intersect_branches)
	inters <- Reduce(union, branch_intersections, integer())

	lapply(branches, function(b) union(setdiff(b, inters), b[[1]]))
}


# given two orderings b1 and b2, compute the delta (e.i. finite) Kendall
# correlation of adding a new cell with bnew1, bnew2 to the orderings.
kendall_finite_cor <- function(b1, b2, new1, new2) {
	b11 <- numeric(length(b1))
	b11[b1 >= new1] <- 1
	b11[b1 <  new1] <- -1

	b22 <- numeric(length(b2))
	b22[b2 >= new2] <- 1
	b22[b2 <  new2] <- -1

	as.double(b11 %*% b22)  # strip dims
}

#' @include utils.r
NULL

#' Convert object to \link[Biobase:class.ExpressionSet]{ExpressionSet} or read it from a file
#'
#' These functions present quick way to create \link[Biobase:class.ExpressionSet]{ExpressionSet} objects.
#'
#' They work by using all continuous (double) columns as expression data, and all others as observation annotations.
#'
#' @param x  \link[base]{data.frame} to convert to an \link[Biobase:class.ExpressionSet]{ExpressionSet}.
#'
#' @return an \link[Biobase:class.ExpressionSet]{ExpressionSet} object
#'
#' @examples
#' library(Biobase)
#' df <- data.frame(Time  = seq_len(3), #integer column
#'                  Actb  = c(0.05, 0.3, 0.8),
#'                  Gapdh = c(0.2, 0.03, 0.1))
#' set <- as.ExpressionSet(df)
#' rownames(exprs(set)) == c('Actb', 'Gapdh')
#' phenoData(set)$Time == 1:3
#'
#' @seealso \link[utils]{read.table} on which \code{read.ExpressionSet} is based, and \link[Biobase:class.ExpressionSet]{ExpressionSet}.
#'
#' @name ExpressionSet helper methods
#' @rdname ExpressionSet-helpers
NULL

#' @importFrom methods setGeneric .valueClassTest
#' @rdname ExpressionSet-helpers
#' @export
setGeneric('as.ExpressionSet', function(x, ...) standardGeneric('as.ExpressionSet'), valueClass = 'ExpressionSet')

#' @param annotation_cols  The data.frame columns used as annotations. All others are used as expressions. (Logical, character or numerical index array)
#'
#' @importFrom Biobase ExpressionSet AnnotatedDataFrame phenoData
#' @rdname ExpressionSet-helpers
#' @export
setMethod('as.ExpressionSet', 'data.frame', function(x, annotation_cols = !sapply(x, is.double)) {
	if (!is.logical(annotation_cols))
		annotation_cols <- l_which(annotation_cols, names(x))

	assay_data <- t(as.matrix(x[!annotation_cols]))
	pheno_data <- AnnotatedDataFrame(x[annotation_cols])

	ExpressionSet(assay_data, pheno_data)
})

#' @param file    File path to read ASCII data from
#' @param header  Specifies if the file has a header row.
#' @param ...     Additional parameters to \link[utils]{read.table}
#'
#' @importFrom utils read.table
#' @rdname ExpressionSet-helpers
#' @export
read.ExpressionSet <- function(file, header = TRUE, ...) { # nolint: object_name_linter.
	as.ExpressionSet(read.table(file, header, ...))
}

#' Diffusion Pseudo Time
#'
#' Create pseudotime ordering and assigns cell to one of three branches
#'
#' Treat it as a matrix of pseudotime by subsetting (\code{\link[=dim.DPT]{[ dim nrow ncol}} \code{\link[=as.matrix.DPT]{as.matrix}}), and as a list of pseudodime, and expression vectors (\code{\link[=names.DPT]{$ [[ names}} \code{\link[=as.data.frame.DPT]{as.data.frame}}).
#'
#' @param dm       A \code{\link{DiffusionMap}} object. Its transition probabilities will be used to calculate the DPT
#' @param tips     The cell index/indices from which to calculate the DPT(s) (integer of length 1-3)
#' @param ...      Unused. All parameters to the right of the \code{...} have to be specified by name (e.g. \code{DPT(dm, w_width = 0.2)})
#' @param w_width  Window width to use for deciding the branch cutoff
#'
#' @return A \code{DPT} object:
#'
#' @slot branch  \code{\link[base]{matrix}} (of \code{\link[base]{integer}}) recursive branch labels for each cell (row); \code{NA} for undeceided. Use \code{\link{branch_divide}} to modify this.
#' @slot tips    \code{\link[base]{matrix}} (of \code{\link[base]{logical}}) indicating if a cell (row) is a tip of the corresponding banch level (col)
#' @slot dm      \code{\link{DiffusionMap}} used to create this DPT object
#'
#' @examples
#' data(guo_norm)
#' dm <- DiffusionMap(guo_norm)
#' dpt <- DPT(dm)
#' str(dpt)
#'
#' @importFrom methods setClass
#' @rdname DPT
#' @export
setClass(
	'DPT',
	slots = c(
		branch = 'matrix', # 'integer'
		tips   = 'matrix', # 'logical'
		dm     = 'DiffusionMap'),
	validity = function(object) {
		TRUE  # TODO
	})

#' @rdname DPT
#' @export
DPT <- function(dm, tips = random_root(dm), ..., w_width = .1) { # nolint: object_name_linter.
	chkDots(...)
	if (!is(dm, 'DiffusionMap')) stop('dm needs to be of class DiffusionMap, not ', class(dm))
	if (!length(tips) %in% 1:3) stop('you need to specify 1-3 tips, got ', length(tips))

	dpt <- dummy_dpt(dm)
	all_cells <- seq_len(nrow(dpt))

	stats <- tipstats(dpt, all_cells, tips)
	branches <- auto_branch(dpt, all_cells, stats, w_width)

	colnames(branches$branch) <- paste0('Branch', seq_len(ncol(branches$branch)))
	colnames(branches$tips)   <- paste0('Tips',   seq_len(ncol(branches$tips)))

	rownames(branches$branch) <- rownames(branches$tips) <- rownames(dm@eigenvectors)
	dpt@branch <- branches$branch
	dpt@tips   <- branches$tips
	dpt
}

dummy_dpt <- function(dm_or_dpt) {
	if (is(dm_or_dpt, 'DPT')) dm_or_dpt
	else if (is(dm_or_dpt, 'DiffusionMap')) new('DPT', branch = matrix(), tips = matrix(), dm = dm_or_dpt)
	else stop('dm_or_dpt needs to be DPT or DiffusionMap object, not ', class(dm_or_dpt))
}

dpt_for_branch <- function(dpt, branch_id) {
	branch_idx <- dpt@branch[, 1L] == branch_id
	stopifnot(any(branch_idx))
	tip_cells <- which(branch_idx & dpt@tips[, 1L])
	if (length(tip_cells) == 0L) tip_cells <- which(branch_idx)
	dpt[tip_cells[[1L]], ]
}

pr_rankcor <- function(x, y) {
	crossprod(x, y) / sqrt(crossprod(x) * crossprod(y))
}

pr_rankcor_prefun <- function(x, y, pairwise, p, reg_entry) {
	x_ranked <- rank_mat(x)
	y_ranked <- rank_mat(y)
	x_rc <- sweep(x_ranked, 1, rowMeans(x_ranked))
	y_rc <- sweep(y_ranked, 1, rowMeans(y_ranked))
	list(x = x_rc, y = y_rc, pairwise = pairwise, p = p, reg_entry = reg_entry)
}

#' @importFrom proxy pr_DB
proxy_add_rankcor_simil <- function() {
	pr_DB$set_entry(
		FUN = pr_rankcor,
		PREFUN = pr_rankcor_prefun,
		names = c('rankcorrelation', 'rankcor', 'spearman'),
		distance = FALSE,
		convert = 'pr_simil2dist',
		type = 'metric',
		loop = TRUE,
		C_FUN = FALSE,
		abcd = FALSE,
		formula = 'xy / sqrt(xx * yy) for ranked and centered x,y',
		reference = '???',
		description = 'rank correlation (taking n instead of n-1 for the variance)')
}

# There is currently a problem on windows which can't display chars in th
# text/plain output, which are not available in the current locale.
# See https://github.com/IRkernel/repr/issues/28#issuecomment-208574856
#' @importFrom utils capture.output
char_fallback <- function(char, default) {
	real_len <- nchar(char)
	r_len <- nchar(capture.output(cat(char)))
	if (real_len == r_len) char else default
}
sym_times <- char_fallback('\u00D7', 'x')


stopifsmall <- function(max_dist) {
	if (max_dist < .Machine$double.eps)
		stop(sprintf(
			'The supplied sigma is not large enough. Please select a larger one.
			find_sigmas(data) should return one with the right order of magnitude. (max dist. is %.3e)',
			max_dist))
}


#' @importFrom utils flush.console
verbose_timing <- function(verbose, msg, expr) {
	if (verbose) {
		cat(sprintf('%s...', msg))
		flush.console()
		dif <- system.time({
			r <- force(expr)
		})
		cat(sprintf('...done. Time: %.2fs\n', dif[['elapsed']]))
		flush.console()
		r
	} else {
		expr
	}
}


#' @importFrom Matrix Diagonal
#' @importMethodsFrom Matrix solve
accumulated_transitions <- function(dm) {
	if (!is.null(dm@data_env$propagations)) {  # compat
		dm@data_env$accumulated_transitions <- dm@data_env$propagations
		rm('propagations', envir = dm@data_env)
	}

	if (is.null(dm@data_env$accumulated_transitions)) {
		if (is.null(dm@transitions))
			stop('DiffusionMap was created with suppress_dpt = TRUE')

		n <- length(dm@d_norm)

		phi0 <- dm@d_norm / sqrt(sum(dm@d_norm ^ 2))
		inv <- solve(Diagonal(n) - dm@transitions + phi0 %*% t(phi0))
		dm@data_env$accumulated_transitions <- inv - Diagonal(n)
	}

	dm@data_env$accumulated_transitions
}


hasattr <- function(x, which) !is.null(attr(x, which, exact = TRUE))


flipped_dcs <- function(d, dcs) {
	if (is(d, 'DiffusionMap')) d <- eigenvectors(d)

	evs <- as.matrix(d[, abs(dcs)])
	evs[, dcs < 0] <- -evs[, dcs < 0]
	evs
}


rescale_mat <- function(mat, rescale) {
	if (is.list(rescale)) {
		stopifnot(setequal(dimnames(rescale), c('from', 'to')))
		rv <- apply(mat, 2L, scales::rescale, rescale$to, rescale$from)
	} else if (is.array(rescale)) {
		stopifnot(length(dim(rescale)) == 3L)
		stopifnot(ncol(mat) == ncol(rescale))
		stopifnot(dim(rescale)[[1L]] == 2L)
		stopifnot(dim(rescale)[[3L]] == 2L)

		col_type <- get(typeof(mat))
		rv <- vapply(seq_len(ncol(mat)), function(d) {
			scales::rescale(mat[, d], rescale['to', d, ], rescale['from', d, ])
		}, col_type(nrow(mat)))
	}
	stopifnot(all(dim(rv) == dim(mat)))
	dimnames(rv) <- dimnames(mat)
	rv
}


# irlba supports sparse data, pcaMethods supports NAs.
#' @importFrom methods is
#' @importFrom pcaMethods pca scores
#' @importFrom irlba prcomp_irlba
pca_scores <- function(x, n_pcs, center = TRUE, scale = FALSE) {
	# prcomp_irlba supports unit vector (uv) scaling
	if (is(x, 'sparseMatrix')) {
		pcs <- prcomp_irlba(x, n_pcs, center = center, scale. = scale)$x
		rownames(pcs) <- rownames(x)
		pcs
	} else {
		scores(pca(x, nPcs = n_pcs, center = center, scale = if (scale) 'uv' else 'none'))
	}
}


runs <- function(vec) {
	enc <- rle(vec)
	enc$values <- make.unique(enc$values, '_')
	inverse.rle(enc)
}


get_louvain_clusters <- function(transitions) {
	graph <- igraph::graph_from_adjacency_matrix(transitions, 'undirected', weighted = TRUE)
	as.integer(unclass(igraph::membership(igraph::cluster_louvain(graph))))
}


#' @importFrom BiocGenerics duplicated
setMethod('duplicated', 'dgCMatrix', function(x, incomparables = FALSE, MARGIN = 1L, ...) { # nolint: object_name_linter.
	MARGIN <- as.integer(MARGIN) # nolint: object_name_linter.
	n <- nrow(x)
	p <- ncol(x)
	j <- rep(seq_len(p), diff(x@p))
	i <- x@i + 1
	v <- x@x

	if (MARGIN == 1L) {  # rows
		names(v) <- j
		splits <- split(v, i)
		is_empty <- setdiff(seq_len(n), i)
	} else if (MARGIN == 2L) {  # columns
		names(v) <- i
		splits <- split(v, j)
		is_empty <- setdiff(seq_len(p), j)
	} else {
		stop('Invalid MARGIN ', MARGIN, ', matrices only have rows (1) and columns (2).')
	}

	result <- duplicated.default(splits)
	if (!any(is_empty)) return(result)

	out <- logical(if (MARGIN == 1L) n else p)
	out[-is_empty] <- result
	if (length(is_empty) > 1)
		out[is_empty[-1]] <- TRUE
	out
})

context('PCA')

library(Biobase)
library(SingleCellExperiment)

test_nobss <- 30L
test_nfeat <- 20L
test_n_pcs <- 4L

test_obss <- paste0('c', seq_len(test_nobss))
test_feat <- paste0('g', seq_len(test_nfeat))

test_matrix <- matrix(runif(test_nobss * test_nfeat), test_nobss, test_nfeat, dimnames = list(test_obss, test_feat))
test_matrix[test_matrix < mean(test_matrix)] <- 0
test_matrix_sparse <- as(test_matrix, 'sparseMatrix')

test_se <- SingleCellExperiment(
	assays = list(logcounts = t(test_matrix)),
	colData = DataFrame(cm1 = LETTERS[seq_len(test_nobss)]),
	rowData = DataFrame(gm1 = letters[seq_len(test_nfeat)]))
test_se_sparse <- test_se
assay(test_se_sparse) <- t(test_matrix_sparse)


test_that('PCA works sparse and dense data', {
	# Each PC can be flipped individually,
	# so the correct alignment would be to see which ones need to be flipped
	# Using abs() is simpler for comparison, but destroys the real PCs.
	pcs_dense  <- abs(pca_scores(test_matrix, test_n_pcs))
	pcs_sparse <- abs(pca_scores(test_matrix_sparse, test_n_pcs))
	expect_equal(pcs_dense, pcs_sparse, tolerance = 1e-5)
})


test_that('PCA with sparse data does not densify', with_mocked_bindings(
	prcomp   = function(...) stop('prcomp should not be called'),
	princomp = function(...) stop('princomp should not be called'),
	.package = "stats",
  with_mocked_bindings(
	  as.matrix = function(...) stop('as.matrix should not be called'),
		.package = "base",
		{
			pca_scores(test_matrix_sparse, test_n_pcs)
			succeed('The matrix was not densified')
		}
	)
))

#' Extraction methods
#'
#' Extract common information from objects.
#' Apart from the input data's branches,
#' you can extract diffusion components via \code{$DCx}.
#' From \code{\link{DPT}} objects, you can also extract the branch label via \code{$Branch},
#' or the diffusion pseudo time for a numbered cell via \code{$DPTx}.
#'
#' @param x       \code{\link{DiffusionMap}} or \code{\link{DPT}}  object
#' @param i,name  Name of a diffusion component \code{'DCx'}, \code{'DPTx'}, \code{'Branch'} or column from the data
#' @param j       N/A
#' @param ...     ignored
#'
#' @return The names or data row, see respective generics.
#'
#' @seealso \link[base]{Extract}, \code{\link[base]{names}} for the generics. \link{DiffusionMap accession methods}, \link{DiffusionMap methods}, \link{Coercion methods} for more
#'
#' @examples
#' data(guo)
#' dm <- DiffusionMap(guo)
#' dm$DC1        # A diffusion component
#' dm$Actb       # A gene expression vector
#' dm$num_cells  # Phenotype metadata
#'
#' dpt <- DPT(dm)
#' dm$Branch
#' dm$DPT1
#'
#' @name Extraction methods
#' @rdname extractions
#' @aliases
#'   names.DPT names.DiffusionMap
#'      [[.DPT    [[.DiffusionMap
#'       $.DPT     $.DiffusionMap
NULL


#' @importFrom methods is
#' @importFrom Biobase featureNames varLabels
#' @rdname extractions
#' @export
setMethod('names', 'DiffusionMap', function(x) {
	c(colnames(eigenvectors(x)), dataset_names(dataset(x)))
})
#' @rdname extractions
#' @export
setMethod('names', 'DPT', function(x) c(paste0('DPT', seq_len(nrow(x))), 'Branch', names(x@dm)))


#' @importFrom methods is
#' @importFrom Biobase exprs featureNames
#' @rdname extractions
#' @export
setMethod('[[', c('DiffusionMap', 'character', 'missing'), function(x, i, j, ...) {
	if (grepl('^DC\\d+$', i)) {
		eigenvectors(x)[, i]
	} else {
		dataset_get_feature(dataset(x), i)
	}
})
#' @rdname extractions
#' @export
setMethod('[[', c('DPT', 'character', 'missing'), function(x, i, j, ...) {
	if (identical(i, 'dpt')) return(dpt_for_branch(x, 1L))  #TODO

	num_i <- if (grepl('DPT\\d+', i)) as.integer(sub('DPT(\\d+)', '\\1', i))

	if (!is.null(num_i) && 1L <= num_i && num_i <= nrow(x)) {
		x[num_i, ]
	} else if (identical(i, 'Branch') || identical(i, 'branch')) {
		x@branch[, 1L]
	} else {
		x@dm[[i]]
	}
})


#' @rdname extractions
#' @export
setMethod('$', 'DiffusionMap', function(x, name) x[[name]])
#' @rdname extractions
#' @export
setMethod('$', 'DPT', function(x, name) x[[name]])

#' @include accessor-generics.r
NULL

#' DiffusionMap accession methods
#'
#' Get and set eigenvalues, eigenvectors, and sigma(s) of a \link{DiffusionMap} object.
#'
#' @param object  A DiffusionMap
#' @param value   Vector of eigenvalues or matrix of eigenvectors to get/set
#'
#' @return The assigned or retrieved value
#'
#' @seealso \link{Extraction methods}, \link{DiffusionMap methods}, \link{Coercion methods} for more
#'
#' @examples
#' data(guo)
#' dm <- DiffusionMap(guo)
#' eigenvalues(dm)
#' eigenvectors(dm)
#' sigmas(dm)
#' dataset(dm)
#' optimal_sigma(dm)
#'
#' @importFrom methods is setGeneric
#' @name DiffusionMap accession methods
#' @rdname DiffusionMap-accessors
#' @include sigmas.r
#' @include diffusionmap.r
NULL


#' @rdname DiffusionMap-accessors
#' @export
setMethod('eigenvalues', 'DiffusionMap', function(object) object@eigenvalues)

#' @rdname DiffusionMap-accessors
#' @export
setMethod('eigenvalues<-', 'DiffusionMap', function(object, value) {
	object@eigenvalues <- value
	object
})


#' @rdname DiffusionMap-accessors
#' @export
setMethod('eigenvectors', 'DiffusionMap', function(object) object@eigenvectors)

#' @rdname DiffusionMap-accessors
#' @export
setMethod('eigenvectors<-', 'DiffusionMap', function(object, value) {
	object@eigenvectors <- value
	validObject(object)
	object
})


#' @rdname DiffusionMap-accessors
#' @export
setMethod('sigmas', 'DiffusionMap', function(object) object@sigmas)

#' @rdname DiffusionMap-accessors
#' @export
setMethod('sigmas<-', 'DiffusionMap', function(object, value) {
	object@sigmas <- value
	validObject(object)
	object
})


#' @rdname DiffusionMap-accessors
#' @export
setMethod('dataset', 'DiffusionMap', function(object) object@data_env$data)

#' @rdname DiffusionMap-accessors
#' @export
setMethod('dataset<-', 'DiffusionMap', function(object, value) {
	object@data_env$data <- value
	validObject(object)
	object
})


#' @rdname DiffusionMap-accessors
#' @export
setMethod('distance', 'DiffusionMap', function(object) object@distance)

#' @rdname DiffusionMap-accessors
#' @export
setMethod('distance<-', 'DiffusionMap', function(object, value) {
	object@distance <- value
	validObject(object)
	object
})


#' @rdname DiffusionMap-accessors
#' @export
setMethod('optimal_sigma', 'DiffusionMap', function(object) optimal_sigma(sigmas(object)))

#' @include dpt.r
NULL

#' DPT methods
#'
#' Methods for the \link{DPT} class. \code{branch_divide} subdivides branches for plotting (see the examples).
#'
#' @param dpt,object  DPT object
#' @param divide      Vector of branch numbers to use for division
#' @param value       Value of slot to set
#'
#' @return \code{branch_divide} and \code{dataset<-} return the changed object, \code{dataset} the extracted data, and \code{tips} the tip indices.
#'
#' @examples
#' data(guo_norm)
#' dpt <- DPT(DiffusionMap(guo_norm))
#' dpt_9_branches <- branch_divide(dpt, 1:3)
#' plot(dpt_9_branches, col_by = 'branch')
#'
#' @seealso \link{plot.DPT} uses \code{branch_divide} for its \code{divide} argument.
#'
#' @aliases dataset.DPT
#' @name DPT methods
#' @rdname DPT-methods
NULL

#' @importFrom stats na.omit
#' @rdname DPT-methods
#' @export
branch_divide <- function(dpt, divide = integer(0L)) {
	check_dpt(dpt)
	if (length(divide) == 0L) return(dpt)

	for (b in divide) {
		super_rows <- dpt@branch[, 1] == b & !is.na(dpt@branch[, 1])
		if (!any(super_rows)) {
			available <- na.omit(unique(dpt@branch[, 1]))
			stop('invalid branch to divide ', b, ' not in ', available)
		}

		# shift sub branches/tips to the left
		dpt@branch[super_rows, ] <- cbind(dpt@branch[super_rows, -1], NA)
		dpt@tips  [super_rows, ] <- cbind(dpt@tips  [super_rows, -1], NA)

		# TODO: maybe also modify DPT?
	}

	vacant_levels <- apply(dpt@branch, 2L, function(col) all(is.na(col)))
	dpt@branch <- dpt@branch[, !vacant_levels]
	dpt@tips   <- dpt@tips  [, !vacant_levels]

	dpt
}

#' @rdname DPT-methods
#' @export
tips <- function(dpt) {
	check_dpt(dpt)
	tip_idx <- dpt@tips[, 1]
	branch_order <- order(dpt@branch[tip_idx, 1])
	which(tip_idx)[branch_order]
}

#' @rdname DPT-methods
#' @export
setMethod('dataset', 'DPT', function(object) dataset(object@dm))

#' @rdname DPT-methods
#' @export
setMethod('dataset<-', 'DPT', function(object, value) {
	dataset(object@dm) <- value
	validObject(object)
	object
})

check_dpt <- function(dpt) if (!is(dpt, 'DPT')) stop('branch_divide needs to be called on a DPT object, not a ', class(dpt))

#' @include sigmas.r
#' @include s4-unions.r
#' @useDynLib destiny
NULL

sigma_msg <- function(sigma) {
	sprintf(
		"The sigma parameter needs to be NULL, 'local', 'global', numeric or a %s object, not a %s.",
		sQuote('Sigmas'), sQuote(class(sigma)))
}

#' Create a diffusion map of cells
#'
#' The provided data can be a double \link[base]{matrix} of expression data or a \link[base]{data.frame} with all non-integer (double) columns
#' being treated as expression data features (and the others ignored), an \link[Biobase:class.ExpressionSet]{ExpressionSet}, or a \link[SingleCellExperiment]{SingleCellExperiment}.
#'
#' @param data           Expression data to be analyzed and covariates. Provide \code{vars} to select specific columns other than the default: all double value columns.
#'                       If \code{distance} is a distance matrix, \code{data} has to be a \code{\link{data.frame}} with covariates only.
#' @param sigma          Diffusion scale parameter of the Gaussian kernel. One of \code{'local'}, \code{'global'}, a (\link[base]{numeric}) global sigma or a \link{Sigmas} object.
#'                       When choosing \code{'global'}, a global sigma will be calculated using \code{\link{find_sigmas}}. (Optional. default: \code{'local'})
#'                       A larger sigma might be necessary if the eigenvalues can not be found because of a singularity in the matrix
#' @param k              Number of nearest neighbors to consider (default: a guess betweeen 100 and \eqn{n - 1}. See \code{\link{find_dm_k}}).
#' @param n_eigs         Number of eigenvectors/values to return (default: 20)
#' @param density_norm   logical. If TRUE, use density normalisation
#' @param ...            Unused. All parameters to the right of the \code{...} have to be specified by name (e.g. \code{DiffusionMap(data, distance = 'cosine')})
#' @param distance       Distance measurement method applied to \code{data} or a distance matrix/\code{\link[stats]{dist}}. For the allowed values, see \code{\link{find_knn}}.
#'                       If this is a \code{\link[Matrix]{sparseMatrix}}, zeros are interpreted as "not a close neighbors",
#'                       which allows the use of kNN-sparsified matrices (see the return value of \code{\link{find_knn}}.
#' @param n_pcs          Number of principal components to compute to base calculations on. Using e.g. 50 DCs results in more regular looking diffusion maps.
#'                       The default NULL will not compute principal components, but use \code{reducedDims(data, 'pca')} if present. Set to NA to suppress using PCs.
#' @param n_local        If \code{sigma == 'local'}, the \code{n_local}th nearest neighbor(s) determine(s) the local sigma
#' @param rotate         logical. If TRUE, rotate the eigenvalues to get a slimmer diffusion map
#' @param censor_val     Value regarded as uncertain. Either a single value or one for every dimension (Optional, default: censor_val)
#' @param censor_range   Uncertainity range for censoring (Optional, default: none). A length-2-vector of certainty range start and end. TODO: also allow \eqn{2\times G} matrix
#' @param missing_range  Whole data range for missing value model. Has to be specified if NAs are in the data
#' @param vars           Variables (columns) of the data to use. Specifying NULL will select all columns (default: All floating point value columns)
#' @param knn_params     Parameters passed to \code{\link{find_knn}}
#' @param verbose        Show a progressbar and other progress information (default: do it if censoring is enabled)
#' @param suppress_dpt   Specify TRUE to skip calculation of necessary (but spacious) information for \code{\link{DPT}} in the returned object (default: FALSE)
#'
#' @return A DiffusionMap object:
#'
#' @slot eigenvalues    Eigenvalues ranking the eigenvectors
#' @slot eigenvectors   Eigenvectors mapping the datapoints to \code{n_eigs} dimensions
#' @slot sigmas         \link{Sigmas} object with either information about the \link{find_sigmas} heuristic run or just local or \link{optimal_sigma}.
#' @slot data_env       Environment referencing the data used to create the diffusion map
#' @slot eigenvec0      First (constant) eigenvector not included as diffusion component.
#' @slot transitions    Transition probabilities. Can be NULL
#' @slot d              Density vector of transition probability matrix
#' @slot d_norm         Density vector of normalized transition probability matrix
#' @slot k              The k parameter for kNN
#' @slot n_pcs          Number of principal components used in kNN computation (NA if raw data was used)
#' @slot n_local        The \code{n_local}th nearest neighbor(s) is/are used to determine local kernel density
#' @slot density_norm   Was density normalization used?
#' @slot rotate         Were the eigenvectors rotated?
#' @slot distance       Distance measurement method used
#' @slot censor_val     Censoring value
#' @slot censor_range   Censoring range
#' @slot missing_range  Whole data range for missing value model
#' @slot vars           Vars parameter used to extract the part of the data used for diffusion map creation
#' @slot knn_params     Parameters passed to \code{\link{find_knn}}
#'
#' @seealso \link{DiffusionMap methods} to get and set the slots. \code{\link{find_sigmas}} to pre-calculate a fitting global \code{sigma} parameter
#'
#' @examples
#' data(guo)
#' DiffusionMap(guo)
#' DiffusionMap(guo, 13, censor_val = 15, censor_range = c(15, 40), verbose = TRUE)
#'
#' covars <- data.frame(covar1 = letters[1:100])
#' dists <- dist(matrix(rnorm(100*10), 100))
#' DiffusionMap(covars, distance = dists)
#'
#' @importFrom methods setClass validObject
#' @rdname DiffusionMap-class
#' @export
setClass( # nolint: cyclocomp_linter.
	'DiffusionMap',
	slots = c(
		eigenvalues   = 'numeric',
		eigenvectors  = 'matrix',
		sigmas        = 'Sigmas',
		data_env      = 'environment',
		eigenvec0     = 'numeric',
		transitions   = 'dMatrixOrNULL',
		d             = 'numeric',
		d_norm        = 'numeric',
		k             = 'integer',
		n_pcs         = 'integer',
		n_local       = 'integer',
		density_norm  = 'logical',
		rotate        = 'logical',
		distance      = 'character',
		censor_val    = 'numericOrNULL',
		censor_range  = 'numericOrNULL',
		missing_range = 'numericOrNULL',
		vars          = 'characterOrnumericOrNULL',
		knn_params    = 'list'),
	validity = function(object) {
		# don't use getters as thisfunction is used in them!
		if (!is.vector(object@eigenvalues) || !is.numeric(object@eigenvalues))
			'eigenvalues(dm) has to be a numeric vector'
		else if (!is.matrix(object@eigenvectors) || !is.numeric(object@eigenvectors))
			'eigenvectors(dm) has to be a numeric matrix'
		else if (length(object@eigenvalues) != ncol(object@eigenvectors))
			'There must be exactly one eigenvalue per eigenvector: length(eigenvalues(dm)) == ncol(eigenvectors(dm))'
		else if (!isTRUE(validObject(object@sigmas, test = TRUE)))
			paste('sigmas invalid:', validObject(object@sigmas, test = TRUE))
		#TODO: validate data_env (data, accumulated_transitions) and eigenvec0
		else if (length(object@d) != nrow(object@eigenvectors))
			'd must be as long as each eigenvector'
		else if (length(object@k) != 1)
			'k must be a number'
		else if (length(object@density_norm) != 1)
			'density_norm must be TRUE or FALSE'
		else if (length(object@rotate) != 1)
			'rotate must be TRUE or FALSE'
		else if (!(object@distance %in% c('euclidean', 'cosine', 'rankcor', 'l2', 'custom')))
			'distance must be "euclidean", "cosine", "rankcor", or "l2"'
		else if (is.null(object@censor_val) != is.null(object@censor_range))
			'Both censor_val and censor_range either need to be NULL or not'
		else if (!is.null(object@censor_val) && length(object@censor_val) != 1)
			'censor_val must be a number'
		else if (!is.null(object@censor_range) && (length(object@censor_range) != 2 || diff(object@censor_range) <= 0))
			'censor_range must be a increasing range (two numbers, the left one being larger)'
		else if (!is.null(object@missing_range) && (length(object@missing_range) != 2 || diff(object@missing_range) <= 0))
			'missing_range must be a increasing range (two numbers, the left one being larger)'
		#TODO validate vars
		else TRUE
	})

#' @importFrom methods new as is
#' @importFrom Matrix Diagonal colSums rowSums t
#' @importFrom VIM hotdeck
#' @importFrom SingleCellExperiment reducedDimNames reducedDim<-
#' @rdname DiffusionMap-class
#' @export
DiffusionMap <- function( # nolint: object_name_linter, cyclocomp_linter.
	data = stopifnot_distmatrix(distance),
	sigma = 'local',
	k = find_dm_k(dataset_n_observations(data, distance) - 1L),
	n_eigs = min(20L, dataset_n_observations(data, distance) - 2L),
	density_norm = TRUE,
	...,
	distance = c('euclidean', 'cosine', 'rankcor', 'l2'),
	n_pcs = NULL,
	n_local = seq(to = min(k, 7L), length.out = min(k, 3L)),
	rotate = FALSE,
	censor_val = NULL, censor_range = NULL,
	missing_range = NULL,
	vars = NULL,
	knn_params = list(),
	verbose = !is.null(censor_range),
	suppress_dpt = FALSE
) {
	# make sure those promises are resolved before we mess with `data`
	force(k)
	force(n_eigs)

	chkDots(...)

	if (is.null(sigma) || !is(sigma, 'Sigmas') && isTRUE(is.na(sigma)))
		sigma <- 'local'
	if (!is(sigma, 'Sigmas') && !(length(sigma) == 1L && sigma %in% c('local', 'global')) && !is.numeric(sigma))
		stop(sigma_msg(sigma))

	if (identical(sigma, 'local') && any(n_local > k))
		stop('For local sigma, All entries of n_local (', paste(n_local, collapse = ','), ') have to be \u2264 k (', k, ')')

	# store away data and continue using imputed, unified version
	data_env <- new.env(parent = .GlobalEnv)

	if (is_distmatrix(distance)) {
		if (!(is.data.frame(data) || is.null(data))) stop('If you provide a matrix for `distance`, `data` has to be NULL or a covariate `data.frame` is of class', class(data))
		if (!is.null(n_pcs)) stop('If you provide a matrix for `distance`, `n_pcs` has to be NULL')

		data_env$data <- if (is.null(data)) distance else data  # put covariates or distance
		dists <- as(distance, 'symmetricMatrix')
		if (!is.null(rownames(data_env$data))) rownames(dists) <- colnames(dists) <- rownames(data)
		distance <- 'custom'
		imputed_data <- data_or_pca <- NULL
		n <- nrow(dists)
	} else {
		dists <- NULL
		distance <- match.arg(distance)

		data_env$data <- data
		data <- dataset_extract_doublematrix(data, vars)
		imputed_data <- data
		if (anyNA(imputed_data))
			imputed_data <- as.matrix(hotdeck(data, imp_var = FALSE))
		n <- nrow(imputed_data)

		# PCA
		pca <- get_pca(imputed_data, data_env$data, n_pcs, verbose)
		if (is.null(pca) && ncol(imputed_data) > 500L) {
			warning('You have ', ncol(imputed_data), ' genes. Consider passing e.g. n_pcs = 50 to speed up computation.')
		}
		if (is.null(pca)) {
			n_pcs <- NA_integer_
			data_or_pca <- imputed_data
		} else {
			n_pcs <- ncol(pca)
			data_or_pca <- pca
			# Update PCA in SCE if there was none
			if (is(data_env$data, 'SingleCellExperiment') && !('pca' %in% reducedDimNames(data_env$data)))
				reducedDim(data_env$data, 'pca') <- pca
		}
	}

	# arg validation

	if (n <= n_eigs + 1L) stop('Eigen decomposition not possible if n \u2264 n_eigs+1 (And ', n, ' \u2264 ', n_eigs + 1L, ')')

	if (is.null(k) || is.na(k)) k <- n - 1L
	#TODO: optimize case `dense <- k == n - 1L`

	if (k >= n) stop(sprintf('k has to be < nrow(data) (And %s \u2265 nrow(data))', k))

	censor <- test_censoring(censor_val, censor_range, imputed_data, missing_range)

	if (censor && !identical(distance, 'euclidean')) stop('censoring model only valid with euclidean distance')

	knn <- get_knn(data_or_pca, dists, k, distance, knn_params, verbose)  # use dists if given, else compute from pca if available, else from data

	sigmas <- get_sigmas(imputed_data, knn$dist, sigma, n_local, distance, censor_val, censor_range, missing_range, vars, verbose)
	sigma <- optimal_sigma(sigmas)  # single number = global, multiple = local

	trans_p <- transition_probabilities(imputed_data, sigma, knn$dist_mat, censor, censor_val, censor_range, missing_range, verbose)
	rm(knn)  # free memory

	d <- rowSums(trans_p, na.rm = TRUE) + 1 # diagonal set to 1

	# normalize by density if requested
	norm_p <- get_norm_p(trans_p, d, d, density_norm)
	rm(trans_p)  # free memory

	d_norm <- rowSums(norm_p)

	# calculate the inverse of a diagonal matrix by inverting the diagonal
	d_rot <- Diagonal(x = d_norm ^ -.5)
	transitions <- as(d_rot %*% norm_p %*% d_rot, 'symmetricMatrix')
	rm(norm_p)  # free memory

	eig_transitions <- decomp_transitions(transitions, n_eigs + 1L, verbose)

	eig_vec <- eig_transitions$vectors
	eig_val <- eig_transitions$values
	if (rotate) eig_vec <- as.matrix(t(t(eig_vec) %*% d_rot))
	rownames(eig_vec) <-
		rownames(transitions) <-
		colnames(transitions) <-
		rownames(if (!is.null(rownames(dists))) dists else data)
	colnames(eig_vec) <-
		names(eig_val) <-
		paste0('DC', seq(0, n_eigs))

	new(
		'DiffusionMap',
		eigenvalues   = eig_val[-1],
		eigenvectors  = eig_vec[, -1, drop = FALSE],
		sigmas        = sigmas,
		data_env      = data_env,
		eigenvec0     = eig_vec[, 1],
		transitions   = if (suppress_dpt) NULL else transitions,
		d             = d,
		d_norm        = d_norm,
		k             = as.integer(k),
		n_pcs         = as.integer(n_pcs),
		n_local       = as.integer(n_local),
		rotate        = rotate,
		density_norm  = density_norm,
		distance      = distance,
		censor_val    = censor_val,
		censor_range  = censor_range,
		missing_range = missing_range,
		knn_params    = knn_params)
}


is_distmatrix <- function(distance) {
	if (is.character(distance))
		FALSE
	else if ((is.matrix(distance) && diff(dim(distance)) == 0L) || is(distance, 'dist') || is(distance, 'symmetricMatrix'))
		TRUE
	else
		stop(
			'`distance` needs to be a distance measure or a square matrix, but is a ',
			class(dist), ' of dim ', nrow(distance), ' by ', ncol(distance))
}


stopifnot_distmatrix <- function(distance) {
	if (is_distmatrix(distance)) NULL
	else stop('`data`` needs to be set if `distance` is a distance measure')
}


#' @importFrom methods new is
get_sigmas <- function(imputed_data, nn_dists, sigma, n_local, distance = 'euclidean', censor_val = NULL, censor_range = NULL, missing_range = NULL, vars = NULL, verbose = FALSE) {
	unspecified_local <- identical(sigma, 'local')
	if (unspecified_local || is.numeric(sigma)) {
		if (unspecified_local) {
			sig_mat <- nn_dists[, n_local, drop = FALSE]
			sigma <- rowSums(sig_mat) / length(n_local) / 2
		}
		new('Sigmas',
			log_sigmas    = NULL,
			dim_norms     = NULL,
			optimal_sigma = sigma,
			optimal_idx   = NULL,
			avrd_norms    = NULL)
	} else if (identical(sigma, 'global')) {
		if (!identical(distance, 'euclidean'))
			stop(sprintf('You have to use euclidean distances with sigma estimation, not %s.', sQuote(distance)))

		find_sigmas(
			imputed_data,
			distance = distance,
			censor_val = censor_val,
			censor_range = censor_range,
			missing_range = missing_range,
			vars = vars,
			verbose = verbose)
	} else if (is(sigma, 'Sigmas')) {
		sigma
	} else {
		stop(sigma_msg(sigma))
	}
}


#' @importFrom methods hasMethod
#' @importFrom SingleCellExperiment reducedDimNames reducedDim
get_pca <- function(data_mat, data_raw, n_pcs, verbose = FALSE) { # nolint: cyclocomp_linter.
	stopifnot(is.null(n_pcs) || length(n_pcs) == 1L)
	# If we suppress PCA computation, return NULL
	if (isTRUE(is.na(n_pcs))) return(NULL)

	# get PCs from SingleCellExperiment if possible
	existing_pca <- if (hasMethod('reducedDim', class(data_raw))) reducedDim(data_raw, 'pca')
	if (!is.null(existing_pca)) {
		if (is.null(n_pcs) || n_pcs == ncol(existing_pca)) {
			if (verbose) cat('Using reducedDim(data, "pca") to compute distances\n')
			return(existing_pca)
		} else if (n_pcs < ncol(existing_pca)) {
			warning('Specified n_pcs < ncol(reducedDim(data, "pca")), using subset')
			return(existing_pca[, seq_len(n_pcs), drop = FALSE])
		} else { #: n_pcs > ncol(pcs)
			warning('Specified n_pcs > ncol(reducedDim(data, "pca")), recalculating PCA')
		}
	} else if (is.null(n_pcs)) {
		# If n_pcs is NULL, data would need to have a PCA
		return(NULL)
	}

	# No PCA in data or requested more PCs
	if (ncol(data_mat) < n_pcs) stop('Cannot compute ', n_pcs, ' PCs from data with ', ncol(data_mat), ' columns.')
	pca_scores(data_mat, n_pcs)
}


get_knn <- function(imputed_data, dists, k, distance = 'euclidean', knn_params = list(), verbose = FALSE) {
	stopifnot(is.null(imputed_data) != is.null(dists))

	if (!is.null(dists)) {
		nn_dist <- t(apply(dists, 1, function(row) sort(row)[2:k]))
		list(dist = nn_dist, dist_mat = dists)
	} else {
		tryCatch({
			verbose_timing(verbose, 'finding knns', do.call(find_knn, c(list(imputed_data, k, distance = distance), knn_params)))
		}, error = function(e) stop('Could not call find_knn. Consider specifying `knn_params = list(M = <larger number>)`. Original error:\n', e$message, call. = FALSE))
	}
}


#' @importFrom Matrix sparseMatrix diag<- drop0 forceSymmetric skewpart symmpart
#' @importFrom utils txtProgressBar setTxtProgressBar
transition_probabilities <- function(imputed_data, sigma, dists, censor, censor_val, censor_range, missing_range, verbose) {
	n <- nrow(dists)

	# create markovian transition probability matrix (trans_p)

	cb <- if (verbose) {
		pb <- txtProgressBar(1, n, style = 3)
		function(i) setTxtProgressBar(pb, i)
	} else {
		invisible
	}

	# initialize trans_p
	trans_p <- verbose_timing(verbose, 'Calculating transition probabilities', {
		if (censor)
			censoring(imputed_data, sigma, dists, censor_val, censor_range, missing_range, cb)
		else
			no_censoring(dists, sigma, cb)
	})

	if (verbose) close(pb)

	#nnzero

	# normalize trans_p and only retain intra-cell transitions
	diag(trans_p) <- 0
	trans_p <- drop0(trans_p)

	stopifnot(is(trans_p, 'symmetricMatrix'))
	trans_p
}

#' @importFrom Matrix sparseMatrix which tcrossprod
no_censoring <- function(dists, sigma, cb = invisible) {
	d2 <- dists ^ 2
	stopifnot(isSymmetric(d2))

	t_p <- if (length(sigma) == 1L) {
		exp(-d2@x / (2 * sigma ^ 2))
	} else {
		stopifnot(d2@uplo == 'U')
		coords <- as(d2, 'TsparseMatrix')
		i <- coords@i + 1L
		j <- coords@j + 1L
		sig2 <- sigma^2

		s1 <- sigma[i] * sigma[j]
		s2 <- sig2[i] + sig2[j]
		sqrt(2 * s1 / s2) * exp(-d2@x / s2)
	}

	sparseMatrix(d2@i, p = d2@p, x = t_p, dims = dim(d2), symmetric = TRUE, index1 = FALSE)
}


#' @importFrom methods as
#' @importFrom Matrix sparseMatrix
get_norm_p <- function(trans_p, d, d_new, density_norm) {
	if (density_norm) {
		trans_p <- as(trans_p, 'dgTMatrix') # use non-symmetric triples to operate on all values
		stopifsmall(max(trans_p@x, na.rm = TRUE))

		#creates a dgCMatrix
		sparseMatrix(trans_p@i, trans_p@j, x = trans_p@x / (d_new[trans_p@i + 1] * d[trans_p@j + 1]), dims = dim(trans_p), index1 = FALSE)
	} else {
		trans_p
	}
}


decomp_transitions <- function(transitions, n_eigs, verbose) {
	verbose_timing(verbose, 'performing eigen decomposition', eig_decomp(transitions, n_eigs))
}

context('ggplot')

data(guo_norm)

guo_df <- as(guo_norm, 'data.frame')
guo_32    <- guo_df[guo_df$num_cells == 32, ]
guo_no_32 <- guo_df[guo_df$num_cells != 32, ]
dm_no_32 <- DiffusionMap(guo_no_32)

#3d. no idea how to test this
if (FALSE) {
	plot.DiffusionMap(dm_no_32, 1:3, col_by = 'num_cells',                pch = 20)
	plot.DiffusionMap(dm_no_32, 1:3, col_by = 'num_cells', ticks =  TRUE, pch = 20)
	plot.DiffusionMap(dm_no_32, 1:3, col_by = 'num_cells', axes  = FALSE, pch = 20)
	plot.DiffusionMap(dm_no_32, 1:3, col_by = 'num_cells', box   =  TRUE, pch = 20)
}

test_that('ggplot plots have the ticks/boxes they should have', {
	p1 <- plot.DiffusionMap(dm_no_32, 1:2, col_by = 'num_cells')
	p2 <- plot.DiffusionMap(dm_no_32, 1:2, col_by = 'num_cells', ticks =  TRUE)
	p3 <- plot.DiffusionMap(dm_no_32, 1:2, col_by = 'num_cells', axes  = FALSE)
	p4 <- plot.DiffusionMap(dm_no_32, 1:2, col_by = 'num_cells', box   =  TRUE)

	# check range_frame
	expect_identical(length(p1$layers), 2L)
	expect_identical(length(p2$layers), 2L)
	expect_identical(length(p3$layers), 1L)
	expect_identical(length(p4$layers), 2L)

	# check ticks
	expect_match(class(p1$theme$axis.ticks)[[1L]], 'element_blank$')
	expect_match(class(p2$theme$axis.ticks)[[1L]], 'element_line$')
	expect_match(class(p3$theme$axis.ticks)[[1L]], 'element_blank$')
	expect_match(class(p4$theme$axis.ticks)[[1L]], 'element_blank$')

	# check box
	expect_match(class(p1$theme$panel.border)[[1L]], 'element_blank$')
	expect_match(class(p2$theme$panel.border)[[1L]], 'element_blank$')
	expect_match(class(p3$theme$panel.border)[[1L]], 'element_blank$')
	expect_match(class(p4$theme$panel.border)[[1L]], 'element_rect$')
})

context('gene relevance')

smps <- 120L
part <- 1 / 4
test_data <- local({
	d <- data.frame(
	  A = c(seq(1,  0, length = smps * part), rep(0, smps * 3 * part)),
		B = c(seq(0,  1, length = smps * 2 * part), rep(1, smps * 2 * part)),
		C = c(rep(0, smps * part), seq(0,  1, length = smps * 2 * part), rep(0, smps * part)),
		D = c(rep(0, smps * part), seq(0, .5, length = smps * part), rep(0, smps * part), seq(.5, 1, length = smps * part)), #: + rnorm(smps, 0, .05)
		stringsAsFactors = FALSE
	)
	d$Cell <- seq_len(nrow(d))
	d$Type <- as.integer(ceiling(d$Cell / (smps / 4)))
	d
})

test_that('Gene Relevance returns the right genes', {
	set.seed(0)
	dm <- DiffusionMap(test_data, distance = 'rankcor')
	gr <- gene_relevance(dm,  smooth = FALSE)
	gr_plot <- plot_gene_relevance(gr, iter_smooth = 0, n_top = 1)
	skip('Not yet stable')
	expect_identical(gr_plot$ids[1:2], c('D', 'C'))
})

context('basic functionality')

test_that('DiffusionMap works', {
	data(guo_norm)
	dm <- DiffusionMap(guo_norm)
	expect_identical(dm@distance, 'euclidean')
})

test_that('Eigenvectors retain cell names', {
	data(guo_norm)
	dm <- DiffusionMap(guo_norm)
	expect_identical(rownames(dm@eigenvectors), Biobase::sampleNames(guo_norm))
})

test_that('DM works with dist matrices', {
	data(guo_norm)
	dists <- as(dist(t(Biobase::exprs(guo_norm))), 'sparseMatrix')
	rownames(dists) <- colnames(dists) <- Biobase::sampleNames(guo_norm)
	dm <- DiffusionMap(distance = dists)
	expect_identical(rownames(dm@eigenvectors), rownames(dists))
})

context('distance metrics')

library(Matrix)

full_t_p_local <- function(dat, sigma, dists) {
	d2 <- as.matrix(dists ^ 2)

	s1 <- sigma %*% t(sigma)
	s2 <- outer(sigma ^ 2, sigma ^ 2, '+')

	rv <- sqrt(2 * s1 / s2) * exp(-d2 / s2)
	rv[d2 == 0] <- 0
	rv
}

test_that('no_censoring produces the correct output for local sigma', {
	test_data <- matrix(rnorm(4L * 5L), 4L, 5L)
	k <- 3L
	n_local <- 2:3

	knn <- find_knn(test_data, k)
	expect_identical(dim(knn$dist), c(nrow(test_data), k))
	expect_identical(dim(knn$dist_mat), rep(nrow(test_data), 2L))
	expect_identical(sum(!is.finite(knn$dist_mat)), 0L)

	sigma <- optimal_sigma(get_sigmas(test_data, knn$dist, 'local', n_local))
	expect_identical(length(sigma), nrow(test_data))

	dists_expected <- full_t_p_local(test_data, sigma, knn$dist_mat)
	dists <- no_censoring(knn$dist_mat, sigma)
	expect_equal(dim(dists), dim(dists_expected))
	expect_equal(as.matrix(dists), dists_expected)
})

emptyplot <- function(xlim = c(0, 1), ylim = xlim, asp = 1, frame.plot = FALSE, col = NULL, ...) { # nolint: object_name_linter.
	plot(0, type = 'n', xlab = '', ylab = '', asp = asp, axes = FALSE,
	     frame.plot = frame.plot, xlim = xlim, ylim = ylim, xaxs = 'i',
	     yaxs = 'i', ...)
	if (!is.null(col))
		rect(xlim[1], ylim[1], xlim[2], ylim[2], col = col)
}

#' @importFrom grDevices palette
#' @importFrom scales colour_ramp rescale
continuous_colors <- function(vals, pal = palette(), limits = NULL, levels = 100) {
	if (is.function(pal))
		pal <- pal(levels)

	if (is.null(limits))
		limits <- range(vals, na.rm = TRUE)

	ramp <- colour_ramp(pal, alpha = TRUE)

	ramp(rescale(vals, from = limits))
}

bad_default_palette <- c('black', 'red', 'green3', 'blue', 'cyan', 'magenta', 'yellow', 'gray')
#this is a reshuffled Set3, but RColorBrewer doesn’t work in .onLoad due to using rgb() unconditionally
gud_default_palette <- c('#8DD3C7', '#FFED6F', '#BEBADA', '#FB8072', '#80B1D3', '#FDB462', '#B3DE69', '#BC80BD', '#FCCDE5', '#D9D9D9', '#CCEBC5', '#FFFFB3')

# do not use .Call.graphics like grDevices::palette
#' @importFrom utils getFromNamespace
set_palette <- function(v) {
	cp <- getFromNamespace('C_palette', 'grDevices')
	do.call(.Call, list(cp, v))  # do.call is needed to get around static analysis
}

.onLoad <- function(libname, pkgname) {
	if (identical(palette(), gud_default_palette) ||
			!identical(tryCatch(proxy::pr_DB$get_entry('rankcorrelation'), error = function(e) NULL), NULL)) {
		return()
	}
	if (identical(palette(), bad_default_palette)) {
		set_palette(gud_default_palette)
	}
	proxy_add_rankcor_simil()
}

# Smooth Using Gaussian Window
# 
# The specific function for smoothing using the gaussian window function
# @param x numeric vector of values to smooth, error will be thrown if not provided.
# @param window the length of the smoothing window, if an integer, represents
# number of items, else, if a value between \code{0} and \code{1}, represents the 
# proportion of the input vector
# @param alpha parameter to determine the breadth of the gaussian window, yielding more or less sensitive 
# smoothing characteristics
# @param ... not used
# @param tails Logical value as to whether the tail regions should be included or not.
smth.gaussian <- function(
	x       = stop("Numeric Vector 'x' is Required"),
  window  = getOption('smoother.window', 0.1),
  alpha   = getOption('smoother.gaussianwindow.alpha', 2.5),
  ...,
  tails   = getOption('smoother.tails', FALSE)){
	
	if (!is.numeric(x) | !is.numeric(alpha)) {
		stop("argument 'x' and 'alpha' must be numeric", call. = FALSE)
	}
	windowLength = .determineWindowLength(x, window)
	makeWindow = function(w, a) {
		hw = abs(w/2)
		e = exp(1)
		a = abs(a)
		ret = sapply(c(0:(w - 1)), function(x) {
			n = x - as.integer(hw)
			k = -0.5 * (a * n/hw)^2
			e^k
		})
		ret
	}
	w = makeWindow(windowLength, alpha[1])
	sizeW = length(w)
	sizeD = length(x)
	w = .normalize(w)
	hkwL = as.integer(sizeW/2)
	hkwR = sizeW - hkwL
	ret = sapply(c(1:sizeD), function(i) {
		ix.d = c((i - hkwL):(i + hkwR - 1))
		ix.w = which(ix.d %in% 1:sizeD)
		ix.d = ix.d[ix.w]
		W.nm = if(length(ix.w) != sizeW){.normalize(w[ix.w])}else{w}
		D.nm = x[ix.d]
		as.numeric(D.nm %*% W.nm)
	})
	if (!tails) {
		ret[c(1:hkwL, (sizeD - hkwR + 1):sizeD)] = NA
	}
	ret
}

.determineWindowLength = function (x, w) {
	if (!is.numeric(x) | !is.numeric(w)) {
		stop("Arguments 'x' and 'w' must be numeric")
	}
	l = length(x)
	w.orig = w
	if (w > 0 && w < 1) {
		w = w * l
	}
	ret = as.integer(max(abs(w[1]), 1))
	if (length(x) <= ret | ret < 1) {
		stop(paste("Resultant window length is out of range (", 
							 ret, "), must be >= 1", sep = ""), call. = FALSE)
	}
	return(ret)
}

.normalize = function(x) {
	if (!is.numeric(x)) {
		stop("argument 'x' must be numeric")
	}
	if (length(x) == 1) {
		return(1)
	}
	total = sum(x)
	if (total == 0) {
		stop("argument 'x' must not sum to zero")
	}
	return(x/total)
}

#' Projection distance
#'
#' @param dm        A \code{\link{DiffusionMap}} object.
#' @param new_dcs   Diffusion component matrix of which to calculate the distance to the data.
#' @param ...       Passed to \code{\link[proxy:dist]{proxy::dist}} if \code{new_data} was passed.
#' @param new_data  New data points to project into the diffusion map.
#'                  Can be a \link[base]{matrix}, \link[base]{data.frame},
#'                  \link[Biobase:class.ExpressionSet]{ExpressionSet},
#'                  or \link[SingleCellExperiment]{SingleCellExperiment}.
#' @param verbose   If \code{\link{TRUE}}, log additional info to the console.
#'
#' @return A vector of distances each new data point has to the existing data.
#'
#' @examples
#' data(guo_norm)
#' g2_32 <- guo_norm[, guo_norm$num_cells < 64]
#' g64  <- guo_norm[, guo_norm$num_cells == 64]
#' dm <- DiffusionMap(g2_32)
#' d <- projection_dist(dm, new_data = g64)
#'
#' @export
projection_dist <- function(dm, new_dcs = NULL, ..., new_data, verbose = FALSE) {
	if (is.null(new_dcs))
		new_dcs <- dm_predict(dm, new_data, ..., verbose = verbose)
	else if (!missing(new_data))
		stop('only pass one of new_dcs and new_data')

	evs <- eigenvectors(dm)

	nns <- find_knn(evs, 1, query = as.matrix(new_dcs))

	nn_dist <- nns$dist[, 1]

	nn_dist
}

#' @include gene-relevance.r
NULL

#' Plot gene relevance or differential map
#'
#' \code{plot(gene_relevance, 'Gene')} plots the differential map of this/these gene(s),
#' \code{plot(gene_relevance)} a relevance map of a selection of genes.
#' Alternatively, you can use \code{plot_differential_map} or \code{plot_gene_relevance} on a \code{\link[=gene_relevance]{GeneRelevance}} or \code{\link{DiffusionMap}} object, or with two matrices.
#'
#' @param x            \code{\link[=gene_relevance]{GeneRelevance}} object.
#' @param y            Gene name(s) or index/indices to create differential map for. (integer or character)
#' @param coords       A \code{\link{DiffusionMap}}/\code{\link[=gene_relevance]{GeneRelevance}} object or a cells \eqn{\times} dims \code{\link{matrix}}.
#' @param exprs        An cells \eqn{\times} genes \code{\link{matrix}}. Only provide if \code{coords} is a matrix.
#' @param ...          Passed to \code{plot_differential_map}/\code{plot_gene_relevance}.
#' @param iter_smooth  Number of label smoothing iterations to perform on relevance map.
#'                     The higher the more homogenous and the less local structure.
#' @param n_top        Number the top n genes per cell count towards the score defining which genes to return and plot in the relevance map.
#' @param genes        Genes to base relevance map on (vector of strings).
#'                     You can also pass an index into the gene names (vector of numbers or logicals with length > 1).
#'                     The default NULL means all genes.
#' @param dims         Names or indices of dimensions to plot. When not plotting a \code{\link[=gene_relevance]{GeneRelevance}} object, the relevance for the dimensions \code{1:max(dims)} will be calculated.
#' @param pal          Palette. Either A colormap function or a list of colors.
#' @param col_na       Color for cells that end up with no most relevant gene.
#' @param bins         Number of hexagonal bins for \code{plot_gene_relevance_rank}.
#' @param limit        Limit the amount of displayed gene labels to the amount of available colors in \code{pal}?
#' @param faceter      A ggplot faceter like \code{\link[ggplot2]{facet_wrap}(~ Gene)}.
#'
#' @return ggplot2 plot, when plotting a relevance map with a list member \code{$ids} containing the gene IDs used.
#'
#' @seealso \code{\link{gene_relevance}}, \link{Gene Relevance methods}
#'
#' @examples
#' data(guo_norm)
#' dm <- DiffusionMap(guo_norm)
#' gr <- gene_relevance(dm)
#' plot(gr)          # or plot_gene_relevance(dm)
#' plot(gr, 'Fgf4')  # or plot_differential_map(dm, 'Fgf4')
#'
#' guo_norm_mat <- t(Biobase::exprs(guo_norm))
#' pca <- prcomp(guo_norm_mat)$x
#' plot_gene_relevance(pca, guo_norm_mat, dims = 2:3)
#' plot_differential_map(pca, guo_norm_mat, genes = c('Fgf4', 'Nanog'))
#'
#' @name Gene Relevance plotting
#' @rdname Gene-Relevance-plotting
NULL

#' @rdname Gene-Relevance-plotting
#' @export
setMethod('plot', c('GeneRelevance', 'character'), function(x, y, ...) plot_differential_map(x, genes = y, ...))
#' @rdname Gene-Relevance-plotting
#' @export
setMethod('plot', c('GeneRelevance', 'numeric'),   function(x, y, ...) plot_differential_map(x, genes = y, ...))

#' @rdname Gene-Relevance-plotting
#' @export
setMethod('plot', c('GeneRelevance', 'missing'), function(x, y, ...) plot_gene_relevance(x, ...))

#' @rdname Gene-Relevance-plotting
#' @export
setGeneric('plot_gene_relevance', function(coords, exprs, ..., iter_smooth = 2L, n_top = 10L, genes = NULL, dims = 1:2, pal = palette(), col_na = 'grey', limit = TRUE) {
	standardGeneric('plot_gene_relevance')
})

#' @rdname Gene-Relevance-plotting
#' @export
setMethod('plot_gene_relevance', c('matrix', 'matrix'), function(coords, exprs, ..., iter_smooth, n_top, genes, dims, pal, col_na, limit) {
	plot_gene_relevance_impl(gene_relevance(coords, exprs, dims = seq_len(max(dims))), iter_smooth = iter_smooth, n_top = n_top, genes = genes, dims = dims, pal = pal, col_na = col_na, limit = limit, ...)
})

#' @rdname Gene-Relevance-plotting
#' @export
setMethod('plot_gene_relevance', c('DiffusionMap', 'missing'), function(coords, exprs, ..., iter_smooth, n_top, genes, dims, pal, col_na, limit) {
	plot_gene_relevance_impl(gene_relevance(coords, dims = seq_len(max(dims))), iter_smooth = iter_smooth, n_top = n_top, genes = genes, dims = dims, pal = pal, col_na = col_na, limit = limit, ...)
})

#' @rdname Gene-Relevance-plotting
#' @export
setMethod('plot_gene_relevance', c('GeneRelevance', 'missing'), function(coords, exprs, ..., iter_smooth, n_top, genes, dims, pal, col_na, limit) {
	plot_gene_relevance_impl(coords, iter_smooth = iter_smooth, n_top = n_top, genes = genes, dims = dims, pal = pal, col_na = col_na, limit = limit, ...)
})

#' @importFrom rlang .data
#' @importFrom ggplot2 ggplot
#' @importFrom ggplot2 geom_point
#' @importFrom ggplot2 scale_color_manual
#' @importFrom ggplot2 ggtitle
#' @importFrom Biobase featureNames
#' @importFrom utils head
plot_gene_relevance_impl <- function(relevance_map, ..., iter_smooth, n_top, genes, dims, pal, col_na, limit) { # nolint: cyclocomp_linter.
	chkDots(...)
	relevance_map <- updateObject(relevance_map)
	partials_norm <- relevance_map@partials_norm
	coords <- get_coords(relevance_map, dims)
	if (!is.numeric(iter_smooth) || length(iter_smooth) != 1L) stop('iter_smooth needs to be an integer(1)')
	if (!is.numeric(n_top) || length(n_top) != 1L) stop('n_top needs to be an integer(1)')

	all_genes <- featureNames(relevance_map)
	if (is.null(genes)) {
		genes <- all_genes
	} else if (is.character(genes)) {
		found <- sapply(genes, function(id) length(grep(id, all_genes)) > 0)
		genes <- genes[found]
	} else {
		genes <- all_genes[genes]
	}

	# gene with top n norm for each cell
	genes_max <- if (n_top == 1L) {
		all_genes[apply(partials_norm, 1L, function(cell) which.max(cell))]
	} else {
		genes_ord <- t(apply(partials_norm, 1L, function(cell) {
			cell <- setNames(cell, all_genes)
			names(cell[order(cell, decreasing = TRUE)[seq_len(n_top)]])
		}))
		as.vector(genes_ord)
	}
	counts <- as.data.frame(table(genes_max), stringsAsFactors = FALSE)
	counts <- counts[order(counts$Freq, decreasing = TRUE), ]
	counts_valid <- counts[counts$genes_max %in% genes, ]
	gene_ids <- counts_valid$genes_max
	scores <- counts_valid$Freq / (sum(counts_valid$Freq) / n_top)
	names(scores) <- gene_ids

	num_top <- min(5L, length(gene_ids))
	top_n_cell_text <- apply(partials_norm, 1L, function(cell) {
		idxs <- head(order(cell, decreasing = TRUE), num_top)
		names <- all_genes[idxs]
		txt <- sprintf('%s. %s (%.3f)', seq_len(num_top), names, cell[idxs])
		paste(txt, collapse = '\n')
	})

	# Plot a single map with cells coloured by gene which has
	# the highest differential norm of all genes considered.

	# matrix cells by n_top. might contain NAs later
	max_genes <-
		if (n_top > 1L) genes_ord
		else matrix(gene_ids[apply(partials_norm, 1L, which.max)], ncol = 1)
	# Label smoothing through graph structure
	for (i in seq_len(iter_smooth)) {
		max_genes <- apply(relevance_map@nn_index, 1, function(idx_neighbors) {
			# treating the matrix as vector yields the first column first, i.e. the closest neighbors ...
			max_genes_nn <- unique(as.vector(max_genes[idx_neighbors, ]))
			max_genes_nn_hist <- vapply(max_genes_nn, function(gene) sum(gene == max_genes[idx_neighbors, ], na.rm = TRUE), integer(1L))
			# ... therefore if e.g. all genes only appear once, the first neighbors stay first
			sorted <- sort(max_genes_nn_hist, decreasing = TRUE)
			names(sorted)[seq_len(n_top)]
		})
		# Make inconsistent `apply` result into a cells by n_top matrix
		max_genes <-
			if (n_top > 1) t(max_genes)
			else matrix(max_genes, ncol = 1)
	}
	# use [1] so in case of an empty row we just get an NA.
	gene_labels <- droplevels(structure(
		apply(max_genes, 1, function(cell) na.omit(match(cell, gene_ids))[1]),
		levels = gene_ids,
		class = 'factor'
	))
	# Try creating a palette of the required length
	if (is.function(pal)) pal <- pal(length(unique(gene_labels)))
	if (limit) gene_labels[as.integer(gene_labels) > length(pal)] <- NA

	# Add more than two DC and return data frame so that user
	# can easily rebuild relevance map on other DC combination than 1 and 2.
	rel_map_data <- cbind(as.data.frame(coords), Gene = gene_labels, TopN = top_n_cell_text)

	d1 <- colnames(coords)[[1]]
	d2 <- colnames(coords)[[2]]
	rel_map <- ggplot(rel_map_data, aes(x = .data[[d1]], y = .data[[d2]], colour = .data$Gene, text = .data$TopN)) +
		geom_point(alpha = .8) +
		geom_rangeframe(colour = par('col')) +
		scale_color_manual(values = pal, na.value = col_na) +
		ggtitle(sprintf('Gene relevance map')) +
		theme_really_minimal()

	rel_map$ids <- gene_ids
	rel_map$scores <- scores

	rel_map
}

get_coords <- function(relevance_map, dims) {
	coords <- relevance_map@coords[, dims, drop = FALSE]
	if (is.null(colnames(coords)))
		colnames(coords) <- paste0('Dim', dims)
	coords
}

get_dim_range <- function(arr, d, dims) {
	if (is.character(dims)) dimnames(arr)[[d]]
	else seq_len(dim(arr)[[d]])
}

#' Find a random root cell index
#'
#' Finds a cell that has the maximum DPT distance from a randomly selected one.
#'
#' @param dm_or_dpt  A \code{\link{DiffusionMap}} or \code{\link{DPT}} object
#'
#' @return A cell index
#'
#' @examples
#' data(guo)
#' dm <- DiffusionMap(guo)
#' random_root(dm)
#'
#' @export
random_root <- function(dm_or_dpt) {
	dpt <- dummy_dpt(dm_or_dpt)
	random_idx <- sample.int(nrow(dpt), 1L)
	which.max(dpt[random_idx, ])
}


#' Find tips in a DiffusionMap object
#'
#' @param dm_or_dpt  A \code{\link{DiffusionMap}} or \code{\link{DPT}} object
#' @param root       Root cell index from which to find tips. (default: random)
#'
#' @return An integer vector of length 3
#'
#' @examples
#' data(guo)
#' dm <- DiffusionMap(guo)
#' is_tip <- l_which(find_tips(dm), len = ncol(guo))
#' plot(dm, col = factor(is_tip))
#'
#' @export
find_tips <- function(dm_or_dpt, root = random_root(dm_or_dpt)) {
	dpt <- dummy_dpt(dm_or_dpt)
	tipstats(dpt, seq_len(nrow(dpt)), root)$tips
}

tipstats <- function(dpt, cells, tips) {
	x <- tips[[1L]]
	dx <- dpt[x, cells]
	y <- if (length(tips) >= 2L) tips[[2L]] else cells[[which.max(dx)]]
	dy <- dpt[y, cells]
	z <- if (length(tips) == 3L) tips[[3L]] else cells[[which.max(dx + dy)]]

	list(
		tips = c(x, y, z),
		dx = dx, dy = dy,
		g = max(dx + dy) / min(dx + dy))
}

#' DiffusionMap methods
#'
#' Methods for external operations on diffusion maps
#'
#' @param x,object  A \code{\link{DiffusionMap}}
#'
#' @return The \code{DiffusionMap} object (\code{print}), or NULL (\code{show}), invisibly
#'
#' @seealso \link{DiffusionMap accession methods}, \link{Extraction methods}, \link{Coercion methods} for more
#'
#' @examples
#' data(guo)
#' dm <- DiffusionMap(guo)
#' print(dm)
#' show(dm)
#'
#' @aliases print.DiffusionMap show.DiffusionMap
#' @name DiffusionMap methods
#' @rdname DiffusionMap-methods
NULL

#' @importFrom utils str
#'
#' @rdname DiffusionMap-methods
#' @export
setMethod('print', 'DiffusionMap', function(x) {
	cat(sprintf('DiffusionMap (%s Diffusion components and %s observations)\n', length(eigenvalues(x)), nrow(eigenvectors(x))))
	cat('eigenvalues:   '); str(eigenvalues(x)) # nolint: semicolon_linter.
	cat('eigenvectors:  '); str(structure(eigenvectors(x), dimnames = NULL)) # nolint: semicolon_linter.
	cat('  ..colnames:  '); str(colnames(eigenvectors(x)), vec.len = 4) # nolint: semicolon_linter.
	cat('optimal_sigma: '); str(optimal_sigma(x)) # nolint: semicolon_linter.
	cat('distance:      '); str(distance(x)) # nolint: semicolon_linter.
	invisible(x)
})

#' @importFrom methods show
#'
#' @rdname DiffusionMap-methods
#' @export
setMethod('show', 'DiffusionMap', function(object) {
	print(object)
	invisible()
})

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

censoring_impl <- function(data, sigmas, dists, thr_or_null, uncertain_or_null, missing_or_null, callback) {
    .Call('_destiny_censoring_impl', PACKAGE = 'destiny', data, sigmas, dists, thr_or_null, uncertain_or_null, missing_or_null, callback)
}

predict_censoring_impl <- function(data, data2, thr, uncertain, missing, sigma) {
    .Call('_destiny_predict_censoring_impl', PACKAGE = 'destiny', data, data2, thr, uncertain, missing, sigma)
}

rank_mat <- function(x) {
    .Call('_destiny_rank_mat', PACKAGE = 'destiny', x)
}

#' @include dpt.r utils.r
NULL

#' Plot DPT
#'
#' Plots diffusion components from a Diffusion Map and the accompanying Diffusion Pseudo Time (\code{\link{DPT}})
#'
#' @param x           A \code{\link{DPT}} object.
#' @param y,root      Root branch ID. Will be used as the start of the DPT. (default: lowest branch ID)
#'                    (If longer than size 1, will be interpreted as \code{c(root, branches)})
#' @param paths_to    Numeric Branch IDs. Are used as target(s) for the path(s) to draw.
#' @param dcs         The dimensions to use from the DiffusionMap
#' @param divide      If \code{col_by = 'branch'}, this specifies which branches to divide. (see \code{\link{branch_divide}})
#' @param w_width     Window width for smoothing the path
#' @param col_by      Color by 'dpt' (DPT starting at \code{branches[[1]]}), 'branch', or a veriable of the data.
#' @param col_path    Colors for the path or a function creating n colors
#' @param col_tip     Color for branch tips
#' @param ...         Graphical parameters supplied to \code{\link{plot.DiffusionMap}}
#' @param col         See \code{\link{plot.DiffusionMap}}. This overrides \code{col_by}
#' @param legend_main See \code{\link{plot.DiffusionMap}}.
#'
#' @return The return value of the underlying call is returned, i.e. a scatterplot3d or rgl object for 3D plots.
#'
#' @aliases plot.DPT
#'
#' @examples
#' data(guo_norm)
#' dm <- DiffusionMap(guo_norm)
#' dpt <- DPT(dm)
#' plot(dpt)
#' plot(dpt, 2L,      col_by = 'branch')
#' plot(dpt, 1L, 2:3, col_by = 'num_cells')
#' plot(dpt, col_by = 'DPT3')
#'
#' @importFrom graphics plot points
#' @importFrom methods is setMethod
#' @importFrom scales colour_ramp rescale
#' @importFrom utils capture.output
#' @importFrom rlang .data
#' @importFrom ggplot2 geom_path geom_point scale_colour_identity
#' @export
plot.DPT <- function( # nolint: cyclocomp_linter.
	x, root = NULL,
	paths_to = integer(0L),
	dcs = 1:2,
	divide = integer(0L),
	w_width = .1,
	col_by = 'dpt',
	col_path = rev(palette()),
	col_tip = 'red',
	...,
	col = NULL,
	legend_main = col_by
) {
	dpt <- x
	dpt_flat <- branch_divide(dpt, divide)

	if (!is.null(root) && length(root) < 1L) stop('root needs to be specified')
	root <-
		if (is.null(root)) min(dpt_flat@branch[, 1], na.rm = TRUE)
		else as.integer(root)
	paths_to <- as.integer(paths_to)

	if (length(root) > 1L && length(paths_to) > 0L)
		stop('(length(root), length(paths_to)) needs to be (1, 0-n) or (2-n, 0), but is (', length(root), ', ', length(paths_to), ')')
	stopifnot(length(dcs) %in% 2:3)

	if (length(root) > 1L && length(paths_to) == 0L) {
		paths_to <- root[-1]
		root <- root[[1]]
	}

	pt_vec <- dpt_for_branch(dpt_flat, root)

	evs <- flipped_dcs(dpt@dm, dcs)

	plot_paths <- function(p, ..., rescale) {
		plot_points <- get_plot_fn(p)
		rescale_fun <-
			if (is.null(rescale)) identity
			else function(x) rescale_mat(x, rescale)

		for (b in seq_along(paths_to)) {
			idx <- dpt@branch[, 1] %in% c(root, paths_to[[b]])
			path <- average_path(pt_vec[idx], evs[idx, ], w_width)
			p <- plot_points(p, rescale_fun(path), type = 'l', col = col_path[[b]], ...)
		}

		tips <- evs[dpt_flat@tips[, 1], ]
		p <- plot_points(p, rescale_fun(tips), col = col_tip, ...)

		if (!is(p, 'ggplot')) p
		else p + scale_colour_identity(
			name = 'Path and Tips', guide = 'legend',
			breaks = c(col_path[seq_along(paths_to)], col_tip),
			labels = c(sprintf('Path to %s', paths_to), 'Tips'))
	}

	col <-
		if (!is.null(col)) col
		else switch(col_by,
			dpt    = pt_vec,
			branch = ,
			Branch = dpt_flat@branch[, 1],
			dpt[[col_by]])

	legend_main <- switch(legend_main, dpt = 'DPT', branch = 'Branch', legend_main)

	args <- list(
		dpt@dm, dcs,
		plot_more = plot_paths,
		legend_main = legend_main,
		col = col,
		...)

	if (!identical(Sys.getenv('LOG_LEVEL'), '')) message('Args:\n', paste(capture.output(print(args)), collapse = '\n'))
	do.call(plot, args)
}

#' @rdname plot.DPT
#' @export
setMethod('plot', c('DPT', 'numeric'), function(x, y, ...) plot.DPT(x, y, ...))

#' @rdname plot.DPT
#' @export
setMethod('plot', c('DPT', 'missing'), function(x, y, ...) {
	args <- list(...)
	root <- args$root  # may be NULL
	args$root <- NULL

	do.call(plot.DPT, c(list(x, root), args))
})


#' @importFrom graphics plot
average_path <- function(pt, x, w_width = .1) {
	stopifnot(identical(nrow(x), length(pt)))
	as.data.frame(apply(x[order(pt), ], 2, function(col) smth.gaussian(col, w_width, tails = TRUE)))
}


get_plot_fn <- function(p) {
	if (is(p, 'ggplot')) {  # ggplot
		function(p2, dat, type = 'p', col, ...) {
			xy <- colnames(dat)
			geom <- switch(type, p = geom_point, l = geom_path, stop)
			p2 + geom(aes(.data[[xy[[1L]]]], .data[[xy[[2L]]]], colour = .data$Path), data.frame(dat, Path = col))
		}
	} else if (is.list(p) && 'points3d' %in% names(p)) {# scatterplot3d
		function(p2, ...) {
			p2$points3d(...)
			p2
		}
	} else if (is(p, 'rglHighlevel')) {  # rgl
		function(p2, x, y = NULL, z = NULL, type = 'p', ...) {
			switch(type, p = rgl::points3d, l = rgl::lines3d, stop)(x, y, z, ...)
			p2
		}
	} else {
		stop('unknown p passed to plot_more (class(es): ', paste(class(p), collapse = ', '), ')')
	}
}

#' @importFrom methods is
#' @importFrom Biobase exprs
#' @importFrom SummarizedExperiment assay colData
dataset_extract_doublematrix <- function(data, vars = NULL) {
	if (is.data.frame(data)) {
		if (is.null(vars)) {
			data <- data[, sapply(data, is.double)]
		} else {  # If we have a data frame subset early, before matrix conversion
			data <- data[, vars]
			vars <- NULL
		}
		data <- as.matrix(data)
	} else if (is(data, 'ExpressionSet')) {
		data <- t(exprs(data))
	} else if (is(data, 'SingleCellExperiment')) {
		#TODO: allow other name?
		data <- t(assay(data, 'logcounts'))
	} else if (!is.matrix(data)) {
		stop('Data needs to be matrix, data.frame, ExpressionSet, or SingleCellExperiment')
	}
	dupes <- duplicated(data)
	if (any(dupes)) {
		data <- data[!dupes, ]
		warning('Duplicate rows removed from data. Consider explicitly using `df[!duplicated(df), ]`')
	}

	if (!is.null(vars))
		data <- data[, vars]
	data
}


#' @importFrom Biobase sampleNames
dataset_n_observations <- function(data, distances) {
	if (is.null(data)) nrow(distances)
	else if (is(data, 'ExpressionSet')) length(sampleNames(data))
	else if (is(data, 'SingleCellExperiment')) ncol(data)
	else nrow(data)
}


#' @importFrom Biobase featureNames
dataset_n_features <- function(data, distances = NULL, vars = NULL) {
	if (is.null(data)) ncol(distances)
	else if (is(data, 'ExpressionSet')) length(featureNames(data))
	else if (is(data, 'SingleCellExperiment')) nrow(data)
	else if (!is.null(vars)) ncol(data[, vars])
	else if (is.data.frame(data)) ncol(data[, sapply(data, is.double)])
	else ncol(data)
}


#' @importFrom methods canCoerce
#' @importFrom utils getS3method
dataset_to_df <- function(dta, row.names = NULL, optional = FALSE, ...) { # nolint: object_name_linter.
	# The ExpressionSet as.data.frame sucks
	if (is(dta, 'ExpressionSet')) {
		cbind(as.data.frame(t(exprs(dta)), row.names, optional, ...), pData(dta))
	} else if (is(dta, 'SingleCellExperiment')) {
		smp_meta <- as.data.frame(colData(dta), row.names, optional, ...)

		#TODO: allow other name?
		mat <- assay(dta, 'logcounts')
		if (is(mat, 'sparseMatrix')) {
			n_genes_max <- getOption('destiny.genes.max', 5000L)
			if (nrow(mat) > n_genes_max) {
				warning(
					'Data has too many genes to convert it to a data.frame (',
					nrow(mat), ' > ', n_genes_max,
					'). You can try setting options(destiny.genes.max = ...)')
				return(smp_meta)
			} else {
				mat <- as.matrix(mat)
			}
		}

		cbind(as.data.frame(t(mat), row.names, optional, ...), smp_meta)
	} else if (canCoerce(dta, 'data.frame')) {
		as(dta, 'data.frame')
	} else if (!is.null(getS3method('as.data.frame', class(dta)[[1L]], optional = TRUE))) { # nolint: brace_linter.
		as.data.frame(dta, row.names, optional, ...)
	} else NULL
}


dataset_names <- function(dta) {
	if (is(dta, 'ExpressionSet')) {
		c(featureNames(dta), varLabels(dta))
	} else if (is(dta, 'SingleCellExperiment')) {
		c(rownames(dta), colnames(colData(dta)))
	} else {
		colnames(dta)
	}
}


#' @importFrom Biobase featureNames exprs
dataset_get_feature <- function(dta, f) {
	force(f)  # else dta[, f] would be dta[, ] and valid
	tryCatch({
		if (is(dta, 'ExpressionSet') && f %in% featureNames(dta)) {
			exprs(dta)[f, ]
		} else if (is(dta, 'SingleCellExperiment') && f %in% rownames(dta)) {
			#TODO: allow other name?
			assay(dta, 'logcounts')[f, ]
		} else if (is(dta, 'ExpressionSet') || is(dta, 'SingleCellExperiment') || is.data.frame(dta)) {
			# data.frame or phenoData/colData
			dta[[f]]
		} else {
			dta[, f]
		}
	}, error = function(e) stop(sprintf('Invalid `%s`: No column, annotation, or feature found with name %s', deparse(substitute(f)), dQuote(f))))
}

context('dataset types')

library(Biobase)
library(SingleCellExperiment)

test_nobss <- 4L
test_nfeat <- 3L

test_obss <- paste0('c', seq_len(test_nobss))
test_feat <- paste0('g', seq_len(test_nfeat))

mk_test_matrix <- function() {
	m <- matrix(runif(test_nobss * test_nfeat), test_nobss, test_nfeat, dimnames = list(test_obss, test_feat))
	m[m < mean(m)] <- 0
	m
}

test_matrix <- mk_test_matrix()
for (attempt in seq_len(100L)) {
	if (!any(duplicated(test_matrix))) break
	test_matrix <- mk_test_matrix()
}
if (any(duplicated(test_matrix))) stop('Could not create sensible test matrix after 100 attempts')

test_df     <- data.frame(test_matrix, cm1 = LETTERS[seq_len(test_nobss)], stringsAsFactors = FALSE)
test_es     <- ExpressionSet(
	t(test_matrix),
	AnnotatedDataFrame(data.frame(cm1 = LETTERS[seq_len(test_nobss)], row.names = test_obss, stringsAsFactors = FALSE)),
	AnnotatedDataFrame(data.frame(gm1 = letters[seq_len(test_nfeat)], row.names = test_feat, stringsAsFactors = FALSE)))
test_se <- SingleCellExperiment(
	assays = list(logcounts = t(test_matrix)),
	colData = DataFrame(cm1 = LETTERS[seq_len(test_nobss)]),
	rowData = DataFrame(gm1 = letters[seq_len(test_nfeat)]))
test_se_sparse <- test_se
assay(test_se_sparse) <- as(assay(test_se_sparse), 'sparseMatrix')


test_that('The helpers work with matrix data', {
	expect_identical(dataset_extract_doublematrix(test_matrix), test_matrix)
	expect_identical(dataset_n_observations(test_matrix), test_nobss)
	expect_identical(dataset_n_features(test_matrix), test_nfeat)
	expect_identical(dataset_to_df(test_matrix), test_df[, 1:3])
	expect_identical(dataset_names(test_matrix), test_feat)
	expect_identical(dataset_get_feature(test_matrix, 'g2'), test_matrix[, 'g2'])
})


test_that('The helpers work with data.frame data', {
	expect_identical(dataset_extract_doublematrix(test_df), test_matrix)
	expect_identical(dataset_n_observations(test_df), test_nobss)
	expect_identical(dataset_n_features(test_df), test_nfeat)
	expect_identical(dataset_to_df(test_df), test_df)
	expect_identical(dataset_names(test_df), c(test_feat, 'cm1'))
	expect_identical(dataset_get_feature(test_df, 'g3'), test_df$g3)
	expect_identical(dataset_get_feature(test_df, 'cm1'), test_df$cm1)
})


test_that('The helpers work with ExpressionSet data', {
	expect_identical(dataset_extract_doublematrix(test_es), test_matrix)
	expect_identical(dataset_n_observations(test_es), test_nobss)
	expect_identical(dataset_n_features(test_es), test_nfeat)
	expect_identical(dataset_to_df(test_es), test_df)
	expect_identical(dataset_names(test_es), c(test_feat, 'cm1'))
	expect_identical(dataset_get_feature(test_es, 'g1'), exprs(test_es)['g1', ])
	expect_identical(dataset_get_feature(test_es, 'cm1'), test_es$cm1)
})


test_that('The helpers work with SingleCellExperiment data', {
	expect_identical(dataset_extract_doublematrix(test_se), test_matrix)
	expect_identical(dataset_n_observations(test_se), test_nobss)
	expect_identical(dataset_n_features(test_se), test_nfeat)
	expect_identical(dataset_to_df(test_se), test_df)
	expect_identical(dataset_names(test_se), c(test_feat, 'cm1'))
	expect_identical(dataset_get_feature(test_se, 'g1'), assay(test_se, 'logcounts')['g1', ])
	expect_identical(dataset_get_feature(test_se, 'cm1'), test_se$cm1)
})


test_that('The helpers work with sparse SingleCellExperiment data', {
	expect_identical(dataset_extract_doublematrix(test_se_sparse), as(test_matrix, 'sparseMatrix'))
	expect_identical(dataset_n_observations(test_se_sparse), test_nobss)
	expect_identical(dataset_n_features(test_se_sparse), test_nfeat)
	expect_identical(dataset_to_df(test_se_sparse), test_df)
	expect_identical(dataset_names(test_se_sparse), c(test_feat, 'cm1'))
	expect_identical(dataset_get_feature(test_se_sparse, 'g1'), assay(test_se_sparse, 'logcounts')['g1', ])
	expect_identical(dataset_get_feature(test_se_sparse, 'cm1'), test_se_sparse$cm1)
})

#' kNN search
#'
#' Approximate k nearest neighbor search with flexible distance function.
#'
#' @param data      Data matrix
#' @param query     Query matrix. Leave it out to use \code{data} as query
#' @param k         Number of nearest neighbors
#' @param ...       Parameters passed to \code{\link[RcppHNSW]{hnsw_knn}}
#' @param distance  Distance metric to use. Allowed measures: Euclidean distance (default), cosine distance (\eqn{1-corr(c_1, c_2)}) or rank correlation distance (\eqn{1-corr(rank(c_1), rank(c_2))})
#' @param method    Method to use. \code{'hnsw'} is tunable with \code{...} but generally less exact than \code{'covertree'} (default: 'covertree')
#' @param sym       Return a symmetric matrix (as long as query is NULL)?
#' @param verbose   Show a progressbar? (default: FALSE)
#'
#' @return A \code{\link{list}} with the entries:
#' \describe{
#'   \item{\code{index}}{A \eqn{nrow(data) \times k} \link{integer} \link{matrix} containing the indices of the k nearest neighbors for each cell.}
#'   \item{\code{dist}}{A \eqn{nrow(data) \times k} \link{double} \link{matrix} containing the distances to the k nearest neighbors for each cell.}
#'   \item{\code{dist_mat}}{
#'     A \code{\link[Matrix:dgCMatrix-class]{dgCMatrix}} if \code{sym == TRUE},
#'     else a \code{\link[Matrix:dsCMatrix-class]{dsCMatrix}} (\eqn{nrow(query) \times nrow(data)}).
#'     Any zero in the matrix (except for the diagonal) indicates that the cells in the corresponding pair are close neighbors.
#'   }
#' }
#'
#' @rdname knn
#' @importFrom RcppHNSW hnsw_build hnsw_knn hnsw_search
#' @export
find_knn <- function(
	data, k,
	...,
	query = NULL,
	distance = c('euclidean', 'cosine', 'rankcor', 'l2'),
	method = c('covertree', 'hnsw'),
	sym = TRUE,
	verbose = FALSE
) {
	p <- utils::modifyList(formals(RcppHNSW::hnsw_knn), list(...))
	method <- match.arg(method)
	distance <- match.arg(distance)
	if (!is.double(data)) {
		warning('find_knn does not yet support sparse matrices, converting data to a dense matrix.')
		data <- as.matrix(data)
	}
	if (method == 'covertree') {
		return(knn.covertree::find_knn(data, k, query = query, distance = distance, sym = sym))
	}

	if (distance == 'rankcor') {
		# TODO: rank_mat only works on dense matrices
		distance <- 'cosine'
		data <- rank_mat(data)
		if (!is.null(query)) query <- rank_mat(query)
	}

	if (is.null(query)) {
		knn <- hnsw_knn(data, k + 1L, distance, M = p$M, ef_construction = p$ef_construction, ef = p$ef, verbose = verbose)
		knn$idx  <- knn$idx[, -1, drop = FALSE]
		knn$dist <- knn$dist[, -1, drop = FALSE]
	} else {
		index <- hnsw_build(data, distance, M = p$M, ef = p$ef_construction, verbose = verbose)
		knn <- hnsw_search(query, index, k, ef = p$ef, verbose = verbose)
	}
	names(knn)[[1L]] <- 'index'  # idx → index
	# R matrices are column-major, so as.vector(m) == c(m[, 1], m[, 2], ...)
	knn$dist_mat <- sparseMatrix(
		rep(seq_len(nrow(knn$index)), k),
		as.vector(knn$index),
		x = as.vector(knn$dist),
		dims = c(nrow(if (is.null(query)) data else query), nrow(data))
	)
	if (is.null(query)) {
		if (sym) knn$dist_mat <- symmetricise(knn$dist_mat)
		nms <- rownames(data)
	} else {
		nms <- rownames(query)
	}
	rownames(knn$dist_mat) <- rownames(knn$index) <- rownames(knn$dist) <- nms
	colnames(knn$dist_mat) <- rownames(data)
	knn
}


# (double generic columnsparse to ... symmetric ...: dgCMatrix -> dsCMatrix)
# retain all differences fully. symmpart halves them in the case of trans_p[i,j] == 0 && trans_p[j,i] > 0
# TODO: could be more efficient
symmetricise <- function(dist_asym) {
	dist_sym <- symmpart(dist_asym) + abs(forceSymmetric(skewpart(dist_asym), 'U'))
	as(dist_sym, 'symmetricMatrix')
}

context('kNN integrity')

test_that('knn works similarly to FNN', {
	skip_if_not_installed('FNN')

	data(guo_norm, package = 'destiny')
	e <- t(Biobase::exprs(guo_norm))

	r_destiny <- destiny::find_knn(e, 5L)
	r_fnn <- FNN::get.knn(e, 5L)

	dimnames(r_destiny$index) <- dimnames(r_destiny$dist) <- NULL

	rows_eq <- sapply(seq_len(nrow(e)), function(r) isTRUE(all.equal(r_destiny$index[r, ], r_fnn$nn.index[r, ])))
	expect_lte(sum(!rows_eq), 5L)
	expect_equal(r_destiny$dist[rows_eq, ], r_fnn$nn.dist[rows_eq, ], tolerance = 1e-5)
})

test_that('knnx works similarly to FNN', {
	skip_if_not_installed('FNN')

	data(guo_norm, package = 'destiny')
	e <- t(Biobase::exprs(guo_norm))
	nc <- guo_norm$num_cells

	r_destiny <- destiny::find_knn(e[nc != 32L, ], 5L, query = e[nc == 32L, ])
	r_fnn <- FNN::get.knnx(e[nc != 32L, ], e[nc == 32L, ], 5L)

	dimnames(r_destiny$index) <- dimnames(r_destiny$dist) <- NULL

	rows_eq <- sapply(seq_len(sum(nc == 32L)), function(r) isTRUE(all.equal(r_destiny$index[r, ], r_fnn$nn.index[r, ])))
	expect_lte(sum(!rows_eq), 30L)
	expect_equal(r_destiny$dist[rows_eq, ], r_fnn$nn.dist[rows_eq, ], tolerance = 1e-5)
})

censoring <- function(data, sigma, dists, censor_val = NULL, censor_range = NULL, missing_range = NULL, callback = invisible) {
	if (!is.null(censor_range))
		censor_range <- matrix(censor_range, ncol = 2)

	if (!is.null(missing_range))
		missing_range <- matrix(missing_range, ncol = 2)

	validate_censoring(data, sigma, dists, censor_val, censor_range, missing_range)

	data <- as.matrix(data)

	# dists is a sparse symmetrix matrix, which eigen cannot handle
	# so we just pass its filled triangle as sparse matrix and convert it back afterwards
	uplo <- dists@uplo
	half <- censoring_impl(data, sigma, structure(dists, class = 'dgCMatrix'), censor_val, censor_range, missing_range, callback)
	structure(half, class = 'dsCMatrix', uplo = uplo)
}

predict_censoring <- function(data, data2, censor_val = NULL, censor_range = NULL, missing_range = NULL, sigma) {
	if (is.null(censor_val)) censor_val <- NA  # this works since this will be NaN in C++ and comparison with NaN is always false
	if (is.null(censor_range)) censor_range <- c(NA, NA)
	if (is.null(missing_range)) missing_range <- c(NA, NA)

	predict_censoring_impl(data, data2, censor_val, censor_range, missing_range, sigma)
}

#' @importFrom Matrix sparseMatrix
validate_censoring <- function(data, sigma, dists, censor_val, censor_range, missing_range) { # nolint: cyclocomp_linter.
	g <- ncol(data)
	n <- nrow(data)

	if (any(is.na(data)) && is.null(missing_range))
		stop('Your data contains missing values (NA). You have to provide a the `missing_range` parameter.')

	if (is.null(censor_val) != is.null(censor_range))
		stop('You have to provide both a censoring value and a censor_range or none')

	if (!is.null(censor_range)) {
		if (!is.numeric(censor_val) || !(length(censor_val) %in% c(g, 1L)))
			stop('censor_val has to be a single numeric value, or length(censor_val) == ncol(data) must be TRUE')

		if (!is.numeric(censor_range) || !(nrow(censor_range) %in% c(g, 1L)) || ncol(censor_range) != 2L || any(diff(t(censor_range)) <= 0L))
			stop('censor_range has to be a numeric vector of length 2, the second of which being larger,
				 or a matrix with nrow(censor_range) == ncol(data) where each row is such a vector')
	}

	if (!is.null(missing_range)) {
		if (!is.numeric(missing_range) || !(nrow(missing_range) %in% c(g, 1L)) || ncol(missing_range) != 2L || any(diff(t(missing_range)) <= 0L))
			stop('missing_range has to be a numeric vector of length 2, the second of which being larger,
				 or a matrix with nrow(missing_range) == ncol(data) where each row is such a vector')
	}

	if (!is.numeric(sigma) || !length(sigma) %in% c(n, 1L))
		stop('sigma has to be a single numeric value or of length nrow(data)')

	if (!is(dists, 'dsCMatrix'))
		stop('dists has to be a dsCMatrix, not ', class(dists))
}

test_censoring <- function(censor_val, censor_range, data, missing_range) {
	if (is.null(data)) return(FALSE)

	has_censor_range <- !(missing(censor_range) || is.null(censor_range))
	has_missing_range <- !(missing(missing_range) || is.null(missing_range))
	if (has_censor_range || has_missing_range) return(TRUE)

	any(is.na(data)) || any(data == censor_val)
}

#' @include diffusionmap.r
#' @include plothelpers.r
NULL

#' 3D or 2D plot of diffusion map
#'
#' If you want to plot the eigenvalues, simply \code{plot(eigenvalues(dm)[start:end], ...)}
#'
#' If you specify negative numbers as diffusion components (e.g. \code{plot(dm, c(-1,2))}), then the corresponding components will be flipped.
#'
#' @param x            A \link{DiffusionMap}
#' @param dims,y       Diffusion components (eigenvectors) to plot (default: first three components; 1:3)
#' @param new_dcs      An optional matrix also containing the rows specified with \code{y} and plotted. (default: no more points)
#' @param new_data     A data set in the same format as \code{x} that is used to create \code{new_dcs <- \link{dm_predict}(dif, new_data)}
#' @param col          Single color string or vector of discrete or categoric values to be mapped to colors.
#'                     E.g. a column of the data matrix used for creation of the diffusion map. (default: \code{\link[igraph]{cluster_louvain}} if igraph is installed)
#' @param col_by       Specify a \code{dataset(x)} or \code{phenoData(dataset(x))} column to use as color
#' @param col_limits   If \code{col} is a continuous (=double) vector, this can be overridden to map the color range differently than from min to max (e.g. specify \code{c(0, 1)})
#' @param col_new      If \code{new_dcs} is given, it will take on this color. A vector is also possible. (default: red)
#' @param pal          Palette used to map the \code{col} vector to colors. (default: use \code{\link{hcl.colors}} for continuous and \code{\link{palette}()} for discrete data)
#' @param pal_new      Palette used to map the \code{col_new} vector to colors. (default: see \code{pal} argument)
#' @param ...          Parameters passed to \link{plot}, \link[scatterplot3d]{scatterplot3d}, or \link[rgl]{plot3d} (if \code{interactive == TRUE})
#' @param ticks        logical. If TRUE, show axis ticks (default: FALSE)
#' @param axes         logical. If TRUE, draw plot axes (default: Only if \code{ticks} is TRUE)
#' @param box          logical. If TRUE, draw plot frame (default: TRUE or the same as \code{axes} if specified)
#' @param legend_main  Title of legend. (default: nothing unless \code{col_by} is given)
#' @param legend_opts  Other \link{colorlegend} options (default: empty list)
#' @param interactive  Use \link[rgl]{plot3d} to plot instead of \link[scatterplot3d]{scatterplot3d}?
#' @param draw_legend  logical. If TRUE, draw color legend (default: TRUE if \code{col_by} is given or \code{col} is given and a vector to be mapped)
#' @param consec_col   If \code{col} or \code{col_by} refers to an integer column, with gaps (e.g. \code{c(5,0,0,3)}) use the palette color consecutively (e.g. \code{c(3,1,1,2)})
#' @param col_na       Color for \code{NA} in the data. specify \code{NA} to hide.
#' @param plot_more    Function that will be called while the plot margins are temporarily changed
#'                     (its \code{p} argument is the rgl or scatterplot3d instance or NULL,
#'                     its \code{rescale} argument is \code{NULL}, a \code{list(from = c(a, b), to = c(c, d))}),
#'                     or an array of shape \eqn{from|to \times dims \times min|max}, i.e. \eqn{2 \times length(dims) \times 2}.
#'                     In case of 2d plotting, it should take and return a ggplot2 object.
#'
#' @return The return value of the underlying call is returned, i.e. a scatterplot3d or rgl object.
#'
#' @examples
#' data(guo)
#' plot(DiffusionMap(guo))
#'
#' @aliases plot.DiffusionMap
#'
#' @importFrom graphics par axis plot plot.new
#' @importFrom stats setNames
#' @importFrom grDevices palette hcl.colors
#' @importFrom scatterplot3d scatterplot3d
#' @importFrom rlang .data
#' @importFrom ggplot2 ggplot aes
#' @importFrom ggplot2 geom_point
#' @importFrom ggplot2 theme theme_minimal element_blank element_line element_text element_rect
#' @importFrom ggplot2 scale_fill_identity scale_fill_manual scale_fill_gradientn scale_fill_identity
#' @importFrom ggplot2 scale_x_continuous scale_y_continuous
#' @importFrom ggplot2 guide_colourbar guide_legend
#' @importFrom ggthemes geom_rangeframe extended_range_breaks
#'
#' @rdname plot.DiffusionMap
#' @export
plot.DiffusionMap <- function( # nolint: cyclocomp_linter.
	x, dims = 1:3,
	new_dcs = if (!is.null(new_data)) dm_predict(x, new_data),
	new_data = NULL,
	col = NULL, col_by = NULL, col_limits = NULL,
	col_new = 'red',
	pal = NULL, pal_new = NULL,
	...,
	ticks = FALSE,
	axes = TRUE,
	box = FALSE,
	legend_main = col_by, legend_opts = list(),
	interactive = FALSE,
	draw_legend = !is.null(col_by) || (length(col) > 1 && !is.character(col)),
	consec_col = TRUE, col_na = 'grey',
	plot_more = function(p, ..., rescale = NULL) p
) {
	dif <- x
	is_projection <- !is.null(new_dcs) && is.character(col_new) && length(col_new) == 1L

	if (interactive) {
		if (!requireNamespace('rgl', quietly = TRUE))
			stop(sprintf('The package %s is required for interactive plots', sQuote('rgl')))
		if (length(dims) != 3L)
			stop('Only 3d plots can be made interactive')
	}

	if (!is.null(col) && !is.null(col_by)) stop('Only specify one of col or col_by')
	if (!is.null(col_by)) {
		col <- dataset_get_feature(dataset(dif), col_by)
	} else if (is.null(col)) {
		if (requireNamespace('igraph', quietly = TRUE)) {
			col <- get_louvain_clusters(dif@transitions)
			col_by <- legend_main <- 'Louvain'
		} else {
			col <- par('col')
		}
	}
	continuous <- is.double(col)
	if (is_projection) {
		projection_guide <- setNames(c(col, col_new), c(paste(legend_main, col), rep_len('new', length(col_new))))
		legend_main <- 'Projection'
	}
	col_legend <- if (continuous && !is.null(col_limits)) col_limits else col

	# use a fitting default palette
	if (is.null(pal)) {
		pal <- if (is.double(col)) hcl.colors
		else palette()
	}

	# make consecutive the colors for the color legend
	if (is.integer(col) && consec_col) {
		# For example: `c(5,0,0,3) -> c(3,1,1,2)`
		col <- factor(col)
	}

	point_data <- cbind(
		as.data.frame(flipped_dcs(eigenvectors(dif), dims)),
		Colour     = col,
		ColourExpl = get_explicit_col(col, pal, col_na, col_limits),
		Projection = factor(rep('old', nrow(eigenvectors(dif))), c('old', 'new')))
	rm(col)

	if (!is.null(new_dcs)) {
		point_data <- rbind(point_data, cbind(
			as.data.frame(flipped_dcs(new_dcs, dims)),
			Colour     = col_new,  #TODO
			ColourExpl = get_explicit_col(col_new, pal_new, col_na, col_limits),
			Projection = 'new'
		))
		col_legend
	}

	lvl_fn <- if (is.factor(point_data$Colour)) levels else unique
	col_lvls <- na.omit(as.character(lvl_fn(point_data$Colour)))
	col_breaks <- point_data$ColourExpl[match(col_lvls, point_data$Colour)]
	is_one_colour <- length(col_lvls) == 1L

	if (length(dims) == 2) {
		d1 <- names(point_data)[[1L]]
		d2 <- names(point_data)[[2L]]

		use_mapping <- continuous || is_projection || !is.null(col_by)
		p <-
			ggplot(point_data, aes(.data[[d1]], .data[[d2]])) +
			theme_really_minimal() +
			geom_point(
				aes(fill = if (use_mapping) .data$Colour else .data$ColourExpl),
				colour = I('#00000000'),
				shape  = I(21))

		nomap_guide <- if (is_one_colour) 'none' else 'legend'
		p <- p +
			if (is_projection)     scale_fill_identity(name = legend_main, guide = 'legend', labels = names(projection_guide), breaks = projection_guide, na.value = col_na)
			else if (!use_mapping) scale_fill_identity(name = legend_main, guide = nomap_guide, labels = col_lvls, breaks = col_breaks, na.value = col_na)
			else if (continuous)   scale_fill_gradientn(name = legend_main, colours = if (is.function(pal)) pal(100) else pal, na.value = col_na)
			else                   scale_fill_manual(name = legend_main, values = if (is.function(pal)) pal(length(col_lvls)) else pal[seq_along(col_lvls)], breaks = col_lvls, labels = col_lvls, na.value = col_na)
		if (box)   p <- p + theme(panel.border = element_rect(fill = NA), axis.title.x = element_text(), axis.title.y = element_text())
		if (ticks) p <- p + theme(axis.ticks = element_line(), axis.text.x  = element_text(), axis.text.y  = element_text())
		if (axes)  p <- p + geom_rangeframe(colour = par('col'))
		if (ticks && axes && !box) p <- p +
			scale_x_continuous(breaks = extended_range_breaks()(point_data[[1L]])) +
			scale_y_continuous(breaks = extended_range_breaks()(point_data[[2L]]))
		p <- plot_more(p, rescale = NULL)
	} else if (length(dims) == 3L) { # nolint: brace_linter.
		if (interactive) {
			p <- rgl::plot3d(point_data, ..., col = point_data$ColourExpl, axes = FALSE, box = FALSE)
			if (axes || ticks) {
				axtype <- if (axes) 'lines' else 'cull'
				nticks <- if (ticks) 5 else 0
				rgl::bbox3d(xlen = nticks, ylen = nticks, zlen = nticks, front = axtype, back = axtype)
			}
			if (box) rgl::box3d()
			plot_more(p, rescale = NULL)
		} else {
			rescale <- NULL
			if (!ticks) {
				rescale <- array(NA, c(2L, length(dims), 2L), list(c('from', 'to'), as.character(dims), c('min', 'max')))
				for (d in seq_along(dims)) {  # -> scatterplot3d's pretty() should not mess things up
					r <- range(point_data[, d])
					point_data[, d] <- scales::rescale(point_data[, d], c(0, 1), r)
					rescale['from', d, ] <- r
					rescale['to', d, ] <- c(0, 1)
				}
			}

			mar <- list(...)$mar
			if (is.null(mar)) mar <- par('mar')
			old_mar <- mar
			on.exit(par(mar = old_mar))
			if (draw_legend) mar[[4]] <- mar[[4]] + 5
			p <- scatterplot3d(
				point_data[, 1:3], ..., color = point_data$ColourExpl, mar = mar,
				axis = axes || box || ticks, lty.axis = if (axes || box) 'solid' else 'blank',
				box = box, tick.marks = ticks)
			rm(mar)
			plot_more(p, rescale = rescale)

			if (draw_legend) {
				args <- c(list(col_legend, pal = pal, main = legend_main), legend_opts)
				if (interactive) {
					rgl::bgplot3d({
						plot.new()
						do.call(colorlegend, args)
					})
				} else {
					do.call(colorlegend, args)
				}
			}
		}
	} else stop(sprintf('dims is of wrong length (%s): Can only handle 2 or 3 dimensions', dims))

	if (length(dims) == 2) p else invisible(p)
}


get_explicit_col <- function(col, pal, col_na, col_limits) {
	# if nothing is given, return one colour
	if (is.null(col)) return(par('col'))

	# if we have continuous colour, we are done.
	if (is.double(col))
		return(continuous_colors(col, pal, col_limits))

	# get palette length and convert col to consecutive integers
	length_pal <-
		if (is.factor(col))
			length(levels(col))
		else if (is.integer(col))
			length(unique(col))
		else stopifnot(is.character(col))
	if (is.factor(col))
		col <- as.integer(col)

	# map integers to strings if necessary
	if (is.integer(col)) {
		if (is.function(pal)) {
			# pal is a colorRampPalette-type function
			pal <- pal(length_pal)
		} else {
			# pal is a vector
			length_pal <- min(length(pal), length_pal)
			pal <- pal[seq_len(length_pal)]
		}

		idx_wrapped <- ((col - 1L) %% length_pal) + 1L
		col <- pal[idx_wrapped]
		col[is.na(col)] <- col_na
	}

	# if the color wasn’t numeric, use as is
	col
}

theme_really_minimal <- function(...) theme_minimal() + theme(axis.text.x = element_blank(), axis.text.y = element_blank(), ...)

#' @rdname plot.DiffusionMap
#' @export
setMethod('plot', c(x = 'DiffusionMap', y = 'numeric'), function(x, y, ...) plot.DiffusionMap(x, y, ...))

#' @rdname plot.DiffusionMap
#' @export
setMethod('plot', c(x = 'DiffusionMap', y = 'missing'), function(x, y, ...) plot(x, seq_len(min(3L, ncol(eigenvectors(x)))), ...))

#' @include sigmas.r
NULL

langle <- '\u27E8'
rangle <- '\u27E9'
angles <- list(langle = langle, rangle = rangle)

#' Plot \link{Sigmas} object
#'
#' @param x              Sigmas object to plot
#' @param col            Vector of bar colors or single color for all bars
#' @param col_highlight  Color for highest bar. Overrides col
#' @param col_line       Color for the line and its axis
#' @param type           Plot type of both lines. Can be a vector of length 2 to specify both separately (default: 'b' aka \dQuote{both lines and points})
#' @param pch            Point identifier for both lines. Can be a vector of length 2 to specify both separately (default: \code{par(pch)} and 4 (a \sQuote{\eqn{\times}}))
#' @param only_dim       logical. If TRUE, only plot the derivative line
#' @param ...            Options passed to the call to plot
#' @param xlab           X label. NULL to use default
#' @param ylab           Either one y label or y labels for both plots. NULL to use both defauts, a NULL in a list of length 2 to use one default.
#' @param main           Title of the plot
#'
#' @return This method plots a Sigma object to the current device and returns nothing/NULL
#'
#' @examples
#' data(guo)
#' sigs <- find_sigmas(guo)
#' plot(sigs)
#'
#' @importFrom graphics plot plot.window par text dotchart layout
#' @name plot.Sigmas
#' @rdname plot.Sigmas
NULL

#' @importFrom graphics plot plot.window par text dotchart layout
#' @rdname plot.Sigmas
#' @export
setMethod('plot', c(x = 'Sigmas', y = 'missing'), function( # nolint: cyclocomp_linter.
	x,
	col = par('fg'),
	col_highlight = '#E41A1C',  # brewer Set1[[1]]
	col_line      = '#999999',  # brewer Set1[[9]]
	type = c('b', 'b'),
	pch = c(par('pch'), 4L),
	only_dim = FALSE,
	...,
	xlab = NULL,
	ylab = NULL,
	main = ''
) {
	sigmas <- x
	if (is.null(optimal_sigma(sigmas))) {
		plot.new()
		plot.window(c(-1, 1), c(-1, 1))
		text(0, 0, expression('local ' * sigma), .5)
		return()
	}
	if (is.null(sigmas@log_sigmas)) {
		return(dotchart(optimal_sigma(sigmas), labels = 'optimal_sigma', color = col_highlight, pch = pch, main = 'optimal sigma given directly'))
	}

	steps <- length(sigmas@log_sigmas)

	colors <- if (length(col) == 1L) rep(col, steps - 1L) else col
	colors[[sigmas@optimal_idx]] <- col_highlight

	#prepare parameters and reset them at the end

	mar <- par('mar')

	if (!only_dim) {
		layout(matrix(1:2, 2L))
		par_old <- par(mar = c(0, mar[2:4]), ..., no.readonly = TRUE)

		on.exit({
			layout(matrix(1))
			par(par_old)
		})
	}

	if (is.null(xlab)) xlab <- expression(log[10](sigma))

	if (is.null(ylab)) ylab <- list(NULL, NULL)
	if (length(ylab) == 1L) ylab <- list(ylab, NULL)
	if (is.null(ylab[[1L]]))
		ylab[[1L]] <- substitute(paste(langle, d, rangle), angles)
	if (is.null(ylab[[2L]]))
		ylab[[2L]] <- substitute(paste(langle, log[10](Z(x)), rangle), angles)

	#first plot

	x <- sigmas@log_sigmas[-1L] - diff(sigmas@log_sigmas) / 2
	xlim <- range(sigmas@log_sigmas)

	ysteps <- pretty(sigmas@dim_norms)
	ymin <- min(ysteps)
	ymax <- max(ysteps) + diff(ysteps[1:2]) / 4

	plot(x, sigmas@dim_norms,
			 xlim = xlim, ylim = c(ymin, ymax),
			 xaxt = if (only_dim) 's' else 'n', xlab = if (only_dim) xlab else '',
			 ylab = ylab[[1L]],
			 col = colors, type = type[[1L]], pch = pch[[1L]],
			 main = main,
			 ...)

	text(log10(optimal_sigma(sigmas)), sigmas@dim_norms[[sigmas@optimal_idx]],
			 substitute(sigma == rsig, list(rsig = round(optimal_sigma(sigmas), 1))), pos = 3)

	#second (overlay) plot

	if (!only_dim) {
		par(mar = c(mar[1:2], 0, mar[[4L]]), ...)

		col_lines <- rep(col_line, length(sigmas@log_sigmas))
		col_lines[c(sigmas@optimal_idx, sigmas@optimal_idx + 1L)] <- col_highlight

		t2 <- if (length(type) > 1L) type[[2L]] else type
		p2 <- if (length(pch)  > 1L)  pch[[2L]] else pch
		plot(sigmas@log_sigmas, sigmas@avrd_norms,
				 xlab = xlab, xlim = xlim,
				 ylab = ylab[[2L]],
				 type = t2, pch = p2, col = col_lines,
				 ...)
	}
	invisible()
})

#' @include s4-unions.r dist-matrix-coerce.r accessor-generics.r
NULL

#' Sigmas Object
#'
#' Holds the information about how the \code{sigma} parameter for a \link{DiffusionMap} was obtained,
#' and in this way provides a plotting function for the \link{find_sigmas} heuristic.
#' You should not need to create a Sigmas object yourself. Provide \code{sigma} to \link{DiffusionMap} instead or use \link{find_sigmas}.
#'
#' A Sigmas object is either created by \link{find_sigmas} or by specifying the \code{sigma} parameter to \link{DiffusionMap}.
#'
#' In the second case, if the \code{sigma} parameter is just a number,
#' the resulting \code{Sigmas} object has all slots except of \code{optimal_sigma} set to \code{NULL}.
#'
#' @usage Sigmas(...)
#'
#' @param ... See \dQuote{\strong{Slots}} below
#' @param object,x  \link{Sigmas} object
#'
#' @return \code{Sigmas} creates an object of the same class
#'
#' @slot log_sigmas     Vector of length \eqn{m} containing the \eqn{\log_{10}} of the \eqn{\sigma}s
#' @slot dim_norms      Vector of length \eqn{m-1} containing the average dimensionality \eqn{\langle p \rangle} for the respective kernel widths
#' @slot optimal_sigma  Multiple local sigmas or the mean of the two global \eqn{\sigma}s around the highest \eqn{\langle p \rangle} (\code{c(optimal_idx, optimal_idx+1L)})
#' @slot optimal_idx    The index of the highest \eqn{\langle p \rangle}.
#' @slot avrd_norms     Vector of length \eqn{m} containing the average dimensionality for the corresponding sigma.
#'
#' @examples
#' data(guo)
#' sigs <- find_sigmas(guo, verbose = FALSE)
#' optimal_sigma(sigs)
#' print(sigs)
#'
#' @seealso \code{\link{find_sigmas}}, the function to determine a locally optimal sigma and returning this class
#'
#' @aliases Sigmas-methods
#'
#' @importFrom methods setClass
#' @rdname Sigmas-class
#' @export Sigmas
#' @exportClass Sigmas
Sigmas <- setClass('Sigmas', slots = c( # nolint: object_name_linter.
	log_sigmas    = 'numericOrNULL',
	dim_norms     = 'numericOrNULL',
	optimal_sigma = 'numericOrNULL',
	optimal_idx   = 'integerOrNULL',
	avrd_norms    = 'numericOrNULL'))

#' @return \code{optimal_sigma} retrieves the numeric value of the optimal sigma or local sigmas
#' @rdname Sigmas-class
#' @export
setMethod('optimal_sigma', 'Sigmas', function(object) object@optimal_sigma)

#' @rdname Sigmas-class
#' @export
setMethod('print', 'Sigmas', function(x) {
	cat(sprintf('Sigmas (%s Steps performed)\noptimal_sigma: ', length(x@log_sigmas)))
	str(optimal_sigma(x))
	invisible(x)
})

#' @importFrom graphics plot
#' @rdname Sigmas-class
#' @export
setMethod('show', 'Sigmas', function(object) {
	plot(object)
	invisible()
})

#' Calculate the average dimensionality for m different gaussian kernel widths (\eqn{\sigma}).
#'
#' The sigma with the maximum value in average dimensionality is close to the ideal one.
#' Increasing step number gets this nearer to the ideal one.
#'
#' @param data           Data set with \eqn{n} observations. Can be a \link[base]{data.frame},
#'                       \link[base]{matrix}, \link[Biobase:class.ExpressionSet]{ExpressionSet}
#'                       or \link[SingleCellExperiment]{SingleCellExperiment}.
#' @param step_size      Size of log-sigma steps
#' @param steps          Number of steps/calculations
#' @param start          Initial value to search from. (Optional. default: \eqn{\log_{10}(min(dist(data)))})
#' @param sample_rows    Number of random rows to use for sigma estimation or vector of row indices/names to use.
#'                       In the first case, only used if actually smaller than the number of available rows (Optional. default: 500)
#' @param early_exit     logical. If TRUE, return if the first local maximum is found, else keep running
#' @param ...            Unused. All parameters to the right of the \code{...} have to be specified by name (e.g. \code{find_sigmas(data, verbose = FALSE)})
#' @param censor_val     Value regarded as uncertain. Either a single value or one for every dimension
#' @param censor_range   Uncertainity range for censoring. A length-2-vector of certainty range start and end. TODO: also allow \eqn{2\times G} matrix
#' @param missing_range  Whole data range for missing value model. Has to be specified if NAs are in the data
#' @param vars           Variables (columns) of the data to use. Specifying TRUE will select all columns (default: All floating point value columns)
#' @param verbose        logical. If TRUE, show a progress bar and plot the output
#'
#' @return Object of class \link{Sigmas}
#'
#' @seealso \code{\link{Sigmas}}, the class returned by this; \code{\link{DiffusionMap}}, the class this is used for
#'
#' @examples
#' data(guo)
#' sigs <- find_sigmas(guo, verbose = TRUE)
#' DiffusionMap(guo, sigs)
#'
#' @importFrom methods as
#' @importFrom graphics plot
#' @importFrom utils txtProgressBar setTxtProgressBar
#' @importFrom Matrix colSums rowSums
#' @importFrom proxy dist
#' @export
find_sigmas <- function( # nolint: cyclocomp_linter.
	data,
	step_size = .1, steps = 10L,
	start = NULL,
	sample_rows = 500L,
	early_exit = FALSE,
	...,
	censor_val = NULL, censor_range = NULL,
	missing_range = NULL,
	vars = NULL,
	verbose = TRUE
) {
	chkDots(...)
	data <- dataset_extract_doublematrix(data, vars)

	if (any(is.na(data)))
		data <- as.matrix(hotdeck(data, imp_var = FALSE))

	stopifnot(steps >= 3L)

	if (length(sample_rows) > 1L) {
		data <- data[sample_rows, ]
	} else if (nrow(data) > sample_rows) {
		sample_idx <- sample(nrow(data), sample_rows)
		data <- data[sample_idx, ]
	}

	n <- nrow(data)

	dists <- dist(data)

	min_dist <- min(dists)
	if (min_dist == 0)
		stop('Minimum distance in the data may not be 0')
	dists <- as(dists, 'symmetricMatrix')

	if (is.null(start))
		start <- log10(min_dist)

	if (verbose) print(c(min_dist = min_dist, start = start, step_size = step_size))

	get_trans_p <-
		if (test_censoring(censor_val, censor_range, data, missing_range)) {
			function(sigma) censoring(data, sigma, dists, censor_val, censor_range, missing_range)
		} else {
			msqd <- -(dists ^ 2)
			function(sigma) exp(msqd / (2 * sigma ^ 2))
		}

	do_step <- function(i) {
		# i can be negative!
		log_sigma <- start + i * step_size
		trans_p <- get_trans_p(10 ^ log_sigma)

		diag_d <- colSums(trans_p, na.rm = TRUE)

		list(avrd_norm = (sum(log10(diag_d / n) / diag_d)) / sum(1 / diag_d),
		     log_sigma = log_sigma)
	}

	avrd_norms <- numeric(steps)
	log_sigmas <- numeric(steps)
	dim_norms  <- numeric(steps - 1)

	step_diff <- function(step) {
		idxs <- c(step, step - 1)
		diff(avrd_norms[idxs]) / diff(log_sigmas[idxs])
	}

	a0 <- do_step(0L)
	avrd_norms[[1L]] <- a0$avrd_norm
	log_sigmas[[1L]] <- a0$log_sigma

	a1 <- do_step(1)
	dir <- 1L
	avrd_norms[[2L]] <- a1$avrd_norm
	log_sigmas[[2L]] <- a1$log_sigma

	if (step_diff(2L) < 0) {
		a1 <- do_step(-1L)
		dir <- -1L
		avrd_norms[[2L]] <- a1$avrd_norm
		log_sigmas[[2L]] <- a1$log_sigma
	}

	dim_norms[[1L]] <- step_diff(2L)

	if (verbose) pb <- txtProgressBar(2L, steps, 1L, style = 3)
	for (step in seq(2L, steps)) {
		a_i <- do_step(dir * (step - 1L))
		avrd_norms[[step]] <- a_i$avrd_norm
		log_sigmas[[step]] <- a_i$log_sigma

		dif_step <- step - 1
		dim_norms[[dif_step]] <- step_diff(step)

		if (verbose) setTxtProgressBar(pb, step)

		if (early_exit && step > 2 && dim_norms[[dif_step]] < dim_norms[[dif_step - 1L]]) {
			avrd_norms <- avrd_norms[seq_len(step)]
			log_sigmas <- log_sigmas[seq_len(step)]
			dim_norms  <- dim_norms[seq_len(dif_step)]
			break
		}
	}
	if (verbose) {
		setTxtProgressBar(pb, steps)
		close(pb)
	}

	if (early_exit && step == steps) warning('All steps were exhausted without finding a maximum. Using last encountered sigma')

	optimal_idx <- which.max(dim_norms)

	ret <- Sigmas(
		log_sigmas = log_sigmas,
		dim_norms  = dim_norms,
		optimal_sigma = 10 ^ mean(log_sigmas[c(optimal_idx, optimal_idx + 1L)]),
		optimal_idx   = optimal_idx,
		avrd_norms = avrd_norms)

	if (verbose) plot(ret)

	ret
}

#' @include diffusionmap.r s4-unions.r
NULL

#' Gene relevances for entire data set
#'
#' The relevance map is cached inside of the \code{\link{DiffusionMap}}.
#'
#' @param coords           A \code{\link{DiffusionMap}} object or a cells \eqn{\times} dims \code{\link{matrix}}.
#' @param exprs            An cells \eqn{\times} genes \code{\link{matrix}}. Only provide if \code{coords} is no \code{\link{DiffusionMap}}.
#' @param ...              Unused. All parameters to the right of the \code{...} have to be specified by name.
#' @param k                Number of nearest neighbors to use
#' @param dims             Index into columns of \code{coord}
#' @param distance         Distance measure to use for the nearest neighbor search.
#' @param smooth           Smoothing parameters \code{c(window, alpha)}.
#'                         Alternatively \code{\link{TRUE}} to use the defaults
#'                         or \code{\link{FALSE}} to skip smoothing,
#' @param remove_outliers  Remove cells that are only within one other cell's nearest neighbor, as they tend to get large norms.
#' @param pcs              A cell \eqn{\times} \code{n_pcs} matrix of principal components to use for the distances.
#' @param knn_params       A \code{\link{list}} of parameters for \code{\link{find_knn}}.
#' @param weights          Weights for the partial derivatives. A vector of the same length as \code{dims}.
#' @param verbose          If TRUE, log additional info to the console
#'
#' @return A \code{GeneRelevance} object:
#'
#' @slot coords         A cells \eqn{\times} dims \code{\link{matrix}} or \code{\link[Matrix:sparseMatrix-class]{sparseMatrix}}
#'                      of coordinates (e.g. diffusion components), reduced to the dimensions passed as \code{dims}
#' @slot exprs          A cells \eqn{\times} genes matrix of expressions
#' @slot partials       Array of partial derivatives wrt to considered dimensions in reduced space
#'                      (genes \eqn{\times} cells \eqn{\times} dimensions)
#' @slot partials_norm  Matrix with norm of aforementioned derivatives. (n\_genes \eqn{\times} cells)
#' @slot nn_index       Matrix of k nearest neighbor indices. (cells \eqn{\times} k)
#' @slot dims           Column index for plotted dimensions. Can \code{\link{character}}, \code{\link{numeric}} or \code{\link{logical}}
#' @slot distance       Distance measure used in the nearest neighbor search. See \code{\link{find_knn}}
#' @slot smooth_window  Smoothing window used
#' @slot smooth_alpha   Smoothing kernel width used
#'
#' @seealso \link{Gene Relevance methods}, \link{Gene Relevance plotting}: \code{plot_differential_map}/\code{plot_gene_relevance}
#'
#' @examples
#' data(guo_norm)
#' dm <- DiffusionMap(guo_norm)
#' gr <- gene_relevance(dm)
#'
#' m <- t(Biobase::exprs(guo_norm))
#' gr_pca <- gene_relevance(prcomp(m)$x, m)
#' # now plot them!
#'
#' @rdname Gene-Relevance
#' @export
setClass('GeneRelevance', slots = c(
	coords = 'matrix',
	exprs = 'dMatrixOrMatrix',
	partials = 'array',
	partials_norm = 'matrix',
	nn_index = 'matrix',  # Derived `k = ncol(nn_index)`
	dims = 'ColIndex',
	distance = 'character',
	smooth_window = 'numeric',
	smooth_alpha = 'numeric'))

#' @rdname Gene-Relevance
#' @export
setGeneric('gene_relevance', function( # nolint: brace_linter.
	coords, exprs, ...,
	k = 20L, dims = 1:2, distance = NULL, smooth = TRUE, remove_outliers = FALSE, verbose = FALSE
) standardGeneric('gene_relevance'))

#' @importFrom Biobase updateObject
#' @rdname Gene-Relevance
#' @export
setMethod('gene_relevance', c('DiffusionMap', 'missing'), function( # nolint: cyclocomp_linter.
	coords, exprs, ..., k,
	dims, distance, smooth, remove_outliers, verbose
) {
	dm <- updateObject(coords)
	relevance_map <- updateObject(dm@data_env$relevance_map)
	smooth <- get_smoothing(smooth)
	if (is.null(relevance_map) ||
		ncol(relevance_map@nn_index) != k ||
		!identical(relevance_map@dims, dims) ||
		!identical(relevance_map@smooth_window, smooth[[1L]]) ||
		!identical(relevance_map@smooth_alpha,  smooth[[2L]])
	) {
		coords <- eigenvectors(dm)
		if (dm@distance == 'custom') stop('Gene relevance cannot be computed from a diffusion map with a custom distance matrix.')
		exprs <- dataset_extract_doublematrix(dataset(dm))
		pcs <- get_pca(exprs, dataset(dm), dm@n_pcs, verbose)
		weights <- eigenvalues(dm)[dims]
		if (is.null(distance)) distance <- dm@distance
		else if (!identical(distance, dm@distance)) stop('the specified distance ', distance, ' is not the same as the one used for the diffusion map: ', dm@distance)
		relevance_map <- gene_relevance(
			coords, exprs, ...,
			k = k, dims = dims, distance = distance, smooth = smooth, remove_outliers = remove_outliers, verbose = verbose,
			pcs = pcs, knn_params = dm@knn_params, weights = weights
		)
		dm@data_env$relevance_map <- relevance_map
	} else {
		chkDots(...)
	}
	relevance_map
})

#' @importFrom methods is
#' @importFrom Biobase rowMedians
#' @importFrom Matrix nnzero
#' @rdname Gene-Relevance
#' @export
setMethod('gene_relevance', c('matrix', 'dMatrixOrMatrix'), function(
	coords, exprs, ...,
	pcs = NULL, knn_params = list(), weights = 1,
	k, dims, distance, smooth, remove_outliers, verbose
) {
	chkDots(...)
	distance <- match.arg(distance, c('euclidean', 'cosine', 'rankcor', 'l2'))
	coords_used <- coords[, dims, drop = FALSE]
	n_dims <- ncol(coords_used)
	if (length(weights) == 1L) weights <- rep(weights, n_dims)
	smooth <- get_smoothing(smooth)

	if (is.null(colnames(exprs))) stop('The expression matrix columns need to be named but are NULL')
	if (n_dims != length(weights)) stop(n_dims, ' dimensions, but ', length(weights), ' weights were provided')

	nn_index <- do.call(find_knn, c(list(if (is.null(pcs)) exprs else pcs, k, distance = distance), knn_params))$index

	k <- ncol(nn_index)
	n_cells <- nrow(coords_used)
	n_genes <- ncol(exprs)
	partials <- array(
		NA,
		dim = c(n_cells, n_genes, n_dims),
		dimnames = list(rownames(exprs), colnames(exprs), if (is.character(dims)) dims else colnames(coords_used)))

	# a very small value to subtract from the differential
	values <- if (is(exprs, 'Matrix')) exprs@x else exprs
	small <- min(values[values != 0]) / (length(exprs) - nnzero(exprs))
	if (verbose) cat('Calculating expression differential\n')
	gene_differential <- function(expr_gene) {
		# Compute change in expression
		# Do not compute if reference is zero, could be drop-out
		expr_masked <- expr_gene
		expr_masked[expr_masked == 0] <- small
		differential_expr <- apply(nn_index, 2, function(nn) expr_gene[nn] - expr_masked)
		differential_expr[differential_expr == 0] <- NA  # Cannot evaluate partial
		#assert stopifnot(identical(dim(differential_expr), c(n_cells, k)))
		differential_expr
	}
	differential_exprs <- apply(exprs, 2L, gene_differential)
	#assert stopifnot(identical(dim(differential_exprs), c(n_cells * k, n_genes)))
	# apply only handles returning vectors, so we have to reshape the return value
	dim(differential_exprs) <- c(n_cells, k, n_genes)
	dimnames(differential_exprs)[[3L]] <- if (length(colnames(exprs)) > 1L) colnames(exprs) else list(colnames(exprs))
	#assert stopifnot(identical(gene_differential(exprs[, 1L]), differential_exprs[, , 1L]))

	for (d in seq_len(n_dims)) {
		# Compute partial derivatives in direction of current dimension

		if (verbose) cat('Calculating partial derivatives of dimension ', d, '/', n_dims, '\n')
		# We could optionaly add normalization by max(coords_used[, d]) - min(coords_used[, d])
		differential_coord <- apply(nn_index, 2L, function(nn) coords_used[nn, d] - coords_used[, d])

		partials_unweighted <- apply(differential_exprs, 3L, function(grad_gene_exprs) {
			# Compute median of difference quotients to NN
			difference_quotients <- grad_gene_exprs / differential_coord
			# Only compute differential if at least two observations are present!
			stable_cells <- rowSums(!is.na(difference_quotients)) >= 2L
			ifelse(stable_cells, rowMedians(difference_quotients, na.rm = TRUE), NA)
		})
		colnames(partials_unweighted) <- colnames(exprs)

		if (!any(is.na(smooth))) {
			order_coor <- order(coords_used[, d])
			order_orig <- order(order_coor)
			# Smooth the partials for each gene across all cells
			partials_unweighted <- apply(partials_unweighted, 2L, function(partials_gene) {
				ordered <- partials_gene[order_coor]
				smoothed <- smth.gaussian(ordered, smooth[[1L]], smooth[[2L]], tails = TRUE)
				smoothed[order_orig]
			})
			colnames(partials_unweighted) <- colnames(exprs)
		}

		partials[, , d] <- weights[[d]] * partials_unweighted
	}

	# Compute norm over partial derivates: Frobenius
	partials_norm <- apply(partials, c(1, 2), function(z) sqrt(sum(z^2, na.rm = TRUE)))
	colnames(partials_norm) <- colnames(partials)

	# Find outlier cells: Not in NN of more than 1 other cell
	# Remove these as they tend to receive very large norms
	if (remove_outliers) {
		outliers <- sapply(seq_len(n_cells), function(cell) sum(nn_index == cell) > 1)
		partials_norm[, outliers] <- NA
	}

	# Prepare output
	rownames(partials_norm) <- rownames(partials)
	colnames(partials_norm) <- colnames(partials)
	new('GeneRelevance',
		coords = coords,
		exprs = exprs,
		partials = partials,
		partials_norm = partials_norm,
		nn_index = nn_index,
		dims = dims,
		smooth_window = smooth[[1L]],
		smooth_alpha  = smooth[[2L]],
		distance = distance)
})

get_smoothing <- function(smooth) {
	if (isTRUE(smooth)) c(getOption('smoother.window', 0.1), getOption('smoother.gaussianwindow.alpha', 2.5))
	else if (identical(smooth, FALSE)) c(NA_real_, NA_real_)
	else if (!is.numeric(smooth) || length(smooth) != 2L)
		stop('`smooth` needs to be TRUE, FALSE or a numeric c(window, alpha), not', capture.output(str(smooth)))
	else smooth
}

#' @include gene-relevance.r
#' @importFrom Biobase featureNames featureNames<-
NULL

#' Gene Relevance methods
#'
#' \code{featureNames <- ...} can be used to set the gene names used for plotting
#' (e.g. if the data contains hardly readably gene or transcript IDs).
#' \code{dataset} gets the expressions used for the gene relevance calculations,
#' and \code{distance} the distance measure.
#'
#' @param x,object  \code{GeneRelevance} object
#' @param value     A text vector (\code{\link{character}} or \code{\link{factor}})
#'
#' @return
#' \code{dataset}, \code{distance}, and \code{featureNames} return the stored properties.
#' The other methods return a \code{GeneRelevance} object (\code{print}, \code{... <- ...}),
#' or NULL (\code{show}), invisibly
#'
#' @seealso \code{\link{gene_relevance}}, \link{Gene Relevance plotting}
#'
#' @examples
#' data(guo_norm)
#' dm <- DiffusionMap(guo_norm)
#' gr <- gene_relevance(dm)
#' stopifnot(distance(gr) == distance(dm))
#' featureNames(gr)[[37]] <- 'Id2 (suppresses differentiation)'
#' # now plot it with the changed gene name(s)
#'
#' @aliases featureNames.GeneRelevance dataset.GeneRelevance
#' @name Gene Relevance methods
#' @rdname Gene-Relevance-methods
NULL


#' @importFrom methods is
#' @importFrom utils str
#'
#' @rdname Gene-Relevance-methods
#' @export
setMethod('print', 'GeneRelevance', function(x) {
	d <- dataset(x)
	cat(sprintf('GeneRelevance (%s genes, %s reduced dimensions, and %s observations)\n', ncol(x@exprs), ncol(x@coords), nrow(x@exprs)))
	cat('is:      ')
	if (is(d, 'Matrix')) cat(sprintf('%s%s%s %s (%s)\n', nrow(d), sym_times, ncol(d), class(d)[[1L]], mode(d@x)))
	else str(structure(d, dimnames = NULL))
	cat('featureNames: '); str(featureNames(x)) # nolint: semicolon_linter.
	invisible(x)
})

#' @importFrom methods show
#'
#' @rdname Gene-Relevance-methods
#' @export
setMethod('show', 'GeneRelevance', function(object) {
	print(object)
	invisible()
})


#' @rdname Gene-Relevance-methods
#' @export
setMethod('featureNames', 'GeneRelevance', function(object) colnames(object@exprs))

#' @rdname Gene-Relevance-methods
#' @export
setMethod('featureNames<-', c('GeneRelevance', 'characterOrFactor'), function(object, value) {
	object <- updateObject(object)
	colnames(object@exprs) <-
		colnames(object@partials_norm) <-
		colnames(object@partials) <-
		value
	object
})


#' @rdname Gene-Relevance-methods
#' @export
setMethod('dataset', 'GeneRelevance', function(object) object@exprs)

#' @rdname Gene-Relevance-methods
#' @export
setMethod('dataset<-', 'GeneRelevance', function(object, value) {
	object <- updateObject(object)
	object@exprs <- value
	validObject(object)
	object
})


#' @rdname Gene-Relevance-methods
#' @export
setMethod('distance', 'GeneRelevance', function(object) object@distance)

#' @rdname Gene-Relevance-methods
#' @export
setMethod('distance<-', 'GeneRelevance', function(object, value) {
	object@distance <- value
	validObject(object)
	object
})

library(destiny)

data(guo)

dark2 <- scales::brewer_pal(palette = 'Dark2')
palette(dark2(8L))




dm_guo <- DiffusionMap(guo, verbose = FALSE,
                       censor_val = 10, censor_range = c(10, 40))
plot(dm_guo,
     col = guo$num_cells, pch = 20)




sigmas <- find_sigmas(guo, verbose = FALSE,
                      censor_val = 10, censor_range = c(10, 40))
par(lwd = 3)
plot(sigmas,
    col           = palette()[[1]],
    col_highlight = palette()[[4]],
    col_line      = palette()[[6]])




dm_guo_global <- DiffusionMap(guo, sigmas, verbose = FALSE,
                              censor_val = 10, censor_range = c(10, 40))
plot(dm_guo_global,
     col = guo$num_cells, pch = 20)

context('utils')

library(Matrix)

test_that('duplicated.dgCMatrix works', {
	m <- Matrix(c(
		1, 1, 2,
		0, 0, 0,
		3, 3, 0,
		3, 3, 0,
		0, 0, 0
	), 5L, 3L, TRUE, sparse = TRUE)
	expect_is(m, 'dgCMatrix')

	expect_identical(duplicated(m), c(FALSE, FALSE, FALSE, TRUE, TRUE))
	expect_identical(duplicated(m, MARGIN = 2), c(FALSE, TRUE, FALSE))
	expect_error(duplicated(m, MARGIN = 3), 'Invalid MARGIN 3')
})

test_that('duplicated.dgCMatrix works with zero columns', {
	m <- sparseMatrix(
		c(1, 1, 1, 2, 1),
		c(1, 2, 4, 4, 6),
		x = c(1, 1, 2, 3, 1))
	expect_is(m, 'dgCMatrix')

	expect_identical(which(duplicated(m, MARGIN = 2)), c(2L, 5L, 6L))
})

---
title: Reproduce the Diffusion Map vignette with the supplied data()
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Reproduce the Diffusion Map vignette with the supplied data()}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(fig.width=6, fig.asp=0.7)
```

Quickstart
==========

A short version to achive the above is by using the preprocessed version of the dataset provided with this package. `data(guo)` is already preprocessed (using the method first mentioned), has its threshold set to a constant 15 and is ready to use. Since the platform’s maximum amplification cycles are 40, that number can be used as upper border of the uncertainty range.

```{r}
library(destiny)
data(guo)
```

It can be used directly for diffusion map creation:

```{r}
dm_guo <- DiffusionMap(guo, verbose = FALSE,
                       censor_val = 15, censor_range = c(15, 40))
dm_guo
```

```{r}
plot(dm_guo)
```

using the annotation shows that the approximation worked

```{r}
palette(cube_helix(6))
plot(dm_guo, col_by = 'num_cells',
     legend_main = 'Cell stage')
```

References
==========

<div id="refs"></div>

---
title: destiny 2.0 brought the Diffusion Pseudo Time (DPT) class
output: rmarkdown::html_vignette
bibliography: bibliography.bib
vignette: >
  %\VignetteIndexEntry{destiny 2.0 brought the Diffusion Pseudo Time (DPT) class}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(fig.width=6, fig.asp=0.7)
```

```{r}
set.seed(1)
```

Diffusion Pseudo Time (DPT) is a pseudo time metric based on the transition probability of a diffusion process [@haghverdi_diffusion_2016].

*destiny*  supports `DPT` in addition to its primary function of creating `DiffusionMap`s from data.

```{r}
library(destiny)    # load destiny…
data(guo)           # …and sample data
library(gridExtra)  # Also we need grid.arrange
```

`DPT` is in practice independent of Diffusion Maps:

```{r}
par(mar = rep(0, 4))
graph <- igraph::graph_from_literal(
    data - + 'transition probabilities' - + DiffusionMap,
    'transition probabilities' - + DPT)
plot(
    graph, layout = igraph::layout_as_tree,
    vertex.size = 50,
    vertex.color = 'transparent',
    vertex.frame.color = 'transparent',
    vertex.label.color = 'black')
```

However in order not to overcomplicate things, in *destiny*, you have to create `DPT` objects from `DiffusionMap` objects.  
<small>(If you really only need the DPT, skip Diffusion Component creation by specifying `n_eigs = 0`)</small>

```{r}
dm <- DiffusionMap(guo)
dpt <- DPT(dm)
```

The resulting object of a call like this will have three automatically chosen tip cells. You can also specify tip cells:

```{r}
set.seed(4)
dpt_random <- DPT(dm, tips = sample(ncol(guo), 3L))
```

Plotting without parameters results in the DPT of the first root cell:

```{r, fig.asp=0.4}
grid.arrange(plot(dpt), plot(dpt_random), ncol = 2)
```

Other possibilities include the DPT from the other tips or everything supported by `plot.DiffusionMap`:

```{r, fig.asp=0.4}
grid.arrange(
    plot(dpt, col_by = 'DPT3'),
    plot(dpt, col_by = 'Gata4', pal = viridis::magma),
    ncol = 2
)
```

The `DPT` object also contains a clustering based on the tip cells and DPT, and you can specify where to draw paths from and to:

```{r}
plot(dpt, root = 2, paths_to = c(1, 3), col_by = 'branch')
```

You can further divide branches. First simply plot branch colors like we did above, then identify the number of the branch you intend to plot, and then specify it in a subsequent `plot` call. In order to see the new branches best, we specify a `dcs` argument that visually spreads out out all four branches.

```{r}
plot(dpt, col_by = 'branch', divide = 3, dcs = c(-1, -3, 2), pch = 20)
```

References
==========

<div id="refs"></div>

---
title: detecting relevant genes with destiny 3
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{detecting relevant genes with destiny 3}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(fig.width=6, fig.asp=0.7)
```

Single Cell RNA-Sequencing data and gene relevance
==================================================

Libraries
---------

We need of course destiny, scran for preprocessing, and some tidyverse niceties.

```{r}
library(conflicted)
library(destiny)
suppressPackageStartupMessages(library(scran))
library(purrr)
library(ggplot2)
library(SingleCellExperiment)
```

Data
----

Let’s use data from the `scRNAseq`[1] package. If necessary, install it via `BiocManager::install('scRNAseq')`.

[1] Risso D, Cole M (2019). [scRNAseq: A Collection of Public Single-Cell RNA-Seq Datasets](https://bioconductor.org/packages/scRNAseq/).

```{r}
# The parts of the help we’re interested in
help('scRNAseq-package', package = 'scRNAseq') %>%
    repr::repr_html() %>%
    stringr::str_extract_all(stringr::regex('<p>The dataset.*?</p>', dotall = TRUE)) %>%
    unlist() %>%
    paste(collapse = '') %>%
    knitr::raw_html()
```

379 cells seems sufficient to see something!

```{r}
allen <- scRNAseq::ReprocessedAllenData()
```

Preprocessing
-------------

We’ll mostly stick to the [scran vignette][] here. Let’s add basic information to the data and choose what to work with.

As `scran` expects the raw counts in the `counts` assay, we rename the more accurate RSEM counts to `counts`.
Our data has ERCC spike-ins in an `altExp` slot:

[scran vignette]: https://bioconductor.org/packages/devel/bioc/vignettes/scran/inst/doc/scran.html

```{r}
rowData(allen)$Symbol <- rownames(allen)
rowData(allen)$EntrezID <- AnnotationDbi::mapIds(org.Mm.eg.db::org.Mm.eg.db, rownames(allen), 'ENTREZID', 'ALIAS')
rowData(allen)$Uniprot <- AnnotationDbi::mapIds(org.Mm.eg.db::org.Mm.eg.db, rownames(allen), 'UNIPROT', 'ALIAS', multiVals = 'list')
assayNames(allen)[assayNames(allen) == 'rsem_counts'] <- 'counts'
assayNames(altExp(allen, 'ERCC'))[assayNames(altExp(allen, 'ERCC')) == 'rsem_counts'] <- 'counts'
allen
```

Now we can use it to renormalize the data. We normalize the `counts` using the spike-in size factors and logarithmize them into `logcounts`.

```{r}
allen <- computeSpikeFactors(allen, 'ERCC')
allen <- logNormCounts(allen)
allen
```

We also use the spike-ins to detect highly variable genes more accurately:

```{r}
decomp <- modelGeneVarWithSpikes(allen, 'ERCC')
rowData(allen)$hvg_order <- order(decomp$bio, decreasing = TRUE)
```

We create a subset of the data containing only rasonably highly variable genes:

```{r}
allen_hvg <- subset(allen, hvg_order <= 5000L)
```

Let’s create a Diffusion map. For rapid results, people often create a PCA first, which can be stored in your `SingleCellExperiment` before creating the Diffusion map or simply created implicitly using `DiffusionMap(..., n_pcs = <number>)`.

However, even with many more principal components than necessary to get a nicely resolved Diffusion Map, the close spatial correspondence between diffusion components and genes are lost.

```{r}
#To go from PCA: reducedDim(allen_hvg, 'pca') <- irlba::prcomp_irlba(t(assay(allen, 'logcounts')), 50)$x
```

The chosen distance metric has big implications on your results, you should try at least cosine and rankcor.

```{r}
set.seed(1)
dms <- c('euclidean', 'cosine', 'rankcor') %>% #, 'l2'
    set_names() %>%
    map(~ DiffusionMap(allen_hvg, distance = ., knn_params = list(method = 'covertree')))
```

```{r, fig.asp = 1/4, fig.width = 10}
dms %>%
    imap(function(dm, dist) plot(dm, 1:2, col_by = 'driver_1_s') + ggtitle(dist)) %>%
    cowplot::plot_grid(plotlist = ., nrow = 1)
```

```{r}
grs <- map(dms, gene_relevance)
```

```{r, fig.asp = 1/4, fig.width = 10}
gms <- imap(grs, function(gr, dist) plot(gr, iter_smooth = 0) + ggtitle(dist))
cowplot::plot_grid(plotlist = gms, nrow = 1)
```

As you can see, despite the quite different embedding, the rankcor and Cosine diffusion Maps display a number of the same driving genes.

```{r}
gms[-1] %>% map(~ .$ids[1:10]) %>% purrr::reduce(base::intersect) %>% cat(sep = ' ')
```

```{r}
options(readr.show_col_types = FALSE)
tryCatch({
    httr::GET('https://rest.uniprot.org/uniprotkb/search', query = list(
        fields = 'accession,gene_names,cc_tissue_specificity',
        format = 'tsv',
        query = rowData(allen)$Uniprot[gms$cosine$ids[1:6]] %>% unlist() %>% paste(collapse = ' OR ')
    )) %>%
        httr::content(type = 'text/tab-separated-values', encoding = 'utf-8')
}, error = function(e) e)
```

---
title: The effects of a global vs. local kernel
output: rmarkdown::html_vignette
bibliography: bibliography.bib
vignette: >
  %\VignetteIndexEntry{The effects of a global vs. local kernel}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

Gaussian kernel width `sigma`
=============================

The other important parameter for `DiffusionMap` is the Gaussian kernel width `sigma` ($\sigma$) that determines the transition probability between data points. The default call of **destiny** – `DiffusionMap(data)` aka `DiffusionMap(data, 'local')`) – uses a local `sigma` per cell, derived from a local density estimate around each cell.

Using the 1.0 default, `sigma = 'global'`, estimates sigma using a heuristic. It is also possible to specify this parameter manually to tweak the result. The eigenvector plot explained above will show a continuous decline instead of sharp drops if either the dataset is too big or the `sigma` is chosen too small.

The sigma estimation algorithm is explained in detail in @haghverdi_diffusion_2015. In brief, it works by finding a maximum in the slope of the log-log plot of local density versus `sigma`.

```{r}
library(destiny)
data(guo_norm)
```

Using find_sigmas
-----------------

An efficient variant of that procedure is provided by `find_sigmas`. This function determines the optimal sigma for a subset of the given data and provides the default sigma for a `DiffusionMap` call. Due to a different starting point, the resulting sigma is different from above:

```{r}
sigmas <- find_sigmas(guo_norm, verbose = FALSE)
optimal_sigma(sigmas)
```

The resulting diffusion map’s approximation depends on the chosen sigma. Note that the sigma estimation heuristic only finds local optima and even the global optimum of the heuristic might not be ideal for your data.

```{r}
palette(cube_helix(6))

plots <- lapply(
  list('local', 5, round(optimal_sigma(sigmas), 2), 100),
  function(sigma) {
    plot(
      DiffusionMap(guo_norm, sigma), 1:2,
      main = paste('σ =', sigma),
      col_by = 'num_cells', draw_legend = FALSE)
  }
)

do.call(gridExtra::grid.arrange, c(plots, ncol = 2))
```

References
==========

<div id="refs"></div>

---
title: The effects of a global vs. local kernel
output: rmarkdown::html_vignette
bibliography: bibliography.bib
vignette: >
  %\VignetteIndexEntry{The effects of a global vs. local kernel}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(fig.width=6, fig.asp=0.7)
```

Gaussian kernel width `sigma`
=============================

The other important parameter for `DiffusionMap` is the Gaussian kernel width `sigma` ($\sigma$) that determines the transition probability between data points. The default call of **destiny** – `DiffusionMap(data)` aka `DiffusionMap(data, 'local')`) – uses a local `sigma` per cell, derived from a local density estimate around each cell.

Using the 1.0 default, `sigma = 'global'`, estimates sigma using a heuristic. It is also possible to specify this parameter manually to tweak the result. The eigenvector plot explained above will show a continuous decline instead of sharp drops if either the dataset is too big or the `sigma` is chosen too small.

The sigma estimation algorithm is explained in detail in @haghverdi_diffusion_2015. In brief, it works by finding a maximum in the slope of the log-log plot of local density versus `sigma`.

```{r}
library(destiny)
data(guo_norm)
```

Using find_sigmas
-----------------

An efficient variant of that procedure is provided by `find_sigmas`. This function determines the optimal sigma for a subset of the given data and provides the default sigma for a `DiffusionMap` call. Due to a different starting point, the resulting sigma is different from above:

```{r}
sigmas <- find_sigmas(guo_norm, verbose = FALSE)
optimal_sigma(sigmas)
```

The resulting diffusion map’s approximation depends on the chosen sigma. Note that the sigma estimation heuristic only finds local optima and even the global optimum of the heuristic might not be ideal for your data.

```{r, fig.width=10}
palette(cube_helix(6))

plots <- lapply(
  list('local', 5, round(optimal_sigma(sigmas), 2), 100),
  function(sigma) {
    plot(
      DiffusionMap(guo_norm, sigma), 1:2,
      main = paste('σ =', sigma),
      col_by = 'num_cells', draw_legend = FALSE)
  }
)

do.call(gridExtra::grid.arrange, c(plots, ncol = 2))
```

References
==========

<div id="refs"></div>

---
title: destiny 2.0 brought the Diffusion Pseudo Time (DPT) class
output: rmarkdown::html_vignette
bibliography: bibliography.bib
vignette: >
  %\VignetteIndexEntry{destiny 2.0 brought the Diffusion Pseudo Time (DPT) class}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r}
set.seed(1)
```

Diffusion Pseudo Time (DPT) is a pseudo time metric based on the transition probability of a diffusion process [@haghverdi_diffusion_2016].

*destiny*  supports `DPT` in addition to its primary function of creating `DiffusionMap`s from data.

```{r}
library(destiny)    # load destiny…
data(guo)           # …and sample data
library(gridExtra)  # Also we need grid.arrange
```

`DPT` is in practice independent of Diffusion Maps:

```{r}
par(mar = rep(0, 4))
graph <- igraph::graph_from_literal(
    data - + 'transition probabilities' - + DiffusionMap,
    'transition probabilities' - + DPT)
plot(
    graph, layout = igraph::layout_as_tree,
    vertex.size = 50,
    vertex.color = 'transparent',
    vertex.frame.color = 'transparent',
    vertex.label.color = 'black')
```

However in order not to overcomplicate things, in *destiny*, you have to create `DPT` objects from `DiffusionMap` objects.  
<small>(If you really only need the DPT, skip Diffusion Component creation by specifying `n_eigs = 0`)</small>

```{r}
dm <- DiffusionMap(guo)
dpt <- DPT(dm)
```

The resulting object of a call like this will have three automatically chosen tip cells. You can also specify tip cells:

```{r}
set.seed(4)
dpt_random <- DPT(dm, tips = sample(ncol(guo), 3L))
```

Plotting without parameters results in the DPT of the first root cell:

TODO: wide plot

```{r}
grid.arrange(plot(dpt), plot(dpt_random), ncol = 2)
```

Other possibilities include the DPT from the other tips or everything supported by `plot.DiffusionMap`:

TODO: wide plot

```{r}
grid.arrange(
    plot(dpt, col_by = 'DPT3'),
    plot(dpt, col_by = 'Gata4', pal = viridis::magma),
    ncol = 2
)
```

The `DPT` object also contains a clustering based on the tip cells and DPT, and you can specify where to draw paths from and to:

```{r}
plot(dpt, root = 2, paths_to = c(1, 3), col_by = 'branch')
```

You can further divide branches. First simply plot branch colors like we did above, then identify the number of the branch you intend to plot, and then specify it in a subsequent `plot` call. In order to see the new branches best, we specify a `dcs` argument that visually spreads out out all four branches.

```{r}
plot(dpt, col_by = 'branch', divide = 3, dcs = c(-1, -3, 2), pch = 20)
```

References
==========

<div id="refs"></div>

---
title: 'destiny main vignette: Start here!'
output: rmarkdown::html_vignette
bibliography: bibliography.bib
vignette: >
  %\VignetteIndexEntry{destiny main vignette: Start here!}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(fig.width=6, fig.asp=0.7)
```

```{r}
library(base64enc)
library(ggplot2)  # would shadow Biobase::exprs
library(gridExtra)  # For grid.arrange

suppressPackageStartupMessages({
    library(readxl)
    library(destiny)
    library(Biobase)
})
```

Diffusion maps are spectral method for non-linear dimension reduction introduced by @coifman_geometric_2005. Diffusion maps are based on a distance metric (diffusion distance) which is conceptually relevant to how differentiating cells follow noisy diffusion-like dynamics, moving from a pluripotent state towards more differentiated states.

The R package **destiny** implements the formulation of diffusion maps presented in @haghverdi_diffusion_2015 which is especially suited for analyzing single-cell gene expression data from time-course experiments. It implicitly arranges cells along their developmental path, with bifurcations where differentiation events occur.

In particular we follow @haghverdi_diffusion_2015 and present an implementation of diffusion maps in R that is less affected by sampling density heterogeneities and thus capable of identifying both abundant and rare cell populations. In addition, **destiny** implements complex noise models reflecting zero-inflation/censoring due to drop-out events in single-cell qPCR data and allows for missing values. Finally, we further improve on the implementation from @haghverdi_diffusion_2015, and implement a nearest neighbour approximation capable of handling very large data sets of up to 300.000 cells.

For those familiar with R, and data preprocessing, we recommend the section [Plotting](#Plotting).

All code in this vignette is accessible via `edit(vignette('destiny'))`

Preprocessing of single qPCR data
=================================

As an example, we present in the following the preprocessing of data from @guo_resolution_2010. This dataset was produced by the Biomark RT-qPCR system and contains Ct values for 48 genes of 442 mouse embryonic stem cells at 7 different developmental time points, from the zygote to blastocyst.

Starting at the totipotent 1-cell stage, cells transition smoothly in the transcriptional landscape towards either the trophoectoderm lineage or the inner cell mass. Subsequently, cells transition from the inner cell mass either towards the endoderm or epiblast lineage. This smooth transition from one developmental state to another, including two bifurcation events, is reflected in the expression profiles of the cells and can be visualized using **destiny**.

Import
------

Downloading the table S4 from the [publication website](http://www.sciencedirect.com/science/article/pii/S1534580710001103) will give you a spreadsheet “mmc4.xls”, from which the data can be loaded:

```{r}
library(readxl)
raw_ct <- read_xls('mmc4.xls', 'Sheet1')

raw_ct[1:9, 1:9]  #preview of a few rows and columns
```

The value 28 is the assumed background expression of 28 cycle times.

In order to easily clean and normalize the data without mangling the annotations, we convert the `data.frame` into a Bioconductor `ExpressionSet` using the `as.ExpressionSet` function from the **destiny** package, and assign it to the name `ct`:

```{r}
library(destiny)
library(Biobase)

# as.data.frame because ExpressionSets
# do not support readxl’s “tibbles”
ct <- as.ExpressionSet(as.data.frame(raw_ct))
ct
```

The advantage of `ExpressionSet` over `data.frame` is that tasks like normalizing the expressions are both faster and do not accidentally destroy annotations by applying “normalization” to columns that are not expressions. The approach of handling a separate expression `matrix` and annotation `data.frame` requires you to be careful when adding or removing samples on both variables, while `ExpressionSet` does it internally for you.

The object internally stores an expression matrix of features × samples, retrievable using `exprs(ct)`, and an annotation `data.frame` of samples × annotations as `phenoData(ct)`. Annotations can be accessed directly via `ct$column` and `ct[['column']]`. Note that the expression matrix is transposed compared to the usual samples × features `data.frame`.

Data cleaning
-------------

We remove all cells that have a value bigger than the background expression, indicating data points not available (`NA`). Also we remove cells from the 1 cell stage embryos, since they were treated systematically different [@guo_resolution_2010].

For this, we add an annotation column containing the embryonic cell stage for each sample by extracting the number of cells from the “Cell” annotation column:

```{r}
num_cells <- gsub('^(\\d+)C.*$', '\\1', ct$Cell)
ct$num_cells <- as.integer(num_cells)
```

We then use the new annotation column to create two filters:

```{r}
# cells from 2+ cell embryos
have_duplications <- ct$num_cells > 1
# cells with values <= 28
normal_vals <- apply(exprs(ct), 2, function(smp) all(smp <= 28))
```

We can use the combination of both filters to exclude both non-divided cells and such containing Ct values higher than the baseline, and store the result as `cleaned_ct`:

```{r}
cleaned_ct <- ct[, have_duplications & normal_vals]
```

Normalization
-------------

Finally we follow @guo_resolution_2010 and normalize each cell using the endogenous controls Actb and Gapdh by subtracting their average expression for each cell. Note that it is not clear how to normalise sc-qPCR data as the expression of housekeeping genes is also stochastic. Consequently, if such housekeeping normalisation is performed, it is crucial to take the mean of several genes.

```{r}
housekeepers <- c('Actb', 'Gapdh')  # houskeeper gene names

normalizations <- colMeans(exprs(cleaned_ct)[housekeepers, ])

guo_norm <- cleaned_ct
exprs(guo_norm) <- exprs(guo_norm) - normalizations
```

The resulting `ExpressionSet` contains the normalized Ct values of all cells retained after cleaning.

Plotting
========

The data necessary to create a diffusion map with our package is a a cell×gene `matrix` or `data.frame`, or alternatively an `ExpressionSet` (which has a gene×cell `exprs` matrix). In order to create a `DiffusionMap` object, you just need to supply one of those formats as first parameter to the `DiffusionMap` function. In the case of a `data.frame`, each floating point column is interpreted as expression levels, and columns of different type (e.g. `factor`, `character` or `integer`) are assumed to be annotations and ignored. Note that single-cell RNA-seq count data should be transformed using a variance-stabilizing transformation (e.g. log or rlog); the Ct scale for qPCR data is logarithmic already (an increase in 1 Ct corresponds to a doubling of transcripts).

In order to create a diffusion map to plot, you have to call `DiffusionMap`, optionally with parameters. If the number of cells is small enough (< ~1000), you do not need to specify approximations like `k` (for k nearest neighbors).

If you started reading here, execute `data(guo.norm)` to load the dataset that was created in the previous section.

```{r}
library(destiny)
#If you start here, run: data(guo_norm)
dm <- DiffusionMap(guo_norm)
```

Simply calling `plot` on the resulting object `dif` will visualize the diffusion components:

```{r}
plot(dm)
```

The diffusion map nicely illustrates a branching during the first days of embryonic development.

The annotation column containing the cell stage can be used to annotate our diffusion map. Using the annotation as `col` parameter will automatically color the map using the current R color palette. Use `palette(colors)` to configure it globally or `plot(..., pal = colors)` for one plot.

```{r}
palette(cube_helix(6)) # configure color palette

plot(dm,
    pch = 20,             # pch for prettier points
    col_by = 'num_cells', # or “col” with a vector or one color
    legend_main = 'Cell stage')
```

Three branches appear in the map, with a bifurcation occurring the 16 cell stage and the 32 cell stage. The diffusion map is able to arrange cells according to their expression profile: Cells that divided the most and the least appear at the tips of the different branches.

In order to display a 2D plot we supply a vector containing two diffusion component numbers (here 1 & 2) as second argument.

```{r}
plot(dm, 1:2,
    col_by = 'num_cells',
    legend_main = 'Cell stage')
```

Alternative visualizations
--------------------------

Diffusion maps consist of eigenvectors called Diffusion Components (DCs) and corresponding eigenvalues. Per default, the first 20 are returned.

You are also able to use packages for interative plots like `rgl` in a similar fashion, by directly subsetting the DCs using `eigenvectors(dif)`:

```{r}
if (require(rgl)) {
	plot3d(
	    eigenvectors(dm)[, 1:3],
	    col = log2(guo_norm$num_cells),
	    type = 's', radius = .01)
	view3d(theta = 10, phi = 30, zoom = .8)
	# now use your mouse to rotate the plot in the window
	close3d()
}
```

For the popular `ggplot2` package, there is built in support in the form of a `fortify.DiffusionMap` method, which allows to use DiffusionMap objects as `data` parameter in the `ggplot` and `qplot` functions. But the regular `plot` function already returns a `ggplot` object anyway.

```{r}
library(ggplot2)
ggplot(dm, aes(DC1, DC2, colour = factor(num_cells))) +
    geom_point() + scale_color_cube_helix()
```

As aesthetics, all diffusion components, gene expressions, and annotations are available. If you plan to make many plots, create a `data.frame` first by using `as.data.frame(dif)` or `fortify(dif)`, assign it to a variable name, and use it for plotting.

Parameter selection
===================

The most important parameter for the visualization, `dims`, is described in the following section. An important parameter in v1, $\sigma$, is explained in its own vignette “Global Sigma”.

[Other parameters](#Other-parameters) are explained at the end of this section.

Dimensions `dims`
-----------------

Diffusion maps consist of the eigenvectors (which we refer to as diffusion components) and corresponding eigenvalues of the diffusion distance matrix. The latter indicate the diffusion components’ importance, i.e. how well the eigenvectors approximate the data. The eigenvectors are decreasingly meaningful.

```{r}
ggplot(NULL, aes(x = seq_along(eigenvalues(dm)), y = eigenvalues(dm))) + theme_minimal() +
    geom_point() + labs(x = 'Diffusion component (DC)', y = 'Eigenvalue')
```

The later DCs often become noisy and less useful:

```{r, fig.asp=0.4}
grid.arrange(
	plot(dm, 3:4,   col_by = 'num_cells', draw_legend = FALSE),
	plot(dm, 19:20, col_by = 'num_cells', draw_legend = FALSE),
	ncol = 2)
```

Other parameters
----------------

If the automatic exclusion of categorical and integral features for data frames is not enough, you can also supply a vector of variable names or indices to use with the `vars` parameter. If you find that calculation time or used memory is too large, the parameter `k` allows you to decrease the quality/runtime+memory ratio by limiting the number of transitions calculated and stored. It is typically not needed if you have less than few thousand cells. The `n.eigs` parameter specifies the number of diffusion components returned.

For more information, consult `help(DiffusionMap)`.

Missing and uncertain values
============================

**destiny** is particularly well suited for gene expression data due to its ability to cope with missing and uncertain data.

Censored values
---------------

Platforms such as RT-qPCR cannot detect expression values below a certain threshold. To cope with this, **destiny** allows to censor specific values. In the case of @guo_resolution_2010, only up to 28 qPCR cycles were counted. All transcripts that would need more than 28 cycles are grouped together under this value. This is illustrated by gene Aqp3:

```{r}
hist(exprs(cleaned_ct)['Aqp3', ], breaks = 20,
     xlab = 'Ct of Aqp3', main = 'Histogram of Aqp3 Ct',
     col = palette()[[4]], border = 'white')
```

For our censoring noise model we need to identify the limit of detection (LoD). While most researchers use a global LoD of 28, reflecting the overall sensitivity of the qPCR machine, different strategies to quantitatively establish this gene-dependent LoD exist. For example, dilution series of bulk data can be used to establish an LoD such that a qPCR reaction will be detected with a specified probability if the Ct value is below the LoD. Here, we use such dilution series provided by Guo et al. and first determine a gene-wise LoD as the largest Ct value smaller than 28. We then follow the manual [Application Guidance: Single-Cell Data Analysis](https://www.bioke.com/Product%20Support/Manuals%20%26%20Downloads/?webshop_supplier=15&webshop_downloadtype=10&webshop_application=199&q=) of the popular Biomarks system and determine a global LoD as the median over the gene-wise LoDs. We use the dilution series from table S7 (`mmc6.xls`). If you have problems with the speed of `read.xlsx`, consider storing your data in tab separated value format and using `read.delim` or `read.ExpressionSet`.

```{r}
dilutions <- read_xls('mmc6.xls', 1L)
dilutions$Cell <- NULL  # remove annotation column

get_lod <- function(gene) gene[[max(which(gene != 28))]]

lods <- apply(dilutions, 2, get_lod)
lod <- ceiling(median(lods))
lod
```

This LoD of 25 and the maximum number of cycles the platform can perform (40), defines the uncertainty range that denotes the possible range of censored values in the censoring model. Using the mean of the normalization vector, we can adjust the uncertainty range and censoring value to be more similar to the other values in order to improve distance measures between data points:

```{r}
lod_norm <- ceiling(median(lods) - mean(normalizations))
max_cycles_norm <- ceiling(40 - mean(normalizations))

list(lod_norm = lod_norm, max_cycles_norm = max_cycles_norm)
```

We then also need to set the normalized values that should be censored – namely all data points were no expression was detected after the LoD – to this special value, because the values at the cycle threshold were changed due to normalization.

```{r}
guo <- guo_norm
exprs(guo)[exprs(cleaned_ct) >= 28] <- lod_norm
```

This version of the dataset is avaliable as `data(guo)` from the **destiny** package.

Now we call the the `DiffusionMap` function using the censoring model:

```{r}
thresh_dm <- DiffusionMap(guo,
    censor_val = lod_norm,
    censor_range = c(lod_norm, max_cycles_norm),
    verbose = FALSE)

plot(thresh_dm, 1:2, col_by = 'num_cells',
     legend_main = 'Cell stage')
```

Compared to the diffusion map created without censoring model, this map looks more homogeneous since it contains more data points.

Missing values
--------------

Gene expression experiments may fail to produce some data points, conventionally denoted as “not available” (`NA`). By calling `DiffusionMap(..., missings = c(total.minimum, total.maximum))`, you can specify the parameters for the missing value model.

As in the data from @guo_resolution_2010 no missing values occurred, we illustrate the capacity of **destiny** to handle missing values by artificially treating ct values of 999 (i. e. data points were no expression was detected after 40 cycles) as missing. This is purely for illustrative purposes and in practice these values should be treated as censored as illustrated in the previous section.

```{r}
# remove rows with divisionless cells
ct_w_missing <- ct[, ct$num_cells > 1L]
# and replace values larger than the baseline
exprs(ct_w_missing)[exprs(ct_w_missing) > 28] <- NA
```

We then perform normalization on this version of the data:

```{r}
housekeep <- colMeans(
    exprs(ct_w_missing)[housekeepers, ],
    na.rm = TRUE)

w_missing <- ct_w_missing
exprs(w_missing) <- exprs(w_missing) - housekeep

exprs(w_missing)[is.na(exprs(ct_w_missing))] <- lod_norm
```

Finally, we create a diffusion map with both missing value model and the censoring model from before:

```{r}
dif_w_missing <- DiffusionMap(w_missing,
    censor_val = lod_norm,
    censor_range = c(lod_norm, max_cycles_norm),
    missing_range = c(1, 40),
    verbose = FALSE)

plot(dif_w_missing, 1:2, col_by = 'num_cells',
     legend_main = 'Cell stage')
```

This result looks very similar to our previous diffusion map since only six additional data points have been added. However if your platform creates more missing values, including missing values will be more useful.

Prediction
==========

In order to project cells into an existing diffusion map, for example to compare two experiments measured by the same platform or to add new data to an existing map, we implemented `dm.predict`. It calculates the transition probabilities between datapoints in old and new data and projects cells into the diffusion map using the existing diffusion components.

As an example we assume that we created a diffusion map from one experiment on 64 cell stage embryos:

```{r}
ct64 <- guo[, guo$num_cells == 64]
dm64 <- DiffusionMap(ct64)
```

Let us compare the expressions from the 32 cell state embryos to the existing map. We use `dm.predict` to create the diffusion components for the new cells using the existing diffusion components from the old data: 

```{r}
ct32 <- guo[, guo$num_cells == 32]
pred32 <- dm_predict(dm64, ct32)
```

By providing the `more` and `col.more` parameters of the `plot` function, we show the first two DCs for both old and new data: 

```{r}
plot(dm64,    1:2,     col     = palette()[[6]],
     new_dcs = pred32, col_new = palette()[[4]])
```

Clearly, the 32 and 64 cell state embryos occupy similar regions in the map, while the cells from the 64 cell state are developed further.

Troubleshooting
===============

There are several properties of data that can yield subpar results. This section explains a few strategies of dealing with them:

**Preprocessing**: if there is a strong dependency of the variance on the mean in your data (as for scRNA-Seq count data),  use a variance stabilizing transformation such as the square root or a (regularized) logarithm before running **destiny**.

**Outliers**: If a Diffusion Component strongly separates some outliers from the remaining cells such that there is a much greater distance between them than within the rest of the cells (i. e. almost two discrete values), consider removing those outliers and recalculating the map, or simply select different Diffusion Components. It may also a be a good idea to check whether the outliers are also present in a PCA plot to make sure they are not biologically relevant.

**Large datasets**: If memory is not sufficient and no machine with more RAM is available, the `k` parameter could be decreased. In addition (particularly for >500,000 cells), you can also downsample the data (possibly in a density dependent fashion).

**“Large-p-small-n” data**: E.g. for scRNA-Seq, it is may be necessary to first perform a Principal Component Analysis (PCA) on the data (e.g. using `prcomp` or `princomp`) and to calculate the Diffusion Components from the Principal Components (typically using the top 50 components yields good results).

References
==========

<div id="refs"></div>

---
title: Reproduce the Diffusion Map vignette with the supplied data()
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Reproduce the Diffusion Map vignette with the supplied data()}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

Quickstart
==========

A short version to achive the above is by using the preprocessed version of the dataset provided with this package. `data(guo)` is already preprocessed (using the method first mentioned), has its threshold set to a constant 15 and is ready to use. Since the platform’s maximum amplification cycles are 40, that number can be used as upper border of the uncertainty range.

```{r}
library(destiny)
data(guo)
```

It can be used directly for diffusion map creation:

```{r}
dm_guo <- DiffusionMap(guo, verbose = FALSE,
                       censor_val = 15, censor_range = c(15, 40))
dm_guo
```

```{r}
plot(dm_guo)
```

using the annotation shows that the approximation worked

```{r}
palette(cube_helix(6))
plot(dm_guo, col_by = 'num_cells',
     legend_main = 'Cell stage')
```

References
==========

<div id="refs"></div>

---
title: tidyverse and ggplot integration with destiny
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{tidyverse and ggplot integration with destiny}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

Interaction with the tidyverse and ggplot2
==========================================

The [tidyverse](https://www.tidyverse.org/), [ggplot2](http://ggplot2.tidyverse.org/), and destiny are a great fit!

```{r}
suppressPackageStartupMessages({
    library(destiny)
    library(tidyverse)
    library(forcats)  # not in the default tidyverse loadout
})
```

ggplot has a peculiar method to set default scales: You just have to define certain variables.

```{r}
scale_colour_continuous <- scale_color_viridis_c
```

When working mainly with dimension reductions, I suggest to hide the (useless) ticks:

```{r}
theme_set(theme_gray() + theme(
    axis.ticks = element_blank(),
    axis.text  = element_blank()))
```

Let’s load our dataset

```{r}
data(guo_norm)
```

Of course you could use <code>[tidyr](http://tidyr.tidyverse.org/)::[gather()](https://rdrr.io/cran/tidyr/man/gather.html)</code> to tidy or transform the data now, but the data is already in the right form for destiny, and [R for Data Science](http://r4ds.had.co.nz/tidy-data.html) is a better resource for it than this vignette. The long form of a single cell `ExpressionSet` would look like:

```{r}
guo_norm %>%
    as('data.frame') %>%
    gather(Gene, Expression, one_of(featureNames(guo_norm)))
```

But destiny doesn’t use long form data as input, since all single cell data has always a more compact structure of genes×cells, with a certain number of per-sample covariates (The structure of `ExpressionSet`).

```{r}
dm <- DiffusionMap(guo_norm)
```

`names(dm)` shows what names can be used in `dm$<name>`, `as.data.frame(dm)$<name>`, or `ggplot(dm, aes(<name>))`:

```{r}
names(dm)  # namely: Diffusion Components, Genes, and Covariates
```

Due to the `fortify` method (which here just means `as.data.frame`) being defined on `DiffusionMap` objects, `ggplot` directly accepts `DiffusionMap` objects:

```{r}
ggplot(dm, aes(DC1, DC2, colour = Klf2)) +
    geom_point()
```

When you want to use a Diffusion Map in a dplyr pipeline, you need to call `fortify`/`as.data.frame` directly:

```{r}
fortify(dm) %>%
    mutate(
        EmbryoState = factor(num_cells) %>%
            lvls_revalue(paste(levels(.), 'cell state'))
    ) %>%
    ggplot(aes(DC1, DC2, colour = EmbryoState)) +
        geom_point()
```

The Diffusion Components of a converted Diffusion Map, similar to the genes in the input `ExpressionSet`, are individual variables instead of two columns in a long-form data frame, but sometimes it can be useful to “tidy” them:

```{r}
fortify(dm) %>%
    gather(DC, OtherDC, num_range('DC', 2:5)) %>%
    ggplot(aes(DC1, OtherDC, colour = factor(num_cells))) +
        geom_point() +
        facet_wrap(~ DC)
```

Another tip: To reduce overplotting, use `sample_frac(., 1.0, replace = FALSE)` (the default) in a pipeline.

Adding a constant `alpha` improves this even more, and also helps you see density:

```{r}
fortify(dm) %>%
    sample_frac() %>%
    ggplot(aes(DC1, DC2, colour = factor(num_cells))) +
        geom_point(alpha = .3)
```

---
title: tidyverse and ggplot integration with destiny
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{tidyverse and ggplot integration with destiny}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(fig.width=6, fig.asp=0.7)
```

```{r, include=FALSE}
library(repr)
library(knitr)
registerS3method("knit_print", "data.frame", function(df, ...) {
  if (is_latex_output()) asis_output(repr::repr_latex(df))
  else if (is_html_output()) asis_output(repr::repr_html(df))
  else repr::repr_text(df)
})
```

Interaction with the tidyverse and ggplot2
==========================================

The [tidyverse](https://www.tidyverse.org/), [ggplot2](http://ggplot2.tidyverse.org/), and destiny are a great fit!

```{r}
suppressPackageStartupMessages({
    library(destiny)
    library(tidyverse)
    library(forcats)  # not in the default tidyverse loadout
})
```

ggplot has a peculiar method to set default scales: You just have to define certain variables.

```{r}
scale_colour_continuous <- scale_color_viridis_c
```

When working mainly with dimension reductions, I suggest to hide the (useless) ticks:

```{r}
theme_set(theme_gray() + theme(
    axis.ticks = element_blank(),
    axis.text  = element_blank()))
```

Let’s load our dataset

```{r}
data(guo_norm)
```

Of course you could use <code>[tidyr](http://tidyr.tidyverse.org/)::[gather()](https://rdrr.io/cran/tidyr/man/gather.html)</code> to tidy or transform the data now, but the data is already in the right form for destiny, and [R for Data Science](http://r4ds.had.co.nz/tidy-data.html) is a better resource for it than this vignette. The long form of a single cell `ExpressionSet` would look like:

```{r}
guo_norm %>%
    as('data.frame') %>%
    gather(Gene, Expression, one_of(featureNames(guo_norm)))
```

But destiny doesn’t use long form data as input, since all single cell data has always a more compact structure of genes×cells, with a certain number of per-sample covariates (The structure of `ExpressionSet`).

```{r}
dm <- DiffusionMap(guo_norm)
```

`names(dm)` shows what names can be used in `dm$<name>`, `as.data.frame(dm)$<name>`, or `ggplot(dm, aes(<name>))`:

```{r}
names(dm)  # namely: Diffusion Components, Genes, and Covariates
```

Due to the `fortify` method (which here just means `as.data.frame`) being defined on `DiffusionMap` objects, `ggplot` directly accepts `DiffusionMap` objects:

```{r}
ggplot(dm, aes(DC1, DC2, colour = Klf2)) +
    geom_point()
```

When you want to use a Diffusion Map in a dplyr pipeline, you need to call `fortify`/`as.data.frame` directly:

```{r}
fortify(dm) %>%
    mutate(
        EmbryoState = factor(num_cells) %>%
            lvls_revalue(paste(levels(.), 'cell state'))
    ) %>%
    ggplot(aes(DC1, DC2, colour = EmbryoState)) +
        geom_point()
```

The Diffusion Components of a converted Diffusion Map, similar to the genes in the input `ExpressionSet`, are individual variables instead of two columns in a long-form data frame, but sometimes it can be useful to “tidy” them:

```{r}
fortify(dm) %>%
    gather(DC, OtherDC, num_range('DC', 2:5)) %>%
    ggplot(aes(DC1, OtherDC, colour = factor(num_cells))) +
        geom_point() +
        facet_wrap(~ DC)
```

Another tip: To reduce overplotting, use `sample_frac(., 1.0, replace = FALSE)` (the default) in a pipeline.

Adding a constant `alpha` improves this even more, and also helps you see density:

```{r}
fortify(dm) %>%
    sample_frac() %>%
    ggplot(aes(DC1, DC2, colour = factor(num_cells))) +
        geom_point(alpha = .3)
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/expressionset-helpers.r
\name{ExpressionSet helper methods}
\alias{ExpressionSet helper methods}
\alias{as.ExpressionSet}
\alias{as.ExpressionSet,data.frame-method}
\alias{read.ExpressionSet}
\title{Convert object to \link[Biobase:class.ExpressionSet]{ExpressionSet} or read it from a file}
\usage{
as.ExpressionSet(x, ...)

\S4method{as.ExpressionSet}{data.frame}(x, annotation_cols = !sapply(x, is.double))

read.ExpressionSet(file, header = TRUE, ...)
}
\arguments{
\item{x}{\link[base]{data.frame} to convert to an \link[Biobase:class.ExpressionSet]{ExpressionSet}.}

\item{...}{Additional parameters to \link[utils]{read.table}}

\item{annotation_cols}{The data.frame columns used as annotations. All others are used as expressions. (Logical, character or numerical index array)}

\item{file}{File path to read ASCII data from}

\item{header}{Specifies if the file has a header row.}
}
\value{
an \link[Biobase:class.ExpressionSet]{ExpressionSet} object
}
\description{
These functions present quick way to create \link[Biobase:class.ExpressionSet]{ExpressionSet} objects.
}
\details{
They work by using all continuous (double) columns as expression data, and all others as observation annotations.
}
\examples{
library(Biobase)
df <- data.frame(Time  = seq_len(3), #integer column
                 Actb  = c(0.05, 0.3, 0.8),
                 Gapdh = c(0.2, 0.03, 0.1))
set <- as.ExpressionSet(df)
rownames(exprs(set)) == c('Actb', 'Gapdh')
phenoData(set)$Time == 1:3

}
\seealso{
\link[utils]{read.table} on which \code{read.ExpressionSet} is based, and \link[Biobase:class.ExpressionSet]{ExpressionSet}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gene-relevance-plotting-differential-map.r,
%   R/gene-relevance-plotting-gr-map.r, R/gene-relevance-plotting-rank.r,
%   R/gene-relevance-plotting.r
\name{plot_differential_map}
\alias{plot_differential_map}
\alias{plot_differential_map,matrix,matrix-method}
\alias{plot_differential_map,DiffusionMap,missing-method}
\alias{plot_differential_map,GeneRelevance,missing-method}
\alias{plot_gene_relevance}
\alias{plot_gene_relevance,matrix,matrix-method}
\alias{plot_gene_relevance,DiffusionMap,missing-method}
\alias{plot_gene_relevance,GeneRelevance,missing-method}
\alias{plot_gene_relevance_rank}
\alias{plot_gene_relevance_rank,matrix,matrix-method}
\alias{plot_gene_relevance_rank,DiffusionMap,missing-method}
\alias{plot_gene_relevance_rank,GeneRelevance,missing-method}
\alias{Gene Relevance plotting}
\alias{plot,GeneRelevance,character-method}
\alias{plot,GeneRelevance,numeric-method}
\alias{plot,GeneRelevance,missing-method}
\title{Plot gene relevance or differential map}
\usage{
plot_differential_map(
  coords,
  exprs,
  ...,
  genes,
  dims = 1:2,
  pal = hcl.colors,
  faceter = facet_wrap(~Gene)
)

\S4method{plot_differential_map}{matrix,matrix}(
  coords,
  exprs,
  ...,
  genes,
  dims = 1:2,
  pal = hcl.colors,
  faceter = facet_wrap(~Gene)
)

\S4method{plot_differential_map}{DiffusionMap,missing}(
  coords,
  exprs,
  ...,
  genes,
  dims = 1:2,
  pal = hcl.colors,
  faceter = facet_wrap(~Gene)
)

\S4method{plot_differential_map}{GeneRelevance,missing}(
  coords,
  exprs,
  ...,
  genes,
  dims = 1:2,
  pal = hcl.colors,
  faceter = facet_wrap(~Gene)
)

plot_gene_relevance(
  coords,
  exprs,
  ...,
  iter_smooth = 2L,
  n_top = 10L,
  genes = NULL,
  dims = 1:2,
  pal = palette(),
  col_na = "grey",
  limit = TRUE
)

\S4method{plot_gene_relevance}{matrix,matrix}(
  coords,
  exprs,
  ...,
  iter_smooth = 2L,
  n_top = 10L,
  genes = NULL,
  dims = 1:2,
  pal = palette(),
  col_na = "grey",
  limit = TRUE
)

\S4method{plot_gene_relevance}{DiffusionMap,missing}(
  coords,
  exprs,
  ...,
  iter_smooth = 2L,
  n_top = 10L,
  genes = NULL,
  dims = 1:2,
  pal = palette(),
  col_na = "grey",
  limit = TRUE
)

\S4method{plot_gene_relevance}{GeneRelevance,missing}(
  coords,
  exprs,
  ...,
  iter_smooth = 2L,
  n_top = 10L,
  genes = NULL,
  dims = 1:2,
  pal = palette(),
  col_na = "grey",
  limit = TRUE
)

plot_gene_relevance_rank(
  coords,
  exprs,
  ...,
  genes,
  dims = 1:2,
  n_top = 10L,
  pal = c("#3B99B1", "#F5191C"),
  bins = 10L,
  faceter = facet_wrap(~Gene)
)

\S4method{plot_gene_relevance_rank}{matrix,matrix}(
  coords,
  exprs,
  ...,
  genes,
  dims = 1:2,
  n_top = 10L,
  pal = c("#3B99B1", "#F5191C"),
  bins = 10L,
  faceter = facet_wrap(~Gene)
)

\S4method{plot_gene_relevance_rank}{DiffusionMap,missing}(
  coords,
  exprs,
  ...,
  genes,
  dims = 1:2,
  n_top = 10L,
  pal = c("#3B99B1", "#F5191C"),
  bins = 10L,
  faceter = facet_wrap(~Gene)
)

\S4method{plot_gene_relevance_rank}{GeneRelevance,missing}(
  coords,
  exprs,
  ...,
  genes,
  dims = 1:2,
  n_top = 10L,
  pal = c("#3B99B1", "#F5191C"),
  bins = 10L,
  faceter = facet_wrap(~Gene)
)

\S4method{plot}{GeneRelevance,character}(x, y, ...)

\S4method{plot}{GeneRelevance,numeric}(x, y, ...)

\S4method{plot}{GeneRelevance,missing}(x, y, ...)
}
\arguments{
\item{coords}{A \code{\link{DiffusionMap}}/\code{\link[=gene_relevance]{GeneRelevance}} object or a cells \eqn{\times} dims \code{\link{matrix}}.}

\item{exprs}{An cells \eqn{\times} genes \code{\link{matrix}}. Only provide if \code{coords} is a matrix.}

\item{...}{Passed to \code{plot_differential_map}/\code{plot_gene_relevance}.}

\item{genes}{Genes to base relevance map on (vector of strings).
You can also pass an index into the gene names (vector of numbers or logicals with length > 1).
The default NULL means all genes.}

\item{dims}{Names or indices of dimensions to plot. When not plotting a \code{\link[=gene_relevance]{GeneRelevance}} object, the relevance for the dimensions \code{1:max(dims)} will be calculated.}

\item{pal}{Palette. Either A colormap function or a list of colors.}

\item{faceter}{A ggplot faceter like \code{\link[ggplot2]{facet_wrap}(~ Gene)}.}

\item{iter_smooth}{Number of label smoothing iterations to perform on relevance map.
The higher the more homogenous and the less local structure.}

\item{n_top}{Number the top n genes per cell count towards the score defining which genes to return and plot in the relevance map.}

\item{col_na}{Color for cells that end up with no most relevant gene.}

\item{limit}{Limit the amount of displayed gene labels to the amount of available colors in \code{pal}?}

\item{bins}{Number of hexagonal bins for \code{plot_gene_relevance_rank}.}

\item{x}{\code{\link[=gene_relevance]{GeneRelevance}} object.}

\item{y}{Gene name(s) or index/indices to create differential map for. (integer or character)}
}
\value{
ggplot2 plot, when plotting a relevance map with a list member \code{$ids} containing the gene IDs used.
}
\description{
\code{plot(gene_relevance, 'Gene')} plots the differential map of this/these gene(s),
\code{plot(gene_relevance)} a relevance map of a selection of genes.
Alternatively, you can use \code{plot_differential_map} or \code{plot_gene_relevance} on a \code{\link[=gene_relevance]{GeneRelevance}} or \code{\link{DiffusionMap}} object, or with two matrices.
}
\examples{
data(guo_norm)
dm <- DiffusionMap(guo_norm)
gr <- gene_relevance(dm)
plot(gr)          # or plot_gene_relevance(dm)
plot(gr, 'Fgf4')  # or plot_differential_map(dm, 'Fgf4')

guo_norm_mat <- t(Biobase::exprs(guo_norm))
pca <- prcomp(guo_norm_mat)$x
plot_gene_relevance(pca, guo_norm_mat, dims = 2:3)
plot_differential_map(pca, guo_norm_mat, genes = c('Fgf4', 'Nanog'))

}
\seealso{
\code{\link{gene_relevance}}, \link{Gene Relevance methods}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diffusionmap-plotting.r
\name{plot.DiffusionMap}
\alias{plot.DiffusionMap}
\alias{plot,DiffusionMap,numeric-method}
\alias{plot,DiffusionMap,missing-method}
\title{3D or 2D plot of diffusion map}
\usage{
plot.DiffusionMap(
  x,
  dims = 1:3,
  new_dcs = if (!is.null(new_data)) dm_predict(x, new_data),
  new_data = NULL,
  col = NULL,
  col_by = NULL,
  col_limits = NULL,
  col_new = "red",
  pal = NULL,
  pal_new = NULL,
  ...,
  ticks = FALSE,
  axes = TRUE,
  box = FALSE,
  legend_main = col_by,
  legend_opts = list(),
  interactive = FALSE,
  draw_legend = !is.null(col_by) || (length(col) > 1 && !is.character(col)),
  consec_col = TRUE,
  col_na = "grey",
  plot_more = function(p, ..., rescale = NULL) p
)

\S4method{plot}{DiffusionMap,numeric}(x, y, ...)

\S4method{plot}{DiffusionMap,missing}(x, y, ...)
}
\arguments{
\item{x}{A \link{DiffusionMap}}

\item{dims, y}{Diffusion components (eigenvectors) to plot (default: first three components; 1:3)}

\item{new_dcs}{An optional matrix also containing the rows specified with \code{y} and plotted. (default: no more points)}

\item{new_data}{A data set in the same format as \code{x} that is used to create \code{new_dcs <- \link{dm_predict}(dif, new_data)}}

\item{col}{Single color string or vector of discrete or categoric values to be mapped to colors.
E.g. a column of the data matrix used for creation of the diffusion map. (default: \code{\link[igraph]{cluster_louvain}} if igraph is installed)}

\item{col_by}{Specify a \code{dataset(x)} or \code{phenoData(dataset(x))} column to use as color}

\item{col_limits}{If \code{col} is a continuous (=double) vector, this can be overridden to map the color range differently than from min to max (e.g. specify \code{c(0, 1)})}

\item{col_new}{If \code{new_dcs} is given, it will take on this color. A vector is also possible. (default: red)}

\item{pal}{Palette used to map the \code{col} vector to colors. (default: use \code{\link{hcl.colors}} for continuous and \code{\link{palette}()} for discrete data)}

\item{pal_new}{Palette used to map the \code{col_new} vector to colors. (default: see \code{pal} argument)}

\item{...}{Parameters passed to \link{plot}, \link[scatterplot3d]{scatterplot3d}, or \link[rgl]{plot3d} (if \code{interactive == TRUE})}

\item{ticks}{logical. If TRUE, show axis ticks (default: FALSE)}

\item{axes}{logical. If TRUE, draw plot axes (default: Only if \code{ticks} is TRUE)}

\item{box}{logical. If TRUE, draw plot frame (default: TRUE or the same as \code{axes} if specified)}

\item{legend_main}{Title of legend. (default: nothing unless \code{col_by} is given)}

\item{legend_opts}{Other \link{colorlegend} options (default: empty list)}

\item{interactive}{Use \link[rgl]{plot3d} to plot instead of \link[scatterplot3d]{scatterplot3d}?}

\item{draw_legend}{logical. If TRUE, draw color legend (default: TRUE if \code{col_by} is given or \code{col} is given and a vector to be mapped)}

\item{consec_col}{If \code{col} or \code{col_by} refers to an integer column, with gaps (e.g. \code{c(5,0,0,3)}) use the palette color consecutively (e.g. \code{c(3,1,1,2)})}

\item{col_na}{Color for \code{NA} in the data. specify \code{NA} to hide.}

\item{plot_more}{Function that will be called while the plot margins are temporarily changed
(its \code{p} argument is the rgl or scatterplot3d instance or NULL,
its \code{rescale} argument is \code{NULL}, a \code{list(from = c(a, b), to = c(c, d))}),
or an array of shape \eqn{from|to \times dims \times min|max}, i.e. \eqn{2 \times length(dims) \times 2}.
In case of 2d plotting, it should take and return a ggplot2 object.}
}
\value{
The return value of the underlying call is returned, i.e. a scatterplot3d or rgl object.
}
\description{
If you want to plot the eigenvalues, simply \code{plot(eigenvalues(dm)[start:end], ...)}
}
\details{
If you specify negative numbers as diffusion components (e.g. \code{plot(dm, c(-1,2))}), then the corresponding components will be flipped.
}
\examples{
data(guo)
plot(DiffusionMap(guo))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methods-coercion.r
\name{Coercion methods}
\alias{Coercion methods}
\alias{as.data.frame.DiffusionMap}
\alias{fortify.DiffusionMap}
\alias{as.data.frame.DPT}
\alias{fortify.DPT}
\alias{as.matrix.DPT}
\alias{as.data.frame,DiffusionMap-method}
\alias{as.data.frame,DPT-method}
\alias{as.matrix,DPT-method}
\title{Coercion methods}
\usage{
\S4method{as.data.frame}{DiffusionMap}(x, row.names = NULL, optional = FALSE, ...)

fortify.DiffusionMap(model, data, ...)

\S4method{as.data.frame}{DPT}(x, row.names = NULL, optional = FALSE, ...)

fortify.DPT(model, data, ...)

\S4method{as.matrix}{DPT}(x, ...)
}
\arguments{
\item{x, model}{A \code{\link{DiffusionMap}} or \code{\link{DPT}} object}

\item{row.names}{NULL or a character vector giving the row names for the data frame. Missing values are not allowed.}

\item{optional}{logical. If TRUE, setting row names and converting column names (to syntactic names: see make.names) is optional.}

\item{...}{Passed to \code{\link[base]{as.data.frame}}}

\item{data}{ignored}
}
\value{
An object of the desired class
}
\description{
Convert a \code{\link{DiffusionMap}} or \code{\link{DPT}} object to other classes
}
\details{
\link[ggplot2]{fortify} is a ggplot2 generic allowing a diffusion map to be used as \code{data} parameter in \link[ggplot2]{ggplot} or \link[ggplot2]{qplot}.
}
\examples{
library(Biobase)
data(guo)
dm <- DiffusionMap(guo)
classes <- vapply(as.data.frame(dm), class, character(1L))
stopifnot(all(classes[paste0('DC', 1:20)] == 'numeric'))
stopifnot(all(classes[featureNames(guo) ] == 'numeric'))
stopifnot(all(classes[   varLabels(guo) ] == c('factor', 'integer')))

}
\seealso{
\link{DiffusionMap accession methods}, \link{Extraction methods}, \link{DiffusionMap methods} for more
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dpt-methods.r
\name{DPT methods}
\alias{DPT methods}
\alias{dataset.DPT}
\alias{branch_divide}
\alias{tips}
\alias{dataset,DPT-method}
\alias{dataset<-,DPT-method}
\title{DPT methods}
\usage{
branch_divide(dpt, divide = integer(0L))

tips(dpt)

\S4method{dataset}{DPT}(object)

\S4method{dataset}{DPT}(object) <- value
}
\arguments{
\item{dpt, object}{DPT object}

\item{divide}{Vector of branch numbers to use for division}

\item{value}{Value of slot to set}
}
\value{
\code{branch_divide} and \code{dataset<-} return the changed object, \code{dataset} the extracted data, and \code{tips} the tip indices.
}
\description{
Methods for the \link{DPT} class. \code{branch_divide} subdivides branches for plotting (see the examples).
}
\examples{
data(guo_norm)
dpt <- DPT(DiffusionMap(guo_norm))
dpt_9_branches <- branch_divide(dpt, 1:3)
plot(dpt_9_branches, col_by = 'branch')

}
\seealso{
\link{plot.DPT} uses \code{branch_divide} for its \code{divide} argument.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/l_which.r
\name{l_which}
\alias{l_which}
\title{Logical which}
\usage{
l_which(idx, nms = seq_len(len), len = length(nms), useNames = TRUE)
}
\arguments{
\item{idx}{Numeric or character indices.}

\item{nms}{Array of names or a sequence. Required if \code{idx} is a character array}

\item{len}{Length of output array. Alternative to \code{nms} if \code{idx} is numeric}

\item{useNames}{Use the names of nms or idx}
}
\value{
Logical vector of length \code{len} or the same length as \code{nms}
}
\description{
Inverse of \link[base]{which}. Converts an array of numeric or character indices to a logical index array.
This function is useful if you need to perform logical operation on an index array but are only given numeric indices.
}
\details{
Either \code{nms} or \code{len} has to be specified.
}
\examples{
all(l_which(2, len = 3L) == c(FALSE, TRUE, FALSE))
all(l_which(c('a', 'c'), letters[1:3]) == c(TRUE, FALSE, TRUE))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cube_helix.r
\name{cube_helix}
\alias{cube_helix}
\alias{scale_colour_cube_helix}
\alias{scale_color_cube_helix}
\alias{scale_fill_cube_helix}
\title{Sequential color palette using the cube helix system}
\usage{
cube_helix(
  n = 6,
  start = 0,
  r = 0.4,
  hue = 0.8,
  gamma = 1,
  light = 0.85,
  dark = 0.15,
  reverse = FALSE
)

scale_colour_cube_helix(
  ...,
  start = 0,
  r = 0.4,
  hue = 0.8,
  gamma = 1,
  light = 0.85,
  dark = 0.15,
  reverse = FALSE,
  discrete = TRUE,
  guide = if (discrete) "legend" else "colourbar"
)

scale_color_cube_helix(
  ...,
  start = 0,
  r = 0.4,
  hue = 0.8,
  gamma = 1,
  light = 0.85,
  dark = 0.15,
  reverse = FALSE,
  discrete = TRUE,
  guide = if (discrete) "legend" else "colourbar"
)

scale_fill_cube_helix(
  ...,
  start = 0,
  r = 0.4,
  hue = 0.8,
  gamma = 1,
  light = 0.85,
  dark = 0.15,
  reverse = FALSE,
  discrete = TRUE,
  guide = if (discrete) "legend" else "colourbar"
)
}
\arguments{
\item{n}{Number of colors to return (default: 6)}

\item{start}{Hue to start helix at (\eqn{\textrm{start} \in [0,3]}, default: 0)}

\item{r}{Number of rotations of the helix. Can be negative. (default: 0.4)}

\item{hue}{Saturation. 0 means greyscale, 1 fully saturated colors (default: 0.8)}

\item{gamma}{Emphasize darker (gamma < 1) or lighter (gamma > 1) colors (default: 1)}

\item{light}{Lightest lightness (default: 0.85)}

\item{dark}{Darkest lightness (default: 0.15)}

\item{reverse}{logical. If TRUE, reverse lightness (default: FALSE)}

\item{...}{parameters passed to \code{\link[ggplot2]{discrete_scale}} or \code{\link[ggplot2]{continuous_scale}}}

\item{discrete}{If TRUE, return a discrete scale, if FALSE a continuous one (default: TRUE)}

\item{guide}{Type of scale guide to use. See \code{\link[ggplot2]{guides}}}
}
\value{
A \code{character} vector of hex colors with length \code{n}
}
\description{
Creates a perceptually monotonously decreasing (or increasing) lightness color palette with different tones.
This was necessary in pre-viridis times, by now you can probably just use \code{\link[grDevices]{hcl.colors}}
}
\examples{
palette(cube_helix())
image(matrix(1:6), col = 1:6, pch = 19, axes = FALSE)

cr <- scales::colour_ramp(cube_helix(12, r = 3))
r <- runif(100)
plot(1:100, r, col = cr(r), type = 'b', pch = 20)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/guo-data.r
\docType{data}
\name{guo}
\alias{guo}
\alias{data:guo}
\alias{data:guo_norm}
\alias{guo_norm}
\title{Guo at al. mouse embryonic stem cell qPCR data}
\format{
An \link[Biobase:class.ExpressionSet]{ExpressionSet} with 48 features, 428 observations and 2 \link[Biobase]{phenoData} annotations.
}
\usage{
data(guo)
data(guo_norm)
}
\value{
an \link[Biobase:class.ExpressionSet]{ExpressionSet} with 48 features and 428 observations containing qPCR Ct values and a "num.cells" observation annotation.
}
\description{
Gene expression data of 48 genes and an annotation column \code{$num_cells} containing the cell stage at which the embryos were harvested.
}
\details{
The data is normalized using the mean of two housekeeping genes.
The difference between \code{guo} and \code{guo_norm} is the LoD being set to 10 in the former, making it usable with the \code{censor_val} parameter of \link{DiffusionMap}.
}
\references{
\url{http://www.sciencedirect.com/science/article/pii/S1534580710001103}
}
\author{
Guoji Guo, Mikael Huss, Guo Qing Tong, Chaoyang Wang, Li Li Sun, Neil D. Clarke, Paul Robson \email{robsonp@gis.a-star.edu.sg}
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sigmas.r
\docType{class}
\name{Sigmas-class}
\alias{Sigmas-class}
\alias{Sigmas}
\alias{Sigmas-methods}
\alias{optimal_sigma,Sigmas-method}
\alias{print,Sigmas-method}
\alias{show,Sigmas-method}
\title{Sigmas Object}
\usage{
Sigmas(...)

\S4method{optimal_sigma}{Sigmas}(object)

\S4method{print}{Sigmas}(x)

\S4method{show}{Sigmas}(object)
}
\arguments{
\item{object, x}{\link{Sigmas} object}

\item{...}{See \dQuote{\strong{Slots}} below}
}
\value{
\code{Sigmas} creates an object of the same class

\code{optimal_sigma} retrieves the numeric value of the optimal sigma or local sigmas
}
\description{
Holds the information about how the \code{sigma} parameter for a \link{DiffusionMap} was obtained,
and in this way provides a plotting function for the \link{find_sigmas} heuristic.
You should not need to create a Sigmas object yourself. Provide \code{sigma} to \link{DiffusionMap} instead or use \link{find_sigmas}.
}
\details{
A Sigmas object is either created by \link{find_sigmas} or by specifying the \code{sigma} parameter to \link{DiffusionMap}.

In the second case, if the \code{sigma} parameter is just a number,
the resulting \code{Sigmas} object has all slots except of \code{optimal_sigma} set to \code{NULL}.
}
\section{Slots}{

\describe{
\item{\code{log_sigmas}}{Vector of length \eqn{m} containing the \eqn{\log_{10}} of the \eqn{\sigma}s}

\item{\code{dim_norms}}{Vector of length \eqn{m-1} containing the average dimensionality \eqn{\langle p \rangle} for the respective kernel widths}

\item{\code{optimal_sigma}}{Multiple local sigmas or the mean of the two global \eqn{\sigma}s around the highest \eqn{\langle p \rangle} (\code{c(optimal_idx, optimal_idx+1L)})}

\item{\code{optimal_idx}}{The index of the highest \eqn{\langle p \rangle}.}

\item{\code{avrd_norms}}{Vector of length \eqn{m} containing the average dimensionality for the corresponding sigma.}
}}

\examples{
data(guo)
sigs <- find_sigmas(guo, verbose = FALSE)
optimal_sigma(sigs)
print(sigs)

}
\seealso{
\code{\link{find_sigmas}}, the function to determine a locally optimal sigma and returning this class
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dpt.r
\docType{class}
\name{DPT-class}
\alias{DPT-class}
\alias{DPT}
\title{Diffusion Pseudo Time}
\usage{
DPT(dm, tips = random_root(dm), ..., w_width = 0.1)
}
\arguments{
\item{dm}{A \code{\link{DiffusionMap}} object. Its transition probabilities will be used to calculate the DPT}

\item{tips}{The cell index/indices from which to calculate the DPT(s) (integer of length 1-3)}

\item{...}{Unused. All parameters to the right of the \code{...} have to be specified by name (e.g. \code{DPT(dm, w_width = 0.2)})}

\item{w_width}{Window width to use for deciding the branch cutoff}
}
\value{
A \code{DPT} object:
}
\description{
Create pseudotime ordering and assigns cell to one of three branches
}
\details{
Treat it as a matrix of pseudotime by subsetting (\code{\link[=dim.DPT]{[ dim nrow ncol}} \code{\link[=as.matrix.DPT]{as.matrix}}), and as a list of pseudodime, and expression vectors (\code{\link[=names.DPT]{$ [[ names}} \code{\link[=as.data.frame.DPT]{as.data.frame}}).
}
\section{Slots}{

\describe{
\item{\code{branch}}{\code{\link[base]{matrix}} (of \code{\link[base]{integer}}) recursive branch labels for each cell (row); \code{NA} for undeceided. Use \code{\link{branch_divide}} to modify this.}

\item{\code{tips}}{\code{\link[base]{matrix}} (of \code{\link[base]{logical}}) indicating if a cell (row) is a tip of the corresponding banch level (col)}

\item{\code{dm}}{\code{\link{DiffusionMap}} used to create this DPT object}
}}

\examples{
data(guo_norm)
dm <- DiffusionMap(guo_norm)
dpt <- DPT(dm)
str(dpt)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diffusionmap-methods.r
\name{DiffusionMap methods}
\alias{DiffusionMap methods}
\alias{print.DiffusionMap}
\alias{show.DiffusionMap}
\alias{print,DiffusionMap-method}
\alias{show,DiffusionMap-method}
\title{DiffusionMap methods}
\usage{
\S4method{print}{DiffusionMap}(x)

\S4method{show}{DiffusionMap}(object)
}
\arguments{
\item{x, object}{A \code{\link{DiffusionMap}}}
}
\value{
The \code{DiffusionMap} object (\code{print}), or NULL (\code{show}), invisibly
}
\description{
Methods for external operations on diffusion maps
}
\examples{
data(guo)
dm <- DiffusionMap(guo)
print(dm)
show(dm)

}
\seealso{
\link{DiffusionMap accession methods}, \link{Extraction methods}, \link{Coercion methods} for more
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sigmas-plotting.r
\name{plot.Sigmas}
\alias{plot.Sigmas}
\alias{plot,Sigmas,missing-method}
\title{Plot \link{Sigmas} object}
\usage{
\S4method{plot}{Sigmas,missing}(
  x,
  col = par("fg"),
  col_highlight = "#E41A1C",
  col_line = "#999999",
  type = c("b", "b"),
  pch = c(par("pch"), 4L),
  only_dim = FALSE,
  ...,
  xlab = NULL,
  ylab = NULL,
  main = ""
)
}
\arguments{
\item{x}{Sigmas object to plot}

\item{col}{Vector of bar colors or single color for all bars}

\item{col_highlight}{Color for highest bar. Overrides col}

\item{col_line}{Color for the line and its axis}

\item{type}{Plot type of both lines. Can be a vector of length 2 to specify both separately (default: 'b' aka \dQuote{both lines and points})}

\item{pch}{Point identifier for both lines. Can be a vector of length 2 to specify both separately (default: \code{par(pch)} and 4 (a \sQuote{\eqn{\times}}))}

\item{only_dim}{logical. If TRUE, only plot the derivative line}

\item{...}{Options passed to the call to plot}

\item{xlab}{X label. NULL to use default}

\item{ylab}{Either one y label or y labels for both plots. NULL to use both defauts, a NULL in a list of length 2 to use one default.}

\item{main}{Title of the plot}
}
\value{
This method plots a Sigma object to the current device and returns nothing/NULL
}
\description{
Plot \link{Sigmas} object
}
\examples{
data(guo)
sigs <- find_sigmas(guo)
plot(sigs)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dpt-methods-matrix.r
\name{DPT matrix methods}
\alias{DPT matrix methods}
\alias{[.DPT}
\alias{nrow.DPT}
\alias{ncol.DPT}
\alias{dim.DPT}
\alias{[,DPT,index,index,logicalOrMissing-method}
\alias{[,DPT,index,missing,logicalOrMissing-method}
\alias{[,DPT,missing,index,logicalOrMissing-method}
\alias{[,DPT,missing,missing,logicalOrMissing-method}
\alias{[[,DPT,index,index-method}
\alias{nrow,DPT-method}
\alias{ncol,DPT-method}
\alias{dim,DPT-method}
\title{DPT Matrix methods}
\usage{
\S4method{[}{DPT,index,index,logicalOrMissing}(x, i, j, ..., drop = TRUE)

\S4method{[}{DPT,index,missing,logicalOrMissing}(x, i, j, ..., drop = TRUE)

\S4method{[}{DPT,missing,index,logicalOrMissing}(x, i, j, ..., drop = TRUE)

\S4method{[}{DPT,missing,missing,logicalOrMissing}(x, i, j, ..., drop = TRUE)

\S4method{[[}{DPT,index,index}(x, i, j, ...)

\S4method{nrow}{DPT}(x)

\S4method{ncol}{DPT}(x)

\S4method{dim}{DPT}(x)
}
\arguments{
\item{x}{\code{\link{DPT}} object.}

\item{i, j}{\link[=numeric]{Numeric} or \link{logical} index.}

\item{...}{ignored}

\item{drop}{If \code{\link{TRUE}}, coerce result to a vector if it would otherwise have \code{1 \%in\% dim(result)}.}
}
\value{
\code{[} returns a dense matrix or (if applicable and \code{isTRUE(drop)}) a vector.

\code{[[} returns single distance value

\code{nrow} and \code{ncol} return the number of cells

\code{dim} returns \code{c(n_cells, n_cells)}
}
\description{
Treat DPT object as a matrix of cell-by-cell DPT distances.
}
\examples{
data(guo_norm)
dm <- DiffusionMap(guo_norm)
dpt <- DPT(dm)
set.seed(1)
plot(dpt[random_root(dpt), ], Biobase::exprs(guo_norm)['DppaI', ])

}
\seealso{
\code{\link{as.matrix.DPT}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/predict.r
\name{dm_predict}
\alias{dm_predict}
\title{Predict new data points using an existing DiffusionMap. The resulting matrix can be used in \link[=plot.DiffusionMap]{the plot method for the DiffusionMap}}
\usage{
dm_predict(dm, new_data, ..., verbose = FALSE)
}
\arguments{
\item{dm}{A \code{\link{DiffusionMap}} object.}

\item{new_data}{New data points to project into the diffusion map.
Can be a \link[base]{matrix}, \link[base]{data.frame},
\link[Biobase:class.ExpressionSet]{ExpressionSet},
or \link[SingleCellExperiment]{SingleCellExperiment}.}

\item{...}{Passed to \code{\link[proxy:dist]{proxy::dist}(new_data, data, dm@distance, ...)}.}

\item{verbose}{Show progress messages?}
}
\value{
A \eqn{nrow(new\_data) \times ncol(eigenvectors(dif))} matrix of projected diffusion components for the new data.
}
\description{
Predict new data points using an existing DiffusionMap. The resulting matrix can be used in \link[=plot.DiffusionMap]{the plot method for the DiffusionMap}
}
\examples{
data(guo)
g1 <- guo[, guo$num_cells != 32L]
g2 <- guo[, guo$num_cells == 32L]
dm <- DiffusionMap(g1)
dc2 <- dm_predict(dm, g2)
plot(dm, new_dcs = dc2)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/find_dm_k.r
\name{find_dm_k}
\alias{find_dm_k}
\title{Find a suitable k}
\usage{
find_dm_k(n, min_k = 100L, small = 1000L, big = 10000L)
}
\arguments{
\item{n}{Number of possible neighbors (nrow(dataset) - 1)}

\item{min_k}{Minimum number of neighbors. Will be chosen for \eqn{n \ge big}}

\item{small}{Number of neighbors considered small. If/where \eqn{n \le small}, n itself will be returned.}

\item{big}{Number of neighbors considered big. If/where \eqn{n \ge big}, \code{min_k} will be returned.}
}
\value{
A vector of the same length as \code{n} that contains suitable \code{k} values for the respective \code{n}
}
\description{
The \code{k} parameter for the k nearest neighbors used in \link{DiffusionMap} should be as big as possible while
still being computationally feasible. This function approximates it depending on the size of the dataset \code{n}.
}
\examples{
curve(find_dm_k(n),     0, 13000, xname = 'n')
curve(find_dm_k(n) / n, 0, 13000, xname = 'n')
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/eig_decomp.r
\name{eig_decomp}
\alias{eig_decomp}
\title{Fast eigen decomposition using \code{\link[RSpectra]{eigs}}}
\usage{
eig_decomp(m, n_eigs, sym, ..., opts = list())
}
\arguments{
\item{m}{A matrix (e.g. from the Matrix package) or
a function (see \code{\link[RSpectra]{eigs}}).}

\item{n_eigs}{Number of eigenvectors to return.}

\item{sym}{defunct and ignored.}

\item{...}{Passed to \code{\link[RSpectra]{eigs}}.}

\item{opts}{Passed to \code{\link[RSpectra]{eigs}}.}
}
\value{
see \code{\link[RSpectra]{eigs}}.
}
\description{
By default uses a random initialization vector that you can make deterministic using
\code{\link[base]{set.seed}} or override by specifying \code{opts = list(initvec = ...)}.
}
\examples{
eig_decomp(cbind(c(1,0,-1), c(0,1,0), c(-1,0,1)), 2)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/projection-dist.r
\name{projection_dist}
\alias{projection_dist}
\title{Projection distance}
\usage{
projection_dist(dm, new_dcs = NULL, ..., new_data, verbose = FALSE)
}
\arguments{
\item{dm}{A \code{\link{DiffusionMap}} object.}

\item{new_dcs}{Diffusion component matrix of which to calculate the distance to the data.}

\item{...}{Passed to \code{\link[proxy:dist]{proxy::dist}} if \code{new_data} was passed.}

\item{new_data}{New data points to project into the diffusion map.
Can be a \link[base]{matrix}, \link[base]{data.frame},
\link[Biobase:class.ExpressionSet]{ExpressionSet},
or \link[SingleCellExperiment]{SingleCellExperiment}.}

\item{verbose}{If \code{\link{TRUE}}, log additional info to the console.}
}
\value{
A vector of distances each new data point has to the existing data.
}
\description{
Projection distance
}
\examples{
data(guo_norm)
g2_32 <- guo_norm[, guo_norm$num_cells < 64]
g64  <- guo_norm[, guo_norm$num_cells == 64]
dm <- DiffusionMap(g2_32)
d <- projection_dist(dm, new_data = g64)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sigmas.r
\name{find_sigmas}
\alias{find_sigmas}
\title{Calculate the average dimensionality for m different gaussian kernel widths (\eqn{\sigma}).}
\usage{
find_sigmas(
  data,
  step_size = 0.1,
  steps = 10L,
  start = NULL,
  sample_rows = 500L,
  early_exit = FALSE,
  ...,
  censor_val = NULL,
  censor_range = NULL,
  missing_range = NULL,
  vars = NULL,
  verbose = TRUE
)
}
\arguments{
\item{data}{Data set with \eqn{n} observations. Can be a \link[base]{data.frame},
\link[base]{matrix}, \link[Biobase:class.ExpressionSet]{ExpressionSet}
or \link[SingleCellExperiment]{SingleCellExperiment}.}

\item{step_size}{Size of log-sigma steps}

\item{steps}{Number of steps/calculations}

\item{start}{Initial value to search from. (Optional. default: \eqn{\log_{10}(min(dist(data)))})}

\item{sample_rows}{Number of random rows to use for sigma estimation or vector of row indices/names to use.
In the first case, only used if actually smaller than the number of available rows (Optional. default: 500)}

\item{early_exit}{logical. If TRUE, return if the first local maximum is found, else keep running}

\item{...}{Unused. All parameters to the right of the \code{...} have to be specified by name (e.g. \code{find_sigmas(data, verbose = FALSE)})}

\item{censor_val}{Value regarded as uncertain. Either a single value or one for every dimension}

\item{censor_range}{Uncertainity range for censoring. A length-2-vector of certainty range start and end. TODO: also allow \eqn{2\times G} matrix}

\item{missing_range}{Whole data range for missing value model. Has to be specified if NAs are in the data}

\item{vars}{Variables (columns) of the data to use. Specifying TRUE will select all columns (default: All floating point value columns)}

\item{verbose}{logical. If TRUE, show a progress bar and plot the output}
}
\value{
Object of class \link{Sigmas}
}
\description{
The sigma with the maximum value in average dimensionality is close to the ideal one.
Increasing step number gets this nearer to the ideal one.
}
\examples{
data(guo)
sigs <- find_sigmas(guo, verbose = TRUE)
DiffusionMap(guo, sigs)

}
\seealso{
\code{\link{Sigmas}}, the class returned by this; \code{\link{DiffusionMap}}, the class this is used for
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gene-relevance.r
\docType{class}
\name{GeneRelevance-class}
\alias{GeneRelevance-class}
\alias{gene_relevance}
\alias{gene_relevance,DiffusionMap,missing-method}
\alias{gene_relevance,matrix,dMatrixOrMatrix-method}
\title{Gene relevances for entire data set}
\usage{
gene_relevance(
  coords,
  exprs,
  ...,
  k = 20L,
  dims = 1:2,
  distance = NULL,
  smooth = TRUE,
  remove_outliers = FALSE,
  verbose = FALSE
)

\S4method{gene_relevance}{DiffusionMap,missing}(
  coords,
  exprs,
  ...,
  k = 20L,
  dims = 1:2,
  distance = NULL,
  smooth = TRUE,
  remove_outliers = FALSE,
  verbose = FALSE
)

\S4method{gene_relevance}{matrix,dMatrixOrMatrix}(
  coords,
  exprs,
  ...,
  pcs = NULL,
  knn_params = list(),
  weights = 1,
  k,
  dims,
  distance,
  smooth,
  remove_outliers,
  verbose
)
}
\arguments{
\item{coords}{A \code{\link{DiffusionMap}} object or a cells \eqn{\times} dims \code{\link{matrix}}.}

\item{exprs}{An cells \eqn{\times} genes \code{\link{matrix}}. Only provide if \code{coords} is no \code{\link{DiffusionMap}}.}

\item{...}{Unused. All parameters to the right of the \code{...} have to be specified by name.}

\item{k}{Number of nearest neighbors to use}

\item{dims}{Index into columns of \code{coord}}

\item{distance}{Distance measure to use for the nearest neighbor search.}

\item{smooth}{Smoothing parameters \code{c(window, alpha)}.
Alternatively \code{\link{TRUE}} to use the defaults
or \code{\link{FALSE}} to skip smoothing,}

\item{remove_outliers}{Remove cells that are only within one other cell's nearest neighbor, as they tend to get large norms.}

\item{verbose}{If TRUE, log additional info to the console}

\item{pcs}{A cell \eqn{\times} \code{n_pcs} matrix of principal components to use for the distances.}

\item{knn_params}{A \code{\link{list}} of parameters for \code{\link{find_knn}}.}

\item{weights}{Weights for the partial derivatives. A vector of the same length as \code{dims}.}
}
\value{
A \code{GeneRelevance} object:
}
\description{
The relevance map is cached inside of the \code{\link{DiffusionMap}}.
}
\section{Slots}{

\describe{
\item{\code{coords}}{A cells \eqn{\times} dims \code{\link{matrix}} or \code{\link[Matrix:sparseMatrix-class]{sparseMatrix}}
of coordinates (e.g. diffusion components), reduced to the dimensions passed as \code{dims}}

\item{\code{exprs}}{A cells \eqn{\times} genes matrix of expressions}

\item{\code{partials}}{Array of partial derivatives wrt to considered dimensions in reduced space
(genes \eqn{\times} cells \eqn{\times} dimensions)}

\item{\code{partials_norm}}{Matrix with norm of aforementioned derivatives. (n\_genes \eqn{\times} cells)}

\item{\code{nn_index}}{Matrix of k nearest neighbor indices. (cells \eqn{\times} k)}

\item{\code{dims}}{Column index for plotted dimensions. Can \code{\link{character}}, \code{\link{numeric}} or \code{\link{logical}}}

\item{\code{distance}}{Distance measure used in the nearest neighbor search. See \code{\link{find_knn}}}

\item{\code{smooth_window}}{Smoothing window used}

\item{\code{smooth_alpha}}{Smoothing kernel width used}
}}

\examples{
data(guo_norm)
dm <- DiffusionMap(guo_norm)
gr <- gene_relevance(dm)

m <- t(Biobase::exprs(guo_norm))
gr_pca <- gene_relevance(prcomp(m)$x, m)
# now plot them!

}
\seealso{
\link{Gene Relevance methods}, \link{Gene Relevance plotting}: \code{plot_differential_map}/\code{plot_gene_relevance}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dpt-helpers.r
\name{find_tips}
\alias{find_tips}
\title{Find tips in a DiffusionMap object}
\usage{
find_tips(dm_or_dpt, root = random_root(dm_or_dpt))
}
\arguments{
\item{dm_or_dpt}{A \code{\link{DiffusionMap}} or \code{\link{DPT}} object}

\item{root}{Root cell index from which to find tips. (default: random)}
}
\value{
An integer vector of length 3
}
\description{
Find tips in a DiffusionMap object
}
\examples{
data(guo)
dm <- DiffusionMap(guo)
is_tip <- l_which(find_tips(dm), len = ncol(guo))
plot(dm, col = factor(is_tip))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/knn.r
\name{find_knn}
\alias{find_knn}
\title{kNN search}
\usage{
find_knn(
  data,
  k,
  ...,
  query = NULL,
  distance = c("euclidean", "cosine", "rankcor", "l2"),
  method = c("covertree", "hnsw"),
  sym = TRUE,
  verbose = FALSE
)
}
\arguments{
\item{data}{Data matrix}

\item{k}{Number of nearest neighbors}

\item{...}{Parameters passed to \code{\link[RcppHNSW]{hnsw_knn}}}

\item{query}{Query matrix. Leave it out to use \code{data} as query}

\item{distance}{Distance metric to use. Allowed measures: Euclidean distance (default), cosine distance (\eqn{1-corr(c_1, c_2)}) or rank correlation distance (\eqn{1-corr(rank(c_1), rank(c_2))})}

\item{method}{Method to use. \code{'hnsw'} is tunable with \code{...} but generally less exact than \code{'covertree'} (default: 'covertree')}

\item{sym}{Return a symmetric matrix (as long as query is NULL)?}

\item{verbose}{Show a progressbar? (default: FALSE)}
}
\value{
A \code{\link{list}} with the entries:
\describe{
  \item{\code{index}}{A \eqn{nrow(data) \times k} \link{integer} \link{matrix} containing the indices of the k nearest neighbors for each cell.}
  \item{\code{dist}}{A \eqn{nrow(data) \times k} \link{double} \link{matrix} containing the distances to the k nearest neighbors for each cell.}
  \item{\code{dist_mat}}{
    A \code{\link[Matrix:dgCMatrix-class]{dgCMatrix}} if \code{sym == TRUE},
    else a \code{\link[Matrix:dsCMatrix-class]{dsCMatrix}} (\eqn{nrow(query) \times nrow(data)}).
    Any zero in the matrix (except for the diagonal) indicates that the cells in the corresponding pair are close neighbors.
  }
}
}
\description{
Approximate k nearest neighbor search with flexible distance function.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gene-relevance-methods.r
\name{Gene Relevance methods}
\alias{Gene Relevance methods}
\alias{featureNames.GeneRelevance}
\alias{dataset.GeneRelevance}
\alias{print,GeneRelevance-method}
\alias{show,GeneRelevance-method}
\alias{featureNames,GeneRelevance-method}
\alias{featureNames<-,GeneRelevance,characterOrFactor-method}
\alias{dataset,GeneRelevance-method}
\alias{dataset<-,GeneRelevance-method}
\alias{distance,GeneRelevance-method}
\alias{distance<-,GeneRelevance-method}
\title{Gene Relevance methods}
\usage{
\S4method{print}{GeneRelevance}(x)

\S4method{show}{GeneRelevance}(object)

\S4method{featureNames}{GeneRelevance}(object)

\S4method{featureNames}{GeneRelevance,characterOrFactor}(object) <- value

\S4method{dataset}{GeneRelevance}(object)

\S4method{dataset}{GeneRelevance}(object) <- value

\S4method{distance}{GeneRelevance}(object)

\S4method{distance}{GeneRelevance}(object) <- value
}
\arguments{
\item{x, object}{\code{GeneRelevance} object}

\item{value}{A text vector (\code{\link{character}} or \code{\link{factor}})}
}
\value{
\code{dataset}, \code{distance}, and \code{featureNames} return the stored properties.
The other methods return a \code{GeneRelevance} object (\code{print}, \code{... <- ...}),
or NULL (\code{show}), invisibly
}
\description{
\code{featureNames <- ...} can be used to set the gene names used for plotting
(e.g. if the data contains hardly readably gene or transcript IDs).
\code{dataset} gets the expressions used for the gene relevance calculations,
and \code{distance} the distance measure.
}
\examples{
data(guo_norm)
dm <- DiffusionMap(guo_norm)
gr <- gene_relevance(dm)
stopifnot(distance(gr) == distance(dm))
featureNames(gr)[[37]] <- 'Id2 (suppresses differentiation)'
# now plot it with the changed gene name(s)

}
\seealso{
\code{\link{gene_relevance}}, \link{Gene Relevance plotting}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/colorlegend.r
\name{colorlegend}
\alias{colorlegend}
\title{Color legend}
\usage{
colorlegend(
  col,
  pal = palette(),
  log = FALSE,
  posx = c(0.9, 0.93),
  posy = c(0.05, 0.9),
  main = NULL,
  cex_main = par("cex.sub"),
  cex_axis = par("cex.axis"),
  col_main = par("col.sub"),
  col_lab = par("col.lab"),
  steps = 5,
  steps_color = 100,
  digit = 2,
  left = FALSE,
  ...,
  cex.main = NULL,
  cex.axis = NULL,
  col.main = NULL,
  col.lab = NULL
)
}
\arguments{
\item{col}{Vector of factor, integer, or double used to determine the ticks.}

\item{pal}{If \code{col} is double, pal is used as a continuous palette, else as categorical one}

\item{log}{Use logarithmic scale?}

\item{posx}{Left and right borders of the color bar relative to plot area (Vector of length 2; 0-1)}

\item{posy}{Bottom and top borders of color bar relative to plot area (Vector of length 2; 0-1)}

\item{main}{Legend title}

\item{cex_main}{Size of legend title font (default: subtitle font size \code{\link{par}('cex.sub')})}

\item{cex_axis}{Size of ticks/category labels (default: axis font size \code{\link{par}('cex.axis')})}

\item{col_main}{Color of legend title (default: subtitle color \code{\link{par}('col.sub')})}

\item{col_lab}{Color of tick or category labels (default: axis color \code{\link{par}('col.lab')})}

\item{steps}{Number of labels in case of a continuous axis. If 0 or FALSE, draw no ticks}

\item{steps_color}{Number of gradient samples in case of continuous axis}

\item{digit}{Number of digits for continuous axis labels}

\item{left}{logical. If TRUE, invert posx}

\item{...}{Additional parameters for the \link[graphics]{text} call used for labels}

\item{cex.main, cex.axis, col.main, col.lab}{For compatibility with \code{\link{par}}}
}
\value{
This function is called for the side effect of adding a colorbar to a plot and returns nothing/NULL.
}
\description{
Creates a color legend for a vector used to color a plot. It will use the current \code{\link[grDevices]{palette}()} or the specified \code{pal} as reference.
}
\details{
When passed a factor or integer vector, it will create a discrete legend, whereas a double vector will result in a continuous bar.
}
\examples{
color_data <- 1:6
par(mar = par('mar') + c(0, 0, 0, 3))
plot(sample(6), col = color_data)
colorlegend(color_data)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dpt-helpers.r
\name{random_root}
\alias{random_root}
\title{Find a random root cell index}
\usage{
random_root(dm_or_dpt)
}
\arguments{
\item{dm_or_dpt}{A \code{\link{DiffusionMap}} or \code{\link{DPT}} object}
}
\value{
A cell index
}
\description{
Finds a cell that has the maximum DPT distance from a randomly selected one.
}
\examples{
data(guo)
dm <- DiffusionMap(guo)
random_root(dm)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dpt-plotting.r
\name{plot.DPT}
\alias{plot.DPT}
\alias{plot,DPT,numeric-method}
\alias{plot,DPT,missing-method}
\title{Plot DPT}
\usage{
plot.DPT(
  x,
  root = NULL,
  paths_to = integer(0L),
  dcs = 1:2,
  divide = integer(0L),
  w_width = 0.1,
  col_by = "dpt",
  col_path = rev(palette()),
  col_tip = "red",
  ...,
  col = NULL,
  legend_main = col_by
)

\S4method{plot}{DPT,numeric}(x, y, ...)

\S4method{plot}{DPT,missing}(x, y, ...)
}
\arguments{
\item{x}{A \code{\link{DPT}} object.}

\item{paths_to}{Numeric Branch IDs. Are used as target(s) for the path(s) to draw.}

\item{dcs}{The dimensions to use from the DiffusionMap}

\item{divide}{If \code{col_by = 'branch'}, this specifies which branches to divide. (see \code{\link{branch_divide}})}

\item{w_width}{Window width for smoothing the path}

\item{col_by}{Color by 'dpt' (DPT starting at \code{branches[[1]]}), 'branch', or a veriable of the data.}

\item{col_path}{Colors for the path or a function creating n colors}

\item{col_tip}{Color for branch tips}

\item{...}{Graphical parameters supplied to \code{\link{plot.DiffusionMap}}}

\item{col}{See \code{\link{plot.DiffusionMap}}. This overrides \code{col_by}}

\item{legend_main}{See \code{\link{plot.DiffusionMap}}.}

\item{y, root}{Root branch ID. Will be used as the start of the DPT. (default: lowest branch ID)
(If longer than size 1, will be interpreted as \code{c(root, branches)})}
}
\value{
The return value of the underlying call is returned, i.e. a scatterplot3d or rgl object for 3D plots.
}
\description{
Plots diffusion components from a Diffusion Map and the accompanying Diffusion Pseudo Time (\code{\link{DPT}})
}
\examples{
data(guo_norm)
dm <- DiffusionMap(guo_norm)
dpt <- DPT(dm)
plot(dpt)
plot(dpt, 2L,      col_by = 'branch')
plot(dpt, 1L, 2:3, col_by = 'num_cells')
plot(dpt, col_by = 'DPT3')

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methods-extraction.r
\name{Extraction methods}
\alias{Extraction methods}
\alias{names.DPT}
\alias{names.DiffusionMap}
\alias{[[.DPT}
\alias{[[.DiffusionMap}
\alias{$.DPT}
\alias{$.DiffusionMap}
\alias{names,DiffusionMap-method}
\alias{names,DPT-method}
\alias{[[,DiffusionMap,character,missing-method}
\alias{[[,DPT,character,missing-method}
\alias{$,DiffusionMap-method}
\alias{$,DPT-method}
\title{Extraction methods}
\usage{
\S4method{names}{DiffusionMap}(x)

\S4method{names}{DPT}(x)

\S4method{[[}{DiffusionMap,character,missing}(x, i, j, ...)

\S4method{[[}{DPT,character,missing}(x, i, j, ...)

\S4method{$}{DiffusionMap}(x, name)

\S4method{$}{DPT}(x, name)
}
\arguments{
\item{x}{\code{\link{DiffusionMap}} or \code{\link{DPT}}  object}

\item{i, name}{Name of a diffusion component \code{'DCx'}, \code{'DPTx'}, \code{'Branch'} or column from the data}

\item{j}{N/A}

\item{...}{ignored}
}
\value{
The names or data row, see respective generics.
}
\description{
Extract common information from objects.
Apart from the input data's branches,
you can extract diffusion components via \code{$DCx}.
From \code{\link{DPT}} objects, you can also extract the branch label via \code{$Branch},
or the diffusion pseudo time for a numbered cell via \code{$DPTx}.
}
\examples{
data(guo)
dm <- DiffusionMap(guo)
dm$DC1        # A diffusion component
dm$Actb       # A gene expression vector
dm$num_cells  # Phenotype metadata

dpt <- DPT(dm)
dm$Branch
dm$DPT1

}
\seealso{
\link[base]{Extract}, \code{\link[base]{names}} for the generics. \link{DiffusionMap accession methods}, \link{DiffusionMap methods}, \link{Coercion methods} for more
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methods-update.r
\name{updateObject methods}
\alias{updateObject methods}
\alias{updateObject.DiffusionMap}
\alias{updateObject.Sigmas}
\alias{updateObject.GeneRelevance}
\alias{updateObject,DiffusionMap-method}
\alias{updateObject,Sigmas-method}
\alias{updateObject,GeneRelevance-method}
\title{Update old destiny objects to a newer version.}
\usage{
\S4method{updateObject}{DiffusionMap}(object, ..., verbose = FALSE)

\S4method{updateObject}{Sigmas}(object, ..., verbose = FALSE)

\S4method{updateObject}{GeneRelevance}(object, ..., verbose = FALSE)
}
\arguments{
\item{object}{An object created with an older destiny release}

\item{...}{ignored}

\item{verbose}{tells what is being updated}
}
\value{
A \link{DiffusionMap} or \link{Sigmas} object that is valid when used with the current destiny release
}
\description{
Handles \link{DiffusionMap}, \link{Sigmas}, and \link[=gene_relevance]{GeneRelevance}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/destiny-package.r
\docType{package}
\name{destiny}
\alias{destiny-package}
\alias{destiny}
\title{Create and plot diffusion maps}
\description{
The main function is \code{\link{DiffusionMap}}, which returns an object you can \code{\link{plot}} (\code{\link{plot.DiffusionMap}} is then called).
}
\examples{
demo(destiny, ask = FALSE)

}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/theislab/destiny/}
  \item \url{https://bioconductor.org/packages/destiny}
  \item \doi{10.1093/bioinformatics/btv715}
  \item Report bugs at \url{https://github.com/theislab/destiny/issues}
}

}
\author{
\strong{Maintainer}: Philipp Angerer \email{phil.angerer@gmail.com} (\href{https://orcid.org/0000-0002-0369-2888}{ORCID})

Other contributors:
\itemize{
  \item Laleh Haghverdi \email{laleh.haghverdi@helmholtz-muenchen.de} [contributor]
  \item Maren Büttner \email{maren.buettner@helmholtz-muenchen.de} (\href{https://orcid.org/0000-0002-6189-3792}{ORCID}) [contributor]
  \item Fabian Theis \email{fabian.theis@helmholtz-muenchen.de} (\href{https://orcid.org/0000-0002-2419-1943}{ORCID}) [contributor]
  \item Carsten Marr \email{carsten.marr@helmholtz-muenchen.de} (\href{https://orcid.org/0000-0003-2154-4552}{ORCID}) [contributor]
  \item Florian Büttner \email{f.buettner@helmholtz-muenchen.de} (\href{https://orcid.org/0000-0001-5587-6761}{ORCID}) [contributor]
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diffusionmap.r
\docType{class}
\name{DiffusionMap-class}
\alias{DiffusionMap-class}
\alias{DiffusionMap}
\title{Create a diffusion map of cells}
\usage{
DiffusionMap(
  data = stopifnot_distmatrix(distance),
  sigma = "local",
  k = find_dm_k(dataset_n_observations(data, distance) - 1L),
  n_eigs = min(20L, dataset_n_observations(data, distance) - 2L),
  density_norm = TRUE,
  ...,
  distance = c("euclidean", "cosine", "rankcor", "l2"),
  n_pcs = NULL,
  n_local = seq(to = min(k, 7L), length.out = min(k, 3L)),
  rotate = FALSE,
  censor_val = NULL,
  censor_range = NULL,
  missing_range = NULL,
  vars = NULL,
  knn_params = list(),
  verbose = !is.null(censor_range),
  suppress_dpt = FALSE
)
}
\arguments{
\item{data}{Expression data to be analyzed and covariates. Provide \code{vars} to select specific columns other than the default: all double value columns.
If \code{distance} is a distance matrix, \code{data} has to be a \code{\link{data.frame}} with covariates only.}

\item{sigma}{Diffusion scale parameter of the Gaussian kernel. One of \code{'local'}, \code{'global'}, a (\link[base]{numeric}) global sigma or a \link{Sigmas} object.
When choosing \code{'global'}, a global sigma will be calculated using \code{\link{find_sigmas}}. (Optional. default: \code{'local'})
A larger sigma might be necessary if the eigenvalues can not be found because of a singularity in the matrix}

\item{k}{Number of nearest neighbors to consider (default: a guess betweeen 100 and \eqn{n - 1}. See \code{\link{find_dm_k}}).}

\item{n_eigs}{Number of eigenvectors/values to return (default: 20)}

\item{density_norm}{logical. If TRUE, use density normalisation}

\item{...}{Unused. All parameters to the right of the \code{...} have to be specified by name (e.g. \code{DiffusionMap(data, distance = 'cosine')})}

\item{distance}{Distance measurement method applied to \code{data} or a distance matrix/\code{\link[stats]{dist}}. For the allowed values, see \code{\link{find_knn}}.
If this is a \code{\link[Matrix]{sparseMatrix}}, zeros are interpreted as "not a close neighbors",
which allows the use of kNN-sparsified matrices (see the return value of \code{\link{find_knn}}.}

\item{n_pcs}{Number of principal components to compute to base calculations on. Using e.g. 50 DCs results in more regular looking diffusion maps.
The default NULL will not compute principal components, but use \code{reducedDims(data, 'pca')} if present. Set to NA to suppress using PCs.}

\item{n_local}{If \code{sigma == 'local'}, the \code{n_local}th nearest neighbor(s) determine(s) the local sigma}

\item{rotate}{logical. If TRUE, rotate the eigenvalues to get a slimmer diffusion map}

\item{censor_val}{Value regarded as uncertain. Either a single value or one for every dimension (Optional, default: censor_val)}

\item{censor_range}{Uncertainity range for censoring (Optional, default: none). A length-2-vector of certainty range start and end. TODO: also allow \eqn{2\times G} matrix}

\item{missing_range}{Whole data range for missing value model. Has to be specified if NAs are in the data}

\item{vars}{Variables (columns) of the data to use. Specifying NULL will select all columns (default: All floating point value columns)}

\item{knn_params}{Parameters passed to \code{\link{find_knn}}}

\item{verbose}{Show a progressbar and other progress information (default: do it if censoring is enabled)}

\item{suppress_dpt}{Specify TRUE to skip calculation of necessary (but spacious) information for \code{\link{DPT}} in the returned object (default: FALSE)}
}
\value{
A DiffusionMap object:
}
\description{
The provided data can be a double \link[base]{matrix} of expression data or a \link[base]{data.frame} with all non-integer (double) columns
being treated as expression data features (and the others ignored), an \link[Biobase:class.ExpressionSet]{ExpressionSet}, or a \link[SingleCellExperiment]{SingleCellExperiment}.
}
\section{Slots}{

\describe{
\item{\code{eigenvalues}}{Eigenvalues ranking the eigenvectors}

\item{\code{eigenvectors}}{Eigenvectors mapping the datapoints to \code{n_eigs} dimensions}

\item{\code{sigmas}}{\link{Sigmas} object with either information about the \link{find_sigmas} heuristic run or just local or \link{optimal_sigma}.}

\item{\code{data_env}}{Environment referencing the data used to create the diffusion map}

\item{\code{eigenvec0}}{First (constant) eigenvector not included as diffusion component.}

\item{\code{transitions}}{Transition probabilities. Can be NULL}

\item{\code{d}}{Density vector of transition probability matrix}

\item{\code{d_norm}}{Density vector of normalized transition probability matrix}

\item{\code{k}}{The k parameter for kNN}

\item{\code{n_pcs}}{Number of principal components used in kNN computation (NA if raw data was used)}

\item{\code{n_local}}{The \code{n_local}th nearest neighbor(s) is/are used to determine local kernel density}

\item{\code{density_norm}}{Was density normalization used?}

\item{\code{rotate}}{Were the eigenvectors rotated?}

\item{\code{distance}}{Distance measurement method used}

\item{\code{censor_val}}{Censoring value}

\item{\code{censor_range}}{Censoring range}

\item{\code{missing_range}}{Whole data range for missing value model}

\item{\code{vars}}{Vars parameter used to extract the part of the data used for diffusion map creation}

\item{\code{knn_params}}{Parameters passed to \code{\link{find_knn}}}
}}

\examples{
data(guo)
DiffusionMap(guo)
DiffusionMap(guo, 13, censor_val = 15, censor_range = c(15, 40), verbose = TRUE)

covars <- data.frame(covar1 = letters[1:100])
dists <- dist(matrix(rnorm(100*10), 100))
DiffusionMap(covars, distance = dists)

}
\seealso{
\link{DiffusionMap methods} to get and set the slots. \code{\link{find_sigmas}} to pre-calculate a fitting global \code{sigma} parameter
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diffusionmap-methods-accession.r
\name{DiffusionMap accession methods}
\alias{DiffusionMap accession methods}
\alias{eigenvalues,DiffusionMap-method}
\alias{eigenvalues<-,DiffusionMap-method}
\alias{eigenvectors,DiffusionMap-method}
\alias{eigenvectors<-,DiffusionMap-method}
\alias{sigmas,DiffusionMap-method}
\alias{sigmas<-,DiffusionMap-method}
\alias{dataset,DiffusionMap-method}
\alias{dataset<-,DiffusionMap-method}
\alias{distance,DiffusionMap-method}
\alias{distance<-,DiffusionMap-method}
\alias{optimal_sigma,DiffusionMap-method}
\title{DiffusionMap accession methods}
\usage{
\S4method{eigenvalues}{DiffusionMap}(object)

\S4method{eigenvalues}{DiffusionMap}(object) <- value

\S4method{eigenvectors}{DiffusionMap}(object)

\S4method{eigenvectors}{DiffusionMap}(object) <- value

\S4method{sigmas}{DiffusionMap}(object)

\S4method{sigmas}{DiffusionMap}(object) <- value

\S4method{dataset}{DiffusionMap}(object)

\S4method{dataset}{DiffusionMap}(object) <- value

\S4method{distance}{DiffusionMap}(object)

\S4method{distance}{DiffusionMap}(object) <- value

\S4method{optimal_sigma}{DiffusionMap}(object)
}
\arguments{
\item{object}{A DiffusionMap}

\item{value}{Vector of eigenvalues or matrix of eigenvectors to get/set}
}
\value{
The assigned or retrieved value
}
\description{
Get and set eigenvalues, eigenvectors, and sigma(s) of a \link{DiffusionMap} object.
}
\examples{
data(guo)
dm <- DiffusionMap(guo)
eigenvalues(dm)
eigenvectors(dm)
sigmas(dm)
dataset(dm)
optimal_sigma(dm)

}
\seealso{
\link{Extraction methods}, \link{DiffusionMap methods}, \link{Coercion methods} for more
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/accessor-generics.r
\name{destiny generics}
\alias{destiny generics}
\alias{eigenvalues}
\alias{eigenvalues<-}
\alias{eigenvectors}
\alias{eigenvectors<-}
\alias{sigmas}
\alias{sigmas<-}
\alias{dataset}
\alias{dataset<-}
\alias{distance}
\alias{distance<-}
\alias{optimal_sigma}
\title{destiny generics}
\usage{
eigenvalues(object)

eigenvalues(object) <- value

eigenvectors(object)

eigenvectors(object) <- value

sigmas(object)

sigmas(object) <- value

dataset(object)

dataset(object) <- value

distance(object)

distance(object) <- value

optimal_sigma(object)
}
\arguments{
\item{object}{Object from which to extract or to which to assign a value}

\item{value}{Value to assign within an object}
}
\value{
\code{eigenvalues} retrieves the numeric eigenvalues

\code{eigenvectors} retrieves the eigenvectors matrix

\code{sigmas} retrieves the \code{\link{Sigmas}} from an object utilizing it as kernel width

\code{dataset} retrieves the data the object was created from

\code{distance} retrieves the distance metric used to create the object, e.g. \code{euclidean}

\code{optimal_sigma} retrieves the numeric value of the optimal sigma or local sigmas
}
\description{
destiny provides several generic methods and implements them for the \code{\link{DiffusionMap}} and \code{\link{Sigmas}} classes.
}
\examples{
data(guo_norm)
dm <- DiffusionMap(guo_norm)
eigenvalues(dm)
eigenvectors(dm)
sigmas(dm)
optimal_sigma(dm)
dataset(dm)
distance(dm)

}
\seealso{
\link{DiffusionMap methods} and \link{Sigmas} class for implementations
}
